Package: rsem
Type: Package
Title: Robust Structural Equation Modeling with Missing Data and
        Auxiliary Variables
Version: 0.5.1
Date: 2023-08-26
Author: Ke-Hai Yuan and Zhiyong Zhang
Maintainer: Zhiyong Zhang <zhiyongzhang@nd.edu>
Depends: R (>= 2.7), MASS, lavaan
Description: A robust procedure is implemented to estimate means and covariance matrix of multiple variables with missing data using Huber weight and then to estimate a structural equation model.
License: GPL-2
URL: https://bigdatalab.nd.edu
ZipData: no
LazyLoad: yes
NeedsCompilation: no
Repository: CRAN
Packaged: 2023-08-26 20:08:52 UTC; zzhang4
Date/Publication: 2023-08-26 20:40:02 UTC
Built: R 4.6.0; ; 2026-04-27 07:34:45 UTC; unix

Package: spp
Type: Package
Title: some description
Version: 1.0
Date: 2008-11-10
Author: Peter K
Depends: caTools
Maintainer: peterK<peterk@compbio.med.harvard.edu>
Description: Describe the package
License: GPL-2
LazyLoad: yes
Packaged: Wed Nov 12 10:42:54 2008; vidhuch

# Default NAMESPACE created by R
# Remove the previous line if you edit this file

# Export all names
exportPattern("rsem", "rsem.Ascov", "rsem.DP", "rsem.emmusig", "rsem.fit",
"rsem.gname", "rsem.pattern", "rsem.print", "rsem.se", "rsem.weight", "semdiag.call.eqs", "semdiag.run.eqs", "semdiag.combinations", "semdiag.read.eqs", "rsem.lavaan"
)

# Import all packages listed as Imports or Depends
import(
  lavaan,
  MASS
)

importFrom("stats", "na.omit", "pchisq", "pf", "pnorm", "qchisq")
importFrom("utils", "read.fwf", "write.table")

README for RSEM
===============

[Bo Li](https://lilab-bcb.github.io/) \(bli28 at mgh dot harvard dot edu\)

* * *

Table of Contents
-----------------

* [Introduction](#introduction)
* [Compilation & Installation](#compilation)
* [Usage](#usage)
    * [Build RSEM references using RefSeq, Ensembl, or GENCODE annotations](#built)
    * [Build RSEM references for untypical organisms](#untypical)
* [Example](#example-main)
* [Simulation](#simulation)
* [Generate Transcript-to-Gene-Map from Trinity Output](#gen_trinity)
* [Differential Expression Analysis](#de)
* [Prior-Enhanced RSEM (pRSEM)](#pRSEM)
* [Authors](#authors)
* [Acknowledgements](#acknowledgements)
* [License](#license)

* * *

## <a name="introduction"></a> Introduction

RSEM is a software package for estimating gene and isoform expression
levels from RNA-Seq data. The RSEM package provides an user-friendly
interface, supports threads for parallel computation of the EM
algorithm, single-end and paired-end read data, quality scores,
variable-length reads and RSPD estimation. In addition, it provides
posterior mean and 95% credibility interval estimates for expression
levels. For visualization, It can generate BAM and Wiggle files in
both transcript-coordinate and genomic-coordinate. Genomic-coordinate
files can be visualized by both UCSC Genome browser and Broad
Institute's Integrative Genomics Viewer (IGV). Transcript-coordinate
files can be visualized by IGV. RSEM also has its own scripts to
generate transcript read depth plots in pdf format. The unique feature
of RSEM is, the read depth plots can be stacked, with read depth
contributed to unique reads shown in black and contributed to
multi-reads shown in red. In addition, models learned from data can
also be visualized. Last but not least, RSEM contains a simulator.

## <a name="compilation"></a> Compilation & Installation

To compile RSEM, simply run
   
    make

For Cygwin users, run

    make cygwin=true

To compile EBSeq, which is included in the RSEM package, run

    make ebseq

To install RSEM, simply put the RSEM directory in your environment's PATH
variable. Alternatively, run

    make install

By default, RSEM executables are installed to `/usr/local/bin`. You
can change the installation location by setting `DESTDIR` and/or
`prefix` variables. The RSEM executables will be installed to
`${DESTDIR}${prefix}/bin`. The default values of `DESTDIR` and
`prefix` are `DESTDIR=` and `prefix=/usr/local`. For example,

    make install DESTDIR=/home/my_name prefix=/software

will install RSEM executables to `/home/my_name/software/bin`.

**Note** that `make install` does not install `EBSeq` related scripts,
such as `rsem-generate-ngvector`, `rsem-run-ebseq`, and
`rsem-control-fdr`. But `rsem-generate-data-matrix`, which generates
count matrix for differential expression analysis, is installed.

### Prerequisites

C++, Perl and R are required to be installed. 

To use the `--gff3` option of `rsem-prepare-reference`, Python is also
required to be installed.

To take advantage of RSEM's built-in support for the Bowtie/Bowtie
2/STAR/HISAT2 alignment program, you must have
[Bowtie](http://bowtie-bio.sourceforge.net)/[Bowtie2](http://bowtie-bio.sourceforge.net/bowtie2)/[STAR](https://github.com/alexdobin/STAR)/[HISAT2](https://ccb.jhu.edu/software/hisat2/manual.shtml)
installed.

## <a name="usage"></a> Usage

### I. Preparing Reference Sequences

RSEM can extract reference transcripts from a genome if you provide it
with gene annotations in a GTF/GFF3 file.  Alternatively, you can provide
RSEM with transcript sequences directly.

Please note that GTF files generated from the UCSC Table Browser do not
contain isoform-gene relationship information.  However, if you use the
UCSC Genes annotation track, this information can be recovered by
downloading the knownIsoforms.txt file for the appropriate genome.
 
To prepare the reference sequences, you should run the
`rsem-prepare-reference` program.  Run 

    rsem-prepare-reference --help

to get usage information or visit the [rsem-prepare-reference
documentation page](rsem-prepare-reference.html).

#### <a name="built"></a> Build RSEM references using RefSeq, Ensembl, or GENCODE annotations

RefSeq and Ensembl are two frequently used annotations. For human and
mouse, GENCODE annotaions are also available. In this section, we show
how to build RSEM references using these annotations. Note that it is
important to pair the genome with the annotation file for each
annotation source. In addition, we recommend users to use the primary
assemblies of genomes. Without loss of generality, we use human genome as
an example and in addition build Bowtie indices. 

For **RefSeq**, the genome and annotation file in GFF3 format can be found
at RefSeq genomes FTP:

```
ftp://ftp.ncbi.nlm.nih.gov/genomes/refseq/
```

For example, the human genome and GFF3 file locate at the subdirectory
`vertebrate_mammalian/Homo_sapiens/all_assembly_versions/GCF_000001405.31_GRCh38.p5`. `GCF_000001405.31_GRCh38.p5`
is the latest annotation version when this section was written.

Download and decompress the genome and annotation files to your working directory:

```
ftp://ftp.ncbi.nlm.nih.gov/genomes/refseq/vertebrate_mammalian/Homo_sapiens/all_assembly_versions/GCF_000001405.31_GRCh38.p5/GCF_000001405.31_GRCh38.p5_genomic.fna.gz
ftp://ftp.ncbi.nlm.nih.gov/genomes/refseq/vertebrate_mammalian/Homo_sapiens/all_assembly_versions/GCF_000001405.31_GRCh38.p5/GCF_000001405.31_GRCh38.p5_genomic.gff.gz
```

`GCF_000001405.31_GRCh38.p5_genomic.fna` contains all top level
sequences, including patches and haplotypes. To obtain the primary
assembly, run the following RSEM python script:

```
rsem-refseq-extract-primary-assembly GCF_000001405.31_GRCh38.p5_genomic.fna GCF_000001405.31_GRCh38.p5_genomic.primary_assembly.fna
```

Then type the following command to build RSEM references:

```
rsem-prepare-reference --gff3 GCF_000001405.31_GRCh38.p5_genomic.gff \
		       --trusted-sources BestRefSeq,Curated\ Genomic \
		       --bowtie \
		       GCF_000001405.31_GRCh38.p5_genomic.primary_assembly.fna \
		       ref/human_refseq
```

In the above command, `--trusted-sources` tells RSEM to only extract
transcripts from RefSeq sources like `BestRefSeq` or `Curated Genomic`. By
default, RSEM trust all sources. There is also an
`--gff3-RNA-patterns` option and its default is `mRNA`. Setting
`--gff3-RNA-patterns mRNA,rRNA` will allow RSEM to extract all mRNAs
and rRNAs from the genome. Visit [here](rsem-prepare-reference.html)
for more details.

Because the gene and transcript IDs (e.g. gene1000, rna28655)
extracted from RefSeq GFF3 files are hard to understand, it is
recommended to turn on the `--append-names` option in
`rsem-calculate-expression` for better interpretation of
quantification results.

For **Ensembl**, the genome and annotation files can be found at
[Ensembl FTP](http://uswest.ensembl.org/info/data/ftp/index.html).

Download and decompress the human genome and GTF files:

```
ftp://ftp.ensembl.org/pub/release-83/fasta/homo_sapiens/dna/Homo_sapiens.GRCh38.dna.primary_assembly.fa.gz
ftp://ftp.ensembl.org/pub/release-83/gtf/homo_sapiens/Homo_sapiens.GRCh38.83.gtf.gz
```

Then use the following command to build RSEM references:

```
rsem-prepare-reference --gtf Homo_sapiens.GRCh38.83.gtf \
		       --bowtie \
		       Homo_sapiens.GRCh38.dna.primary_assembly.fa \
		       ref/human_ensembl
```

If you want to use GFF3 file instead, which is unnecessary and not
recommended, you should add option `--gff3-RNA-patterns transcript`
because `mRNA` is replaced by `transcript` in Ensembl GFF3 files.

**GENCODE** only provides human and mouse annotations. The genome and
  annotation files can be found from [GENCODE
  website](http://www.gencodegenes.org/).

Download and decompress the human genome and GTF files:

```
ftp://ftp.sanger.ac.uk/pub/gencode/Gencode_human/release_24/GRCh38.primary_assembly.genome.fa.gz
ftp://ftp.sanger.ac.uk/pub/gencode/Gencode_human/release_24/gencode.v24.annotation.gtf.gz
```

Then type the following command:

```
rsem-prepare-reference --gtf gencode.v24.annotation.gtf \
		       --bowtie \
		       GRCh38.primary_assembly.genome.fa \
		       ref/human_gencode
```

Similar to Ensembl annotation, if you want to use GFF3 files (not
recommended), add option `--gff3-RNA-patterns transcript`.

#### <a name="untypical"></a> Build RSEM references for untypical organisms

For untypical organisms, such as viruses, you may only have a GFF3 file that containing only genes but not any transcripts. You need to turn on `--gff3-genes-as-transcripts` so that RSEM will make each gene as a unique transcript.

Here is an example command:

```
rsem-prepare-reference --gff3 virus.gff \
               --gff3-genes-as-transcripts \
               --bowtie \
               virus.genome.fa \
               ref/virus
```

### II. Calculating Expression Values

To calculate expression values, you should run the
`rsem-calculate-expression` program.  Run 

    rsem-calculate-expression --help

to get usage information or visit the [rsem-calculate-expression
documentation page](rsem-calculate-expression.html).

#### Calculating expression values from single-end data

For single-end models, users have the option of providing a fragment
length distribution via the `--fragment-length-mean` and
`--fragment-length-sd` options.  The specification of an accurate fragment
length distribution is important for the accuracy of expression level
estimates from single-end data.  If the fragment length mean and sd are
not provided, RSEM will not take a fragment length distribution into
consideration.

#### Using an alternative aligner

By default, RSEM automates the alignment of reads to reference
transcripts using the Bowtie aligner. Turn on `--bowtie2` for
`rsem-prepare-reference` and `rsem-calculate-expression` will allow
RSEM to use the Bowtie 2 alignment program instead. Please note that
indel alignments, local alignments and discordant alignments are
disallowed when RSEM uses Bowtie 2 since RSEM currently cannot handle
them. See the description of `--bowtie2` option in
`rsem-calculate-expression` for more details. Similarly, turn on
`--star` will allow RSEM to use the STAR aligner. Turn on `--hisat2-hca`
will allow RSEM to use the HISAT2 aligner according to Human Cell
Atals SMART-Seq2 pipeline. To use an alternative alignment program,
align the input reads against the file
`reference_name.idx.fa` generated by `rsem-prepare-reference`, and
format the alignment output in SAM/BAM/CRAM format.  Then, instead of
providing reads to `rsem-calculate-expression`, specify the
`--alignments` option and provide the SAM/BAM/CRAM file as an
argument.

RSEM requires the alignments of a read to be adjacent. For paired-end
reads, RSEM also requires the two mates of any alignment be
adjacent. To check if your SAM/BAM/CRAM file satisfy the requirements,
run

    rsem-sam-validator <input.sam/input.bam/input.cram>

If your file does not satisfy the requirements, you can use
`convert-sam-for-rsem` to convert it into a BAM file which RSEM can
process. Run
 
    convert-sam-for-rsem --help

to get usage information or visit the [convert-sam-for-rsem
documentation
page](convert-sam-for-rsem.html).

Note that RSEM does ** not ** support gapped alignments. So make sure
that your aligner does not produce alignments with
intersions/deletions. In addition, you should make sure that you use
`reference_name.idx.fa`, which is generated by RSEM, to build your
aligner's indices.

### III. Visualization

RSEM includes a copy of SAMtools. When `--no-bam-output` is not
specified and `--sort-bam-by-coordinate` is specified, RSEM will
produce these three files:`sample_name.transcript.bam`, the unsorted
BAM file, `sample_name.transcript.sorted.bam` and
`sample_name.transcript.sorted.bam.bai` the sorted BAM file and
indices generated by the SAMtools included. All three files are in
transcript coordinates. When users in addition specify the
`--output-genome-bam` option, RSEM will produce three more files:
`sample_name.genome.bam`, the unsorted BAM file,
`sample_name.genome.sorted.bam` and
`sample_name.genome.sorted.bam.bai` the sorted BAM file and
indices. All these files are in genomic coordinates.

#### a) Converting transcript BAM file into genome BAM file

Normally, RSEM will do this for you via `--output-genome-bam` option
of `rsem-calculate-expression`. However, if you have run
`rsem-prepare-reference` and use `reference_name.idx.fa` to build
indices for your aligner, you can use `rsem-tbam2gbam` to convert your
transcript coordinate BAM alignments file into a genomic coordinate
BAM alignments file without the need to run the whole RSEM
pipeline.

Usage:

    rsem-tbam2gbam reference_name unsorted_transcript_bam_input genome_bam_output

reference_name	   		  : The name of reference built by `rsem-prepare-reference`				
unsorted_transcript_bam_input	  : This file should satisfy: 1) the alignments of a same read are grouped together, 2) for any paired-end alignment, the two mates should be adjacent to each other, 3) this file should not be sorted by samtools 
genome_bam_output		  : The output genomic coordinate BAM file's name

#### b) Generating a Wiggle file

A wiggle plot representing the expected number of reads overlapping
each position in the genome/transcript set can be generated from the
sorted genome/transcript BAM file output.  To generate the wiggle
plot, run the `rsem-bam2wig` program on the
`sample_name.genome.sorted.bam`/`sample_name.transcript.sorted.bam` file.

Usage:    

    rsem-bam2wig sorted_bam_input wig_output wiggle_name [--no-fractional-weight]

sorted_bam_input        : Input BAM format file, must be sorted  
wig_output              : Output wiggle file's name, e.g. output.wig  
wiggle_name             : The name of this wiggle plot  
--no-fractional-weight  : If this is set, RSEM will not look for "ZW" tag and each alignment appeared in the BAM file has weight 1. Set this if your BAM file is not generated by RSEM. Please note that this option must be at the end of the command line

#### c) Loading a BAM and/or Wiggle file into the UCSC Genome Browser or Integrative Genomics Viewer(IGV)

For UCSC genome browser, please refer to the [UCSC custom track help page](http://genome.ucsc.edu/goldenPath/help/customTrack.html).

For integrative genomics viewer, please refer to the [IGV home page](http://www.broadinstitute.org/software/igv/home). Note: Although IGV can generate read depth plot from the BAM file given, it cannot recognize "ZW" tag RSEM puts. Therefore IGV counts each alignment as weight 1 instead of the expected weight for the plot it generates. So we recommend to use the wiggle file generated by RSEM for read depth visualization.

Here are some guidance for visualizing transcript coordinate files using IGV:

1) Import the transcript sequences as a genome 

Select File -> Import Genome, then fill in ID, Name and Fasta file. Fasta file should be `reference_name.idx.fa`. After that, click Save button. Suppose ID is filled as `reference_name`, a file called `reference_name.genome` will be generated. Next time, we can use: File -> Load Genome, then select `reference_name.genome`.

2) Load visualization files

Select File -> Load from File, then choose one transcript coordinate visualization file generated by RSEM. IGV might require you to convert wiggle file to tdf file. You should use igvtools to perform this task. One way to perform the conversion is to use the following command:

    igvtools tile reference_name.transcript.wig reference_name.transcript.tdf reference_name.genome   
 
#### d) Generating Transcript Wiggle Plots

To generate transcript wiggle plots, you should run the
`rsem-plot-transcript-wiggles` program.  Run 

    rsem-plot-transcript-wiggles --help

to get usage information or visit the [rsem-plot-transcript-wiggles
documentation page](rsem-plot-transcript-wiggles.html).

#### e) Visualize the model learned by RSEM

RSEM provides an R script, `rsem-plot-model`, for visulazing the model learned.

Usage:
    
    rsem-plot-model sample_name output_plot_file

sample_name: the name of the sample analyzed    
output_plot_file: the file name for plots generated from the model. It is a pdf file    

The plots generated depends on read type and user configuration. It
may include fragment length distribution, mate length distribution,
read start position distribution (RSPD), quality score vs observed
quality given a reference base, position vs percentage of sequencing
error given a reference base and alignment statistics.

fragment length distribution and mate length distribution: x-axis is fragment/mate length, y axis is the probability of generating a fragment/mate with the associated length

RSPD: Read Start Position Distribution. x-axis is bin number, y-axis is the probability of each bin. RSPD can be used as an indicator of 3' bias

Quality score vs. observed quality given a reference base: x-axis is Phred quality scores associated with data, y-axis is the "observed quality", Phred quality scores learned by RSEM from the data. Q = -10log_10(P), where Q is Phred quality score and P is the probability of sequencing error for a particular base

Position vs. percentage sequencing error given a reference base: x-axis is position and y-axis is percentage sequencing error

Alignment statistics: It includes a histogram and a pie chart. For the histogram, x-axis shows the number of **isoform-level** alignments a read has and y-axis provides the number of reads with that many alignments. The inf in x-axis means number of reads filtered due to too many alignments. For the pie chart, four categories of reads --- unalignable, unique, **isoform-level**multi-mapping, filtered -- are plotted and their percentages are noted. In both the histogram and the piechart, numbers belong to unalignable, unique, multi-mapping, and filtered are colored as green, blue, gray and red. 
 
## <a name="example-main"></a> Example

Suppose we download the mouse genome from UCSC Genome Browser.  We do
not add poly(A) tails and use `/ref/mouse_0` as the reference name.
We have a FASTQ-formatted file, `mmliver.fq`, containing single-end
reads from one sample, which we call `mmliver_single_quals`.  We want
to estimate expression values by using the single-end model with a
fragment length distribution. We know that the fragment length
distribution is approximated by a normal distribution with a mean of
150 and a standard deviation of 35. We wish to generate 95%
credibility intervals in addition to maximum likelihood estimates.
RSEM will be allowed 1G of memory for the credibility interval
calculation.  We will visualize the probabilistic read mappings
generated by RSEM on UCSC genome browser. We will generate a list of
transcript wiggle plots (`output.pdf`) for the genes provided in `gene_ids.txt`.
We will visualize the models learned in
`mmliver_single_quals.models.pdf`

The commands for this scenario are as follows:

    rsem-prepare-reference --gtf mm9.gtf --transcript-to-gene-map knownIsoforms.txt --bowtie --bowtie-path /sw/bowtie /data/mm9 /ref/mouse_0
    rsem-calculate-expression --bowtie-path /sw/bowtie --phred64-quals --fragment-length-mean 150.0 --fragment-length-sd 35.0 -p 8 --output-genome-bam --calc-ci --ci-memory 1024 /data/mmliver.fq /ref/mouse_0 mmliver_single_quals
    rsem-bam2wig mmliver_single_quals.sorted.bam mmliver_single_quals.sorted.wig mmliver_single_quals
    rsem-plot-transcript-wiggles --gene-list --show-unique mmliver_single_quals gene_ids.txt output.pdf 
    rsem-plot-model mmliver_single_quals mmliver_single_quals.models.pdf

## <a name="simulation"></a> Simulation

RSEM provides users the `rsem-simulate-reads` program to simulate RNA-Seq data based on parameters learned from real data sets. Run

    rsem-simulate-reads

to get usage information or read the following subsections.
 
### Usage: 

    rsem-simulate-reads reference_name estimated_model_file estimated_isoform_results theta0 N output_name [-q]

__reference_name:__ The name of RSEM references, which should be already generated by `rsem-prepare-reference`   	     

__estimated_model_file:__ This file describes how the RNA-Seq reads will be sequenced given the expression levels. It determines what kind of reads will be simulated (single-end/paired-end, w/o quality score) and includes parameters for fragment length distribution, read start position distribution, sequencing error models, etc. Normally, this file should be learned from real data using `rsem-calculate-expression`. The file can be found under the `sample_name.stat` folder with the name of `sample_name.model`. `model_file_description.txt` provides the format and meanings of this file.    

__estimated_isoform_results:__ This file contains expression levels for all isoforms recorded in the reference. It can be learned using `rsem-calculate-expression` from real data. The corresponding file users want to use is `sample_name.isoforms.results`. If simulating from user-designed expression profile is desired, start from a learned `sample_name.isoforms.results` file and only modify the `TPM` column. The simulator only reads the TPM column. But keeping the file format the same is required. If the RSEM references built are aware of allele-specific transcripts, `sample_name.alleles.results` should be used instead.   

__theta0:__ This parameter determines the fraction of reads that are coming from background "noise" (instead of from a transcript). It can also be estimated using `rsem-calculate-expression` from real data. Users can find it as the first value of the third line of the file `sample_name.stat/sample_name.theta`.   

__N:__ The total number of reads to be simulated. If `rsem-calculate-expression` is executed on a real data set, the total number of reads can be found as the 4th number of the first line of the file `sample_name.stat/sample_name.cnt`.   

__output_name:__ Prefix for all output files.   

__--seed seed:__ Set seed for the random number generator used in simulation. The seed should be a 32-bit unsigned integer.

__-q:__ Set it will stop outputting intermediate information.   

### Outputs:

output_name.sim.isoforms.results, output_name.sim.genes.results: Expression levels estimated by counting where each simulated read comes from.
output_name.sim.alleles.results: Allele-specific expression levels estimated by counting where each simulated read comes from.

output_name.fa if single-end without quality score;   
output_name.fq if single-end with quality score;   
output_name_1.fa & output_name_2.fa if paired-end without quality
score;   
output_name_1.fq & output_name_2.fq if paired-end with quality score.   

**Format of the header line**: Each simulated read's header line encodes where it comes from. The header line has the format:

    {>/@}_rid_dir_sid_pos[_insertL]

__{>/@}:__ Either '>' or '@' must appear. '>' appears if FASTA files are generated and '@' appears if FASTQ files are generated

__rid:__ Simulated read's index, numbered from 0   

__dir:__ The direction of the simulated read. 0 refers to forward strand ('+') and 1 refers to reverse strand ('-')   

__sid:__ Represent which transcript this read is simulated from. It ranges between 0 and M, where M is the total number of transcripts. If sid=0, the read is simulated from the background noise. Otherwise, the read is simulated from a transcript with index sid. Transcript sid's transcript name can be found in the `transcript_id` column of the `sample_name.isoforms.results` file (at line sid + 1, line 1 is for column names)   

__pos:__ The start position of the simulated read in strand dir of transcript sid. It is numbered from 0   

__insertL:__ Only appear for paired-end reads. It gives the insert length of the simulated read.   

### Example:

Suppose we want to simulate 50 millon single-end reads with quality scores and use the parameters learned from [Example](#example-main). In addition, we set theta0 as 0.2 and output_name as `simulated_reads`. The command is:

    rsem-simulate-reads /ref/mouse_0 mmliver_single_quals.stat/mmliver_single_quals.model mmliver_single_quals.isoforms.results 0.2 50000000 simulated_reads

## <a name="gen_trinity"></a> Generate Transcript-to-Gene-Map from Trinity Output

For Trinity users, RSEM provides a perl script to generate transcript-to-gene-map file from the fasta file produced by Trinity.

### Usage:

    extract-transcript-to-gene-map-from-trinity trinity_fasta_file map_file

trinity_fasta_file: the fasta file produced by trinity, which contains all transcripts assembled.    
map_file: transcript-to-gene-map file's name.    

## <a name="de"></a> Differential Expression Analysis

Popular differential expression (DE) analysis tools such as edgeR and
DESeq do not take variance due to read mapping uncertainty into
consideration. Because read mapping ambiguity is prevalent among
isoforms and de novo assembled transcripts, these tools are not ideal
for DE detection in such conditions.

EBSeq, an empirical Bayesian DE analysis tool developed in UW-Madison,
can take variance due to read mapping ambiguity into consideration by
grouping isoforms with parent gene's number of isoforms. In addition,
it is more robust to outliers. For more information about EBSeq
(including the paper describing their method), please visit [EBSeq's
website](http://www.biostat.wisc.edu/~ningleng/EBSeq_Package).


RSEM includes EBSeq in its folder named `EBSeq`. To use it, first type

    make ebseq

to compile the EBSeq related codes. 

EBSeq requires gene-isoform relationship for its isoform DE
detection. However, for de novo assembled transcriptome, it is hard to
obtain an accurate gene-isoform relationship. Instead, RSEM provides a
script `rsem-generate-ngvector`, which clusters transcripts based on
measures directly relating to read mappaing ambiguity. First, it
calculates the 'unmappability' of each transcript. The 'unmappability'
of a transcript is the ratio between the number of k mers with at
least one perfect match to other transcripts and the total number of k
mers of this transcript, where k is a parameter. Then, Ng vector is
generated by applying Kmeans algorithm to the 'unmappability' values
with number of clusters set as 3. This program will make sure the mean
'unmappability' scores for clusters are in ascending order. All
transcripts whose lengths are less than k are assigned to cluster
3. Run

    rsem-generate-ngvector --help

to get usage information or visit the [rsem-generate-ngvector
documentation
page](rsem-generate-ngvector.html).

If your reference is a de novo assembled transcript set, you should
run `rsem-generate-ngvector` first. Then load the resulting
`output_name.ngvec` into R. For example, you can use 

    NgVec <- scan(file="output_name.ngvec", what=0, sep="\n")

. After that, set "NgVector = NgVec" for your differential expression
test (either `EBTest` or `EBMultiTest`).


For users' convenience, RSEM also provides a script
`rsem-generate-data-matrix` to extract input matrix from expression
results:

    rsem-generate-data-matrix sampleA.[genes/isoforms].results sampleB.[genes/isoforms].results ... > output_name.counts.matrix

The results files are required to be either all gene level results or
all isoform level results. You can load the matrix into R by

    IsoMat <- data.matrix(read.table(file="output_name.counts.matrix"))

before running either `EBTest` or `EBMultiTest`.

Lastly, RSEM provides two scripts, `rsem-run-ebseq` and
`rsem-control-fdr`, to help users find differential expressed
genes/transcripts. First, `rsem-run-ebseq` calls EBSeq to calculate related statistics
for all genes/transcripts. Run 

    rsem-run-ebseq --help

to get usage information or visit the [rsem-run-ebseq documentation
page](rsem-run-ebseq.html). Second,
`rsem-control-fdr` takes `rsem-run-ebseq` 's result and reports called
differentially expressed genes/transcripts by controlling the false
discovery rate. Run

    rsem-control-fdr --help

to get usage information or visit the [rsem-control-fdr documentation
page](rsem-control-fdr.html). These
two scripts can perform DE analysis on either 2 conditions or multiple
conditions.

Please note that `rsem-run-ebseq` and `rsem-control-fdr` use EBSeq's
default parameters. For advanced use of EBSeq or information about how
EBSeq works, please refer to [EBSeq's
manual](http://www.bioconductor.org/packages/devel/bioc/vignettes/EBSeq/inst/doc/EBSeq_Vignette.pdf).

Questions related to EBSeq should
be sent to <a href="mailto:nleng@wisc.edu">Ning Leng</a>.

## <a name="pRSEM"></a> Prior-Enhanced RSEM (pRSEM)

### I. Overview

[Prior-enhanced RSEM (pRSEM)](https://deweylab.github.io/pRSEM/) uses complementary information (e.g. ChIP-seq data) to allocate RNA-seq multi-mapping fragments. We included pRSEM code in the subfolder `pRSEM/` as well as in RSEM's scripts `rsem-prepare-reference` and `rsem-calculate-expression`. 

### II. Demo

To get a quick idea on how to use pRSEM, you can try [this demo](https://github.com/pliu55/pRSEM_demo). It provides a single script, named `run_pRSEM_demo.sh`, which allows you to run all pRSEM's functions. It also contains detailed descriptions of pRSEM's workflow, input and output files.

### III. Installation

To compile pRSEM, type

    make pRSEM

Note that you need to first compile RSEM before compiling pRSEM. Currently, pRSEM has only been tested on Linux.


### IV. Example

To run pRSEM on the [RSEM example above](#example-main), you need to provide:
- __ChIP-seq sequencing file(s) in FASTQ format__ or __a ChIP-seq peak file in BED format__. They will be used by pRSEM to obtain complementatry information for allocating RNA-seq multi-mapping fragments.
- __a genome mappability file in bigWig format__ to let pRSEM build a training
  set of isoforms to learn prior. Mappability can be obtained from UCSC's 
  ENCODE composite track for [human hg19](http://hgdownload.cse.ucsc.edu/goldenPath/hg19/encodeDCC/wgEncodeMapability/wgEncodeCrgMapabilityAlign36mer.bigWig) 
  and [mouse mm9](http://hgdownload.cse.ucsc.edu/goldenPath/mm9/encodeDCC/wgEncodeMapability/wgEncodeCrgMapabilityAlign36mer.bigWig). For other genomes, you 
  can generate the mappability file by following [this tutorial] (http://wiki.bits.vib.be/index.php/Create_a_mappability_track#Install_and_run_the_GEM_library_tools).

Assuming you would like to use RNA Pol II's ChIP-seq sequencing files `/data/mmliver_PolIIRep1.fq.gz` and `/data/mmliver_PolIIRep2.fq.gz`, with ChIP-seq control `/data/mmliver_ChIPseqCtrl.fq.gz`. Also, assuming the mappability file for mouse genome is `/data/mm9.bigWig` and you prefer to use STAR located at `/sw/STAR` to align RNA-seq fragments and use Bowtie to align ChIP-seq reads. Then, you can use the following commands to run pRSEM:

    rsem-prepare-reference --gtf mm9.gtf \
                           --star \
                           --star-path /sw/STAR \
                           -p 8 \
                           --prep-pRSEM \
                           --bowtie-path /sw/bowtie \
                           --mappability-bigwig-file /data/mm9.bigWig \
                           /data/mm9 \
                           /ref/mouse_0
  
    rsem-calculate-expression --star \
                              --star-path /sw/STAR \
                              --calc-pme \
                              --run-pRSEM \
                              --chipseq-target-read-files /data/mmliver_PolIIRep1.fq.gz,/data/mmliver_PolIIRep2.fq.gz \
                              --chipseq-control-read-files /data/mmliver_ChIPseqCtrl.fq.gz \
                              --bowtie-path /sw/bowtie \
                              -p 8 \
                              /data/mmliver.fq \
                              /ref/mouse_0 \
                              mmliver_single_quals


To find out more about pRSEM options and examples, you can use the commands:

    rsem-prepare-reference --help

and 

    rsem-calculate-expression --help


### V. System Requirements
- Linux
- Perl version >= 5.8.8
- Python version >= 2.7.3
- R version >= 3.3.1
- Bioconductor 3.3


### VI. Required External Packages
All the following packages will be automatically installed when compiling pRSEM.
- [data.table 1.9.6](https://cran.r-project.org/web/packages/data.table/index.html): an extension of R's data.frame, heavily used by pRSEM.
- [GenomicRanges 1.24.3](https://bioconductor.org/packages/release/bioc/html/GenomicRanges.html): efficient representing and manipulating genomic intervals, heavily used by pRSEM.
- [ShortRead 1.30.0](https://bioconductor.org/packages/release/bioc/html/ShortRead.html): guessing the encoding of ChIP-seq FASTQ file's quality score.
- [caTools 1.17.1](https://cran.r-project.org/web/packages/caTools/index.html): used for SPP Peak Caller.
- [SPP Peak Caller](https://code.google.com/archive/p/phantompeakqualtools/):
  ChIP-seq peak caller. Source code was slightly modified in terms of included headers in order to be compiled under R v3.3.1.
- [IDR](https://sites.google.com/site/anshulkundaje/projects/idr/idrCode.tar.gz?attredirects=0):
  calculating Irreproducible Discovery Rate to call peaks from multiple ChIP-seq replicates.


## <a name="authors"></a> Authors

[Bo Li](http://bli25ucb.github.io/) and [Colin Dewey](https://www.biostat.wisc.edu/~cdewey/) designed the RSEM algorithm. [Bo Li](http://bli25ucb.github.io/) implemented the RSEM software. [Peng Liu](https://www.biostat.wisc.edu/~cdewey/group.html) contributed the STAR aligner options and prior-enhanced RSEM (pRSEM).

## <a name="acknowledgements"></a> Acknowledgements

RSEM uses the [Boost C++](http://www.boost.org/) and
[SAMtools](http://www.htslib.org/) libraries. RSEM includes
[EBSeq](http://www.biostat.wisc.edu/~ningleng/EBSeq_Package/) for
differential expression analysis.

We thank earonesty, Dr. Samuel Arvidsson, John Marshall, and Michael
R. Crusoe for contributing patches.

We thank Han Lin, j.miller, Jo&euml;l Fillon, Dr. Samuel G. Younkin,
Malcolm Cook, Christina Wells, Uro&#353; &#352;ipeti&#263;,
outpaddling, rekado, and Josh Richer for suggesting possible fixes.

**Note** that `bam_sort.c` of SAMtools is slightly modified so that
  `samtools sort -n` will not move the two mates of paired-end
  alignments apart. In addition, we turn on the `--without-curses`
  option when configuring SAMtools and thus SAMtools' curses-based
  `tview` subcommand is not built.

## <a name="license"></a> License

RSEM is licensed under the [GNU General Public License
v3](http://www.gnu.org/licenses/gpl-3.0.html).

===========================
Anshul Kundaje
Date: Feb 13 2012
Email: anshul@kundaje.net
Version: 2.0
===========================
This set of programs operate on mapped Illumina single-end read datasets in tagAlign or BAM format.
They can be used to 
(1) Compute the predominant fragment length based on strand cross-correlation peak
(2) Compute Data quality measures based on strand cross-correlation analysis and relative phantom peak
(3) Call Peaks and regions for punctate binding ChIP-seq datasets

===========================
CITATIONS:
===========================
If you are using the code or results in any formal publication please cite
[1] Anshul Kundaje, Computer Science Dept., MIT, ENCODE Consortium, http://code.google.com/p/phantompeakqualtools, Feb 2013
[2] Kharchenko PK, Tolstorukov MY, Park PJ, Design and analysis of ChIP-seq experiments for DNA-binding proteins Nat Biotechnol. 2008 Dec;26(12):1351-9

===========================
DEPENDENCIES:
===========================
unix,bash,R-2.10 and above,awk,samtools,boost C++ libraries
R packages: SPP, caTools, snow
NOTE: The current package does not run on a MAC or WINDOWS.

===========================
FILES:
===========================
(1) spp_1.10.1.tar.gz  : modified SPP peak-caller package (The original SPP-peak caller package was written by Peter Kharchenko[2])
(2) run_spp.R          : The script to compute the frag length, data quality characteristics based on cross-correlation analysis and/or peak calling
(3) run_spp_nodups.R   : (FOR DATASETS WHERE DUPLICATES ARE REMOVED i.e. MAX 1 READ STARTING AT ANY GENOMIC LOCATION) The script to compute the frag length, data quality characteristics based on cross-correlation analysis and/or peak calling
(4) README.txt         : This README

============================
INSTALLATION:
============================
(1) First make sure that you have installed R (version 2.10 or higher)

(2) Also, you must have the Boost C++ libraries installed. Most linux distributions have these preinstalled.
If not, you can easily get these from your standard package manager for your linux distribution.
e.g synaptic package manager (apt-get) for ubuntu or emerge for gentoo.

(3) Install the following R packages
	- caTools
	- snow (if you want parallel processing)
from within R
install.packages([packageName],dependencies=TRUE)

(4) You can then install the SPP package spp_1.10.X.tar.gz
<From your bash shell>
	R CMD INSTALL spp_1.10.X.tar.gz

<From within R>
	install.packages('spp_1.10.X.tar.gz',dependencies=TRUE)

(5) If your alignment files are BAM, you must have the samtools executable in your path so that the R script run_spp.R can call it using the system() command
You can get samtools from here http://samtools.sourceforge.net/
You can add the following line to your .bashrc file
	export PATH="<path_to_samtools_executable>:${PATH}"
	
(6) Run run_spp.R
	Rscript run_spp.R <options>

===========================
GENERAL USAGE
===========================
Usage: Rscript run_spp.R <options>

MANDATORY ARGUMENTS
-c=<ChIP_alignFile>, full path and name (or URL) of tagAlign/BAM file (can be gzipped) (FILE EXTENSION MUST BE tagAlign.gz, tagAlign, bam or bam.gz)

MANDATORY ARGUMENTS FOR PEAK CALLING
-i=<Input_alignFile>, full path and name (or URL) of tagAlign/BAM file (can be gzipped) (FILE EXTENSION MUST BE tagAlign.gz, tagAlign, bam or bam.gz)

OPTIONAL ARGUMENTS
-s=<min>:<step>:<max> , strand shifts at which cross-correlation is evaluated, default=-100:5:600
-speak=<strPeak>, user-defined cross-correlation peak strandshift
-x=<min>:<max>, strand shifts to exclude (This is mainly to avoid region around phantom peak) default=10:(readlen+10)
-p=<nodes> , number of parallel processing nodes, default=0
-fdr=<falseDisoveryRate> , false discovery rate threshold for peak calling
-npeak=<numPeaks>, threshold on number of peaks to call
-tmpdir=<tempdir> , Temporary directory (if not specified R function tempdir() is used)
-filtchr=<chrnamePattern> , Pattern to use to remove tags that map to specific chromosomes e.g. _ will remove all tags that map to chromosomes with _ in their name

OUTPUT ARGUMENTS
-odir=<outputDirectory> name of output directory (If not set same as ChIP file directory is used)
-savn=<narrowpeakfilename> OR -savn NarrowPeak file name (fixed width peaks)
-savr=<regionpeakfilename> OR -savr RegionPeak file name (variable width peaks with regions of enrichment around peak summits)
-savd=<rdatafile> OR -savd, save Rdata file
-savp=<plotdatafile> OR -savp, save cross-correlation plot
-out=<resultfile>, append peakshift/phantomPeak results to a file
-rf, if plot or rdata or narrowPeak file exists replace it. If not used then the run is aborted if the plot or Rdata or narrowPeak file exists
-clean, if used it will remove the original chip and control files after reading them in. CAUTION: Use only if the script calling run_spp.R is creating temporary files

===========================
TYPICAL USAGE
===========================
(1) Determine strand cross-correlation peak / predominant fragment length OR print out quality measures
	
	Rscript run_spp.R -c=<tagAlign/BAMfile> -savp -out=<outFile>

-savp will create a pdf showing the cross-correlation plot
-out=<outFile> will create and/or append to a file named <outFile> several important characteristics of the dataset.
The file contains 11 tab delimited columns

COL1: Filename: tagAlign/BAM filename
COL2: numReads: effective sequencing depth i.e. total number of mapped reads in input file
COL3: estFragLen: comma separated strand cross-correlation peak(s) in decreasing order of correlation.
	  The top 3 local maxima locations that are within 90% of the maximum cross-correlation value are output.
	  In almost all cases, the top (first) value in the list represents the predominant fragment length.
	  If you want to keep only the top value simply run
	  sed -r 's/,[^\t]+//g' <outFile> > <newOutFile>
COL4: corr_estFragLen: comma separated strand cross-correlation value(s) in decreasing order (col2 follows the same order)
COL5: phantomPeak: Read length/phantom peak strand shift
COL6: corr_phantomPeak: Correlation value at phantom peak
COL7: argmin_corr: strand shift at which cross-correlation is lowest
COL8: min_corr: minimum value of cross-correlation
COL9: Normalized strand cross-correlation coefficient (NSC) = COL4 / COL8
COL10: Relative strand cross-correlation coefficient (RSC) = (COL4 - COL8) / (COL6 - COL8)
COL11: QualityTag: Quality tag based on thresholded RSC (codes: -2:veryLow,-1:Low,0:Medium,1:High,2:veryHigh)

You can run the program on multiple datasets in parallel and append all the quality information to the same <outFile> for a summary analysis.

NSC values range from a minimum of 1 to larger positive numbers. 1.1 is the critical threshold. 
Datasets with NSC values much less than 1.1 (< 1.05) tend to have low signal to noise or few peaks (this could be biological eg.a factor that truly binds only a few sites in a particular tissue type OR it could be due to poor quality)

RSC values range from 0 to larger positive values. 1 is the critical threshold.
RSC values significantly lower than 1 (< 0.8) tend to have low signal to noise. The low scores can be due to failed and poor quality ChIP, low read sequence quality and hence lots of mismappings, shallow sequencing depth (significantly below saturation) or a combination of these. Like the NSC, datasets with few binding sites (< 200) which is biologically justifiable also show low RSC scores.

Qtag is a thresholded version of RSC.

(2) Peak calling

Rscript run_spp.R -c=<ChIP_tagalign/BAM_file> -i=<control_tagalign/BAM_file> -fdr=<fdr> -odir=<peak_call_output_dir> -savr -savp -savd -rf
Rscript run_spp.R -c=<ChIP_tagalign/BAM_file> -i=<control_tagalign/BAM_file> -npeak=<npeaks> -odir=<peak_call_output_dir> -savr -savp -savd -rf

(3) For IDR analysis you want to call a large number of peaks (relaxed threshold) so that the IDR model has access to a sufficient noise component.

Rscript run_spp.R -c=<ChIP_tagalign/BAM_file> -i=<control_tagalign/BAM_file> -npeak=300000 -odir=<peak_call_output_dir> -savr -savp -rf -out=<resultFile>

===========================
NOTES:
===========================
- It is EXTREMELY important to filter out multi-mapping reads from the BAM/tagAlign files. Large number of multimapping reads can severly affect the phantom peak coefficient and peak calling results.

- If a dataset seems to have high PCR bottlenecking, then you might want to actually clamp the number of unique mappping reads per position to 1 or upto 5. If not the phantom peak coefficient can be artificially good.

- For the IDR rescue strategy, one needs to pool reads from replicates and then shuffle and subsample the mapped reads to create two balanced pseudoReplicates. This is much easier to implement on tagAlign/BED read-mapping files using the unix 'shuf' command. So it is recommended to use the tagAlign format.

- In most cases, you can simply use the maximum reported strand correlation peak as the predominant fragment length.
However, it is useful to manually take a look at the cross-correlation plot to make sure the selected max peak is not an artifact.

- Also, if there are problems with library size-selection, a dataset's cross-correlation profile can have multiple strong cross-correlation peaks. This is currently not autodetected.

===========================
INPUT FILE FORMATS:
===========================
(1) BAM format
This is a binary alignment format specified in http://samtools.sourceforge.net/SAM-1.3.pdf
You MUST have samtools installed to use run_spp.R with BAM files

(2) TagAlign files
This a text-based BED3+3 alignment format that is easier to manipulate. It contains 6 tab delimited columns.

chrom	 string	 Name of the chromosome
chromStart	 int	 The starting position of the feature in the chromosome. The first base in a chromosome is numbered 0.
chromEnd	 int	 The ending position of the feature in the chromosome or scaffold. The chromEnd base is not included in the display of the feature. For example, the first 100 bases of a chromosome are defined as
                     chromStart=0, chromEnd=100, and span the bases numbered 0-99.
sequence	 string	 Sequence of this read
score	 int	 Indicates uniqueness or quality (preferably 1000/alignmentCount).
strand	 char	 Orientation of this read (+ or -)

NOTE: You dont have to store the sequence of reads in the sequence field as the peak caller never really uses that field. You can just put the letter 'N' in that field. This saves space significantly.

For the IDR rescue strategy, one needs to use shuffled and subsampled version of the alignment files. This is much easier to implement on tagAlign text files using the unix 'shuf' command.
So it is recommended to preferably use the tagAlign format.

----------------------------------
CONVERTING BAM TO TAGALIGN FILES
----------------------------------
It is very quick to convert BAM files to gzipped tagAlign files using

samtools view -F 0x0204 -o - <bamFile> | awk 'BEGIN{OFS="\t"}{if (and($2,16) > 0) {print $3,($4-1),($4-1+length($10)),"N","1000","-"} else {print $3,($4-1),($4-1+length($10)),"N","1000","+"} }' | gzip -c > <gzip_TagAlignFileName>

===========================
OUTPUT FILE FORMATS:
===========================
(1) NarrowPeak/RegionPeak format

The output peak file is in BED6+4 format known as tagAlign. It consists of 10 tab-delimited columns

chrom	 string	 Name of the chromosome
chromStart	 int	 The starting position of the feature in the chromosome. The first base in a chromosome is numbered 0.
chromEnd	 int	 The ending position of the feature in the chromosome or scaffold. The chromEnd base is not included in the display of the feature.
                     For example, the first 100 bases of a chromosome are defined as chromStart=0, chromEnd=100, and span the bases numbered 0-99.
name	 string	 Name given to a region (preferably unique). Use '.' if no name is assigned.
score	 int	 Indicates how dark the peak will be displayed in the browser (1-1000). If '0', the DCC will assign this based on signal value. Ideally average signalValue per base spread between 100-1000.
strand	 char	 +/- to denote strand or orientation (whenever applicable). Use '.' if no orientation is assigned.
signalValue	 float	 Measurement of overall (usually, average) enrichment for the region.
pValue	 float	 Measurement of statistical signficance (-log10). Use -1 if no pValue is assigned.
qValue	 float	 Measurement of statistical significance using false discovery rate (-log10). Use -1 if no qValue is assigned.
peak	 int	 Point-source called for this peak; 0-based offset from chromStart. Use -1 if no point-source called.

pliu 20150607
genome_table.txt and genome_tables/ are removed. The same info can be obtained
from rsem-prepare-reference

===========================
README for consistency analysis of peak calling on replicates
Qunhua Li and Anshul Kundaje (Oct,2010)
===========================
This set of programs are used for consistency analysis on peak calling results on multiple replicates of a dataset

================
DEPENDENCIES
================
unix, R version 2.9 or higher

================
FILES:
================
batch-consistency-analysis.r : for pairwise IDR analysis of replicates
batch-consistency-plot.r: for creating diagnostic and IDR plots
functions-all-clayton-12-13.r: helper function
genome_table.txt: This file MUST contain the size of each chromosome of the genome of the organism that the peak files are referring to

================
INPUT FILE FORMATS
================
(1) genome_table.txt
It contains two space delimited fields
Col1: chromosome name (These MUST match the chromosome names in the peak files)
Col2: chromosome size (in bp)

(1) Peak Files
Peak files MUST be in narrowPeak format (and unzipped ... the code currently doesnt handle gzipped peak files directly)

NarrowPeak files are in BED6+4 format. It consists of 10 tab-delimited columns

chrom	 string	 Name of the chromosome
chromStart	 int	 The starting position of the feature in the chromosome. The first base in a chromosome is numbered 0.
chromEnd	 int	 The ending position of the feature in the chromosome or scaffold. The chromEnd base is not included in the display of the feature.
                     For example, the first 100 bases of a chromosome are defined as chromStart=0, chromEnd=100, and span the bases numbered 0-99.
name	 string	 Name given to a region (preferably unique). Use '.' if no name is assigned.
score	 int	 Indicates how dark the peak will be displayed in the browser (1-1000). If '0', the DCC will assign this based on signal value. Ideally average signalValue per base spread between 100-1000.
strand	 char	 +/- to denote strand or orientation (whenever applicable). Use '.' if no orientation is assigned.
signalValue	 float	 Measurement of overall (usually, average) enrichment for the region.
pValue	 float	 Measurement of statistical signficance (-log10). Use -1 if no pValue is assigned.
qValue	 float	 Measurement of statistical significance using false discovery rate (-log10). Use -1 if no qValue is assigned.
peak	 int	 Point-source called for this peak; 0-based offset from chromStart. Use -1 if no point-source called.

*NOTE*: the p-value and q-value columns MUST be in -log10() scale

The narrowPeak format has 3 columns that can be used to rank peaks 
(signal.value, p.value (-log_10) and q.value (-log_10)).
The peak summit column must have values relative to the start coordinate of the peaks.
You can use any of these columns but make sure that whichever measure you are using rank peaks is relatively continuous without too many ties.
e.g. For the SPP peak caller it is recommended to use signal.value column
e.g. PeakSeq peak caller has relatively continuous q.values without too many ties. So for PeakSeq it is better to use q.value
 
================
RUNNING INSTRUCTIONS
================
First make sure the genome_table.txt file contains the appropriate chromosome names and sizes. If not replace the contents of this file. Make sure the file continues to be named 'genome_table.txt'.
The file name is currently hardcoded. We will change this in the next release of the code.

(1) batch-consistency-analysis.r

This is used to run pairwise consistency analysis on a pair of replicate peak files

----------------
GENERAL USAGE:
----------------
Rscript batch-consistency-analysis.r [peakfile1] [peakfile2] [peak.half.width] [outfile.prefix] [min.overlap.ratio] [is.broadpeak] [ranking.measure]

Typical usage for SPP peak caller peaks
Rscript batch-consistency-analysis.r [peakfile1] [peakfile2] -1 [outfile.prefix] 0 F q.value

Typical usage for MACS peak caller peaks
Rscript batch-consistency-analysis.r [peakfile1] [peakfile2] 200 [outfile.prefix] 0 F p.value

[peakfile1] and [peakfile2] are the peak calls for the pair of replicates in narrowPeak format. They must be uncompressed files.
e.g. /peaks/reps/chipSampleRep1_VS_controlSampleRep0.narrowPeak AND 
	 /peaks/reps/chipSampleRep2_VS_controlSampleRep0.narrowPeak

[peak.half.width]: Set this to -1 if you want to use the reported peak width in the peak files.
If you want to truncate peak widths to say 400 bp max then use a value of 200.

[outfile.prefix] is a prefix that will be used to name the output data for this pair of replicates.
The prefix must also include the PATH to the directory where you want to store the output data.
e.g. /consistency/reps/chipSampleRep1_VS_chipSampleRep2

[min.overlap.ratio]: fractional bp overlap (ranges from 0 to 1) between peaks in replicates to be considered as overlapping peaks. 
Set to 0 if you want to allow overlap to be defined as >= 1 bp overlap.
If set to say 0.5 this would mean that atleast 50% of the peak in one replicate should be covered by a peak in the other replicate to count as an overlap.

[is.broadpeak]: Is the peak file format narrowPeak or broadPeak. Set to F if it is narrowPeak/regionPeak or T if it is broadPeak.

[ranking.measure] is the ranking measure to use. It can take only one of the following values
signal.value , p.value or q.value

OUTPUT:
The results will be written to the directory contained in [outfile.prefix]
a. The output from EM fitting: suffixed by -em.sav
b. The output for plotting empirical curves: suffixed by -uri.sav
	Note: 1 and 2 are objects that can be loaded back to R for plotting or other purposes (e.g. retrieve data)
c. The parameters estimated from EM and the log of consistency analysis, suffixed by -Rout.txt
d. The number of peaks that pass specific IDR thresholds for the pairwise analysis: suffixed by npeaks-aboveIDR.txt
e. The full set of peaks that overlap between the replicates with local and global IDR scores: suffixed by overlapped-peaks.txt


(2) batch-consistency-plot.r

This is used to plot the IDR plots and diagnostic plots for a single or multiple pairs of replicates.

----------------
GENERAL USAGE:
----------------
Rscript batch-consistency-plot.r [npairs] [output.prefix] [input.file.prefix1] [input.file.prefix2] [input.file.prefix3] ....

[n.pairs] is the number of pairs of replicates that you want to plot on the same plot
e.g. 1 or 3 or ...

[output.prefix] is a prefix that will be used to name output data from this analysis. 
NOT TO BE CONFUSED with [outfile.prefix] in batch-consistency-analysis.r
The prefix must also include the PATH to the directory where you want to store the output data.
e.g. /consistency/plots/chipSampleAllReps

[input.file.prefix 1, 2, 3 ...] are the [outfile.prefix] values used to name the output from pairwise analysis on all replicates
e.g. /consistency/reps/chipSampleRep1_VS_chipSampleRep2
	 /consistency/reps/chipSampleRep1_VS_chipSampleRep3
	 /consistency/reps/chipSampleRep2_VS_chipSampleRep3

OUTPUT:
1. summary consistency plots in .ps format: suffixed by -plot.ps
These plots are very informative about the quality and similarity of the replicates.

===================================================
GETTING NUMBER OF PEAKS THAT PASS AN IDR THRESHOLD
===================================================
For each pairwise analysis, we have a *overlapped-peaks.txt file

The last column (Column 11) of the overlapped-peaks.txt file has the global IDR score for each pair of overlapping peaks
To get the number of peaks that pass an IDR threshold of T (e.g. 0.01) you simply find the number of lines that have a global IDR score <= T

awk '$11 <= 0.01 {print $0}' [overlappedPeaksFileName] | wc -l

# 1-20-10 Qunhua Li
#
# This program first plots correspondence curve and IDR threshold plot
# (i.e. number of selected peaks vs IDR) for each pair of sample
#
# usage: 
# Rscript batch-consistency-plot-merged.r [npairs] [output.dir] [input.file.prefix 1, 2, 3 ...]
# [npairs]: integer, number of consistency analyses
#          (e.g. if 2 replicates, npairs=1, if 3 replicates, npairs=3
# [output.dir]: output directory for plot
# [input.file.prefix 1, 2, 3]: prefix for the output from batch-consistency-analysis2. They are the input files for merged analysis see below for examples (i.e. saved.file.prefix). It can be multiple files
#

args <- commandArgs(trailingOnly=T)
npair <- args[1] # number of curves to plot on the same figure
output.file.prefix <- args[2] # file name for plot, generated from script at the outer level
df.txt <- 10
ntemp <- as.numeric(npair)
saved.file.prefix <- list() # identifier of filenames that contain the em and URI results
source("functions-all-clayton-12-13.r")

uri.list <- list()
uri.list.match <- list()
ez.list <- list()
legend.txt <- c()
em.output.list <- list()
uri.output.list <- list()

for(i in 1:npair){
  saved.file.prefix[i] <- args[2+i]
 
  load(paste(saved.file.prefix[i], "-uri.sav", sep=""))
  load(paste(saved.file.prefix[i], "-em.sav", sep=""))

  uri.output.list[[i]] <- uri.output
  em.output.list[[i]] <- em.output

  ez.list[[i]] <- get.ez.tt.all(em.output, uri.output.list[[i]]$data12.enrich$merge1,
                                uri.output.list[[i]]$data12.enrich$merge2) # reverse =T for error rate

  # URI for all peaks
  uri.list[[i]] <- uri.output$uri.n
  # URI for matched peaks
  uri.match <- get.uri.matched(em.output$data.pruned, df=df.txt)
  uri.list.match[[i]] <- uri.match$uri.n

  file.name <- unlist(strsplit(as.character(saved.file.prefix[i]), "/"))
  
  legend.txt[i] <- paste(i, "=", file.name[length(file.name)])

}

plot.uri.file <- paste(output.file.prefix, "-plot.ps", sep="")

############# plot and report output
# plot correspondence curve for each pair,
# plot number of selected peaks vs IDR 
# plot all into 1 file
postscript(paste(output.file.prefix, "-plot.ps", sep=""))
par(mfcol=c(2,3), mar=c(5,6,4,2)+0.1)
plot.uri.group(uri.list, NULL, file.name=NULL, c(1:npair), title.txt="all peaks")
plot.uri.group(uri.list.match, NULL, file.name=NULL, c(1:npair), title.txt="matched peaks")
plot.ez.group(ez.list, plot.dir=NULL, file.name=NULL, legend.txt=c(1:npair), y.lim=c(0, 0.6))
plot(0, 1, type="n", xlim=c(0,1), ylim=c(0,1), xlab="", ylab="", xaxt="n", yaxt="n") # legends
legend(0, 1, legend.txt, cex=0.6)

dev.off()

#
#  pliu 20150608
#
#  module for processing RNA-seq data
#

main <- function() {
  name2func <- list(
    'selTrainingTr'                = selTrainingTr,
    'prepTSSPeakFeatures'          = prepTSSPeakFeatures,
    'prepPeakSignalGCLenFeatures'  = prepPeakSignalGCLenFeatures,
    'prepMultiTargetsFeatures'     = prepMultiTargetsFeatures,
    'genPriorByTSSPeak'            = genPriorByTSSPeak,
    'genPriorByPeakSignalGCLen'    = genPriorByPeakSignalGCLen,
    'genPriorByCombinedTSSSignals' = genPriorByCombinedTSSSignals
  )

  argv <- commandArgs(trailingOnly=T)
  name2func[[argv[1]]](argv[2:length(argv)])
}


genPriorByCombinedTSSSignals <- function(argv=NA){
  libloc <- argv[1]
  finfo  <- argv[2]
  fout_glmmdl <- argv[3]
  fout_ftrs   <- argv[4]
  fout_pvalLL <- argv[5]
  fout_prior  <- argv[6]

# libloc <- '/ua/pliu/dev/RSEM/pRSEM/RLib/'
# finfo  <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/example.temp/multi_targets.info'
# fout_glmmdl <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/example.stat/example_prsem.lgt_mdl.RData'
# fout_ftrs   <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/example.stat/example_prsem.all_tr_features'
# fout_pvalLL <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/example.stat/example_prsem.pval_LL'
# fout_prior  <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/example.stat/example_prsem.all_tr_prior'

  .libPaths(c(libloc, .libPaths()))
  suppressMessages(library(data.table))

  infodt <- fread(finfo, header=T, sep="\t")
  tgtids <- infodt[, targetid]
  ftrsdt <- rbindlist(lapply(tgtids,
              function(tgtid) {
                fin <- subset(infodt, targetid==tgtid)[, fftrs]
                dt <- fread(fin, header=T, sep="\t")
                dt[, `:=`( log10_tss_sig = ifelse(tss_sig > 0, log10(tss_sig),
                                                  -4),
                           targetid      = tgtid )]
                dt[, `:=`(tss_sig = NULL, nrd = NULL) ]
                return(dt)
              }))

  alldt <- dcast(ftrsdt, ... ~ targetid, value.var = 'log10_tss_sig')
  trndt <- subset(alldt, is_training == 1)
  frm <- paste0('is_expr ~ ', paste(sort(tgtids), collapse=' + '))

  glmmdl <- glm(frm, family='binomial', data=trndt)
  save(glmmdl, file=fout_glmmdl)

  alldt[, prd_expr_prob := predict(glmmdl, alldt, type='response')]
  alldt[, partition := factor(ifelse(prd_expr_prob > 0.5, 1, 0))]

  trn_prtdt <- subset(alldt, is_training == 1)
  fit <- getFitByMLDM(trn_prtdt[, pme_count], trn_prtdt[, partition])
  alldt[, prior:= fit$par[partition]]

  orig_ordered_trids <- subset(ftrsdt, targetid == tgtids[1])[, trid]
  setkey(alldt, trid)

  write.table(alldt[orig_ordered_trids], fout_ftrs, quote=F, sep='\t',
              col.names=T, row.names=F)

  not_expr_cnt <- subset(trn_prtdt, partition == 0)[, pme_count]
  expr_cnt     <- subset(trn_prtdt, partition == 1)[, pme_count]
  wrs <- suppressWarnings(wilcox.test(expr_cnt, not_expr_cnt,
                                      alternative='greater', paired=F, exact=T))
  pval <- wrs$p.value
  loglikelihood <- fit$value
  pvalLLdt <- data.table(pvalue = pval, loglikelihood = loglikelihood)
  write.table(pvalLLdt, fout_pvalLL, quote=F, sep="\t", col.names=T,
              row.names=F)

  out_priordt <- alldt[orig_ordered_trids, list(prior, trid)]
  write.table(out_priordt, fout_prior, quote=F, sep=' # ', col.names=F,
              row.names=F)
}


genPriorByPeakSignalGCLen <- function(argv=NA) {
  libloc           <- argv[1]
  fall_tr_features <- argv[2]
  partition_model  <- argv[3]
  fout             <- argv[4]

# libloc <- '/ua/pliu/dev/RSEM/pRSEM/RLib/'
# fall_tr_features <- '/tier2/deweylab/scratch/pliu/dev/rsem_expr/test.temp/test_prsem.all_tr_features'
# partition_model <- 'pk_lgtnopk'
# fout <- '/tier2/deweylab/scratch/pliu/dev/rsem_expr/test.temp/test_prsem.all_tr_prior'

  partition_model2func <- list(
    ## not needed in this function
   #'pk'   = getSampleAndPriorByPeak
   #'1prt' = getSampleAndPriorByOnePartition,

    ## w/ peak + logit on no peak
    'pk_lgtnopk' = getSampleAndPriorByPeakLogitNoPeak,

    ## linear regression on all with different number of bins
    'lm3'        = getSampleAndPriorByLM3,  # 3 bins
    'lm4'        = getSampleAndPriorByLM4,  # 4 bins
    'lm5'        = getSampleAndPriorByLM5,  # 5 bins
    'lm6'        = getSampleAndPriorByLM6,  # 6 bins

	  ## no peak + lm on w/ peak with different number of bins
    'nopk_lm2pk' = getSampleAndPriorByNoPeakLM2Peak,
    'nopk_lm3pk' = getSampleAndPriorByNoPeakLM3Peak,
    'nopk_lm4pk' = getSampleAndPriorByNoPeakLM4Peak,
    'nopk_lm5pk' = getSampleAndPriorByNoPeakLM5Peak,

    ## w/ peak + lm on no peak with different number of bins
    'pk_lm2nopk' = getSampleAndPriorByPeakLM2NoPeak,
    'pk_lm3nopk' = getSampleAndPriorByPeakLM3NoPeak,
    'pk_lm4nopk' = getSampleAndPriorByPeakLM4NoPeak,
    'pk_lm5nopk' = getSampleAndPriorByPeakLM5NoPeak
  )

  .libPaths(c(libloc, .libPaths()))
  suppressMessages(library(data.table))

  all_trdt <- fread(fall_tr_features, header=T, sep="\t")
  GC_mean <- mean(all_trdt[, GC_fraction])
  all_trdt[, `:=`( log10_count    = log10(pme_count + 1),
                   log10_tss_sig  = ifelse(tss_sig > 0,  log10(tss_sig),  -4.0),
                   log10_body_sig = ifelse(body_sig > 0, log10(body_sig), -4.0),
                   log10_tes_sig  = ifelse(tes_sig > 0,  log10(tes_sig),  -4.0),
                   log10_eff_len  = ifelse(efflen > 0,   log10(efflen),   -4.0),
                   log10_GC_ov_mean = ifelse(GC_fraction > 0,
                                             log10(GC_fraction/GC_mean),  -4.0),
                   no_tss_pk      = 1 - tss_pk,
                   no_body_pk     = 1 - body_pk,
                   no_tes_pk      = 1 - tes_pk
                 )]

  training_trdt <- subset(all_trdt, is_training==1)

  func <- partition_model2func[[partition_model]]

  outdt <- func(training_trdt, all_trdt)
  write.table(outdt[, list(prior, trid)], fout, quote=F, sep=' # ', col.names=F,
              row.names=F)
}


prepMultiTargetsFeatures <- function(argv=NA){
  libloc            <- argv[1]
  fall_tr_crd       <- argv[2]
  ftraining_tr_crd  <- argv[3]
  fisoforms_results <- argv[4]
  flanking_width    <- as.numeric(argv[5])
  cap_stacked_chipseq_reads   <- argv[6]
  n_max_stacked_chipseq_reads <- argv[7]
  finfo             <- argv[8]
  nthr              <- argv[9]

# libloc            <- '/ua/pliu/dev/RSEM/pRSEM/RLib/'
# fall_tr_crd       <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/example.temp/example_prsem.all_tr_crd'
# ftraining_tr_crd  <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/example.temp/example_prsem.training_tr_crd'
# fisoforms_results <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/example.isoforms.results'
# flanking_width    <- 500
# cap_stacked_chipseq_reads   <- 'True'
# n_max_stacked_chipseq_reads <- 5
# finfo             <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/example.temp/multi_targets.info'
# nthr              <- 16

# tmpdir <- '/tier2/deweylab/scratch/pliu/test/pRSEM/histone/03_rsem_expr/LTHSCRep1/LTHSCRep1.temp/'
# libloc            <- '/ua/pliu/dev/RSEM/pRSEM/RLib/'
# fall_tr_crd       <- paste0(tmpdir, 'LTHSCRep1_prsem.all_tr_crd')
# ftraining_tr_crd  <- paste0(tmpdir, 'LTHSCRep1_prsem.training_tr_crd')
# fisoforms_results <- paste0(tmpdir, '../LTHSCRep1.isoforms.results')
# flanking_width    <- 500
# cap_stacked_chipseq_reads   <- 'False'
# n_max_stacked_chipseq_reads <- 5
# finfo             <- paste0(tmpdir, 'multi_targets.info')
# nthr              <- 16

  .libPaths(c(libloc, .libPaths()))
  suppressMessages(library(data.table))
  suppressMessages(library(GenomicRanges))

  all_trdt <- fread(fall_tr_crd, header=T, sep="\t")
  training_trdt <- fread(ftraining_tr_crd, header=T, sep="\t", select='trid')

  rsemdt <- fread(fisoforms_results, header=T, sep="\t", select=c(
                  'transcript_id', 'posterior_mean_count', 'pme_TPM'))
  setnames(rsemdt, 1:2, c('trid', 'pme_count'))

  trdt <- merge(all_trdt, rsemdt, by='trid', all.x=T)
  trdt[, `:=`( tss         = ifelse(strand == '+', start, end),
               is_training = ifelse(trid %in% training_trdt[, trid], 1, 0) )]

  tssdt  <- trdt[, list(chrom, tss, trid)]
  tssdt[,  `:=`( start = tss - flanking_width,
                 end   = tss + flanking_width ) ]

  infodt <- fread(finfo, header=T, sep="\t")
  dum <- mclapply(infodt[, targetid], prepTSSSignalsFeatures, tssdt,
                  infodt, trdt, all_trdt, flanking_width,
                  cap_stacked_chipseq_reads, n_max_stacked_chipseq_reads,
                  mc.cores=nthr)
 #dum <- lapply(infodt[, targetid], prepTSSSignalsFeatures, tssdt,
 #              infodt, trdt, all_trdt, flanking_width,
 #              cap_stacked_chipseq_reads, n_max_stacked_chipseq_reads)
}


prepTSSSignalsFeatures <- function(tgtid, tssdt, infodt, trdt, all_trdt,
                                   flanking_width, is_cap, n_max_cap) {
  faln <- subset(infodt, targetid == tgtid)[, faln]
  fout <- subset(infodt, targetid == tgtid)[, fftrs]
  allrddt <- fread(paste0('zcat ',faln), header=F, sep="\t",
                   select=c('V1', 'V2', 'V3', 'V6'))
  setnames(allrddt, 1:4, c('chrom', 'start', 'end', 'strand'))

  if ( is_cap == 'True' ) {
    ## keep at most 5 reads per strand-specific interval
    allrddt[, dupi := seq_len(.N), by=list(chrom, start, end, strand)]
    rddt <- subset(allrddt, dupi <= n_max_cap)
    rddt[, dupi := NULL]
  } else {
    rddt <- allrddt
  }

  ## since no peak is called here, just use the average read length as fraglen
  ## count # of reads as signals rather than # of overlapping nucleotide
  ## normalize by TSS interval length and read depth to RPKM
  tssgrs <- makeGRangesFromDataFrame(tssdt, keep.extra.columns=T)
  rdgrs  <- makeGRangesFromDataFrame(rddt,  keep.extra.columns=T)

  ol <- findOverlaps(rdgrs, tssgrs, type='within', ignore.strand=T)
  oldt <- data.table(query=queryHits(ol), subject=subjectHits(ol))
  oldt[, trid := tssdt[, trid][subject]]
  nrddt <- oldt[, list(nrd = .N), by=trid]

  trdt <- merge(trdt, nrddt, by='trid', all.x=T)

  n_tot_rds <- length(rdgrs)
  trdt[, `:=`( tss_sig = ifelse(is.na(nrd), 0,
                                nrd*1e+9/(flanking_width*2+1)/n_tot_rds),
               is_expr = ifelse(pme_count > 0 & pme_TPM >= 1, 1, 0) )]

  setkey(trdt, trid)
  trdt <- trdt[all_trdt[, trid]] ## keep the order of original trids
  write.table(trdt, fout, quote=F, sep="\t", col.names=T, row.names=F)
}


prepPeakSignalGCLenFeatures <- function(argv=NA){
  libloc            <- argv[1]
  fall_tr_crd       <- argv[2]
  ftraining_tr_crd  <- argv[3]
  fout              <- argv[4]
  fisoforms_results <- argv[5]
  flanking_width    <- as.numeric(argv[6])
  partition_model   <- argv[7]
  fchipseq_peaks    <- argv[8]
  fchipseq_target_signals <- argv[9]
  fall_tr_gc        <- argv[10]
  nthr              <- argv[11]
  fraglen           <- as.numeric(argv[12])

# libloc            <- '/ua/pliu/dev/RSEM/pRSEM/RLib/'
# fall_tr_crd       <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/test.temp/test_prsem.all_tr_crd'
# ftraining_tr_crd  <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/test.temp/test_prsem.training_tr_crd'
# fout              <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/test.temp/test_prsem.all_tr_features'
# fisoforms_results <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/test.isoforms.results'
# flanking_width    <- 500
# partition_model   <- 'lm4'
# fchipseq_peaks    <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/test.temp/idr_target_vs_control.regionPeak.gz'
# fchipseq_target_signals <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/test.temp/target.tagAlign.gz'
# fall_tr_gc        <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/test.temp/test_prsem.all_tr_gc'
# nthr              <- 20
# fraglen           <- 110

# runid  <- 'lm4_k562rep1'
# exprdir <- paste0('/tier2/deweylab/scratch/pliu/test/pRSEM/', runid,
#                   '/rsem_expr/')
# tempdir <- paste0(exprdir, runid, '.temp/')
# libloc            <- '/ua/pliu/dev/RSEM/pRSEM/RLib/'
# fall_tr_crd       <- paste0(tempdir, runid, '_prsem.all_tr_crd')
##fall_tr_crd       <- paste0(tempdir, 'tmp.all_tr_crd')
# ftraining_tr_crd  <- paste0(tempdir, runid, '_prsem.training_tr_crd')
# fout              <- paste0('./', runid, '_prsem.all_tr_features')
# fisoforms_results <- paste0(exprdir, runid, '.isoforms.results')
# flanking_width    <- 500
# partition_model   <- 'lm4'
# fchipseq_peaks    <- paste0(tempdir, 'idr_target_vs_control.regionPeak.gz')
# fchipseq_target_signals <- paste0(tempdir, 'target.tagAlign.gz')
##fchipseq_target_signals <- paste0(tempdir, 'tmp.chrX.tagAlign.gz')
# fall_tr_gc        <- paste0(tempdir, runid, '_prsem.all_tr_gc')
# nthr              <- 20
# fraglen           <- 110

  .libPaths(c(libloc, .libPaths()))
  suppressMessages(library(data.table))
  suppressMessages(library(GenomicRanges))

  all_trdt <- fread(fall_tr_crd, header=T, sep="\t")

  rsemdt <- fread(fisoforms_results, header=T, sep="\t", select=c(
                  'transcript_id', 'effective_length', 'posterior_mean_count'))
  setnames(rsemdt, 1:3, c('trid', 'efflen',  'pme_count'))

  gcdt <- fread(fall_tr_gc, header=T, sep="\t")

  trdt <- merge(all_trdt, rsemdt, by='trid', all.x=T)
  trdt <- merge(trdt, gcdt, by='trid', all.x=T)

  trdt[, `:=`( tss = ifelse(strand == '+', start, end  ),
               tes = ifelse(strand == '+', end,   start))]
  tssdt  <- trdt[, list(chrom, tss, trid)]
  bodydt <- trdt[, list(chrom, start, end, trid)]
  tesdt  <- trdt[, list(chrom, tes, trid)]

  tssdt[,  `:=`( start = tss - flanking_width,
                 end   = tss + flanking_width ) ]
  bodydt[, `:=`( body_start = start + flanking_width + 1,
                 body_end   = end   - flanking_width - 1)]
  bodydt[, `:=`( start = ifelse(body_start <= body_end, body_start, body_end),
                 end   = ifelse(body_start <= body_end, body_end, body_start))]
  tesdt[,  `:=`( start = tes - flanking_width,
                 end   = tes + flanking_width ) ]

  pkdt <- data.table(read.table(gzfile(fchipseq_peaks), header=F, sep="\t",
                                colClasses=c('character', 'numeric', 'numeric',
                                             rep('NULL', 7))))
  setnames(pkdt, 1:3, c('chrom', 'start', 'end'))

  has_tss_pk_trids  <- getRegionPeakOLTrID(tssdt,  pkdt)
  has_body_pk_trids <- getRegionPeakOLTrID(bodydt, pkdt)
  has_tes_pk_trids  <- getRegionPeakOLTrID(tesdt,  pkdt)

  rddt <- data.table(read.table(gzfile(fchipseq_target_signals), header=F,
                                sep="\t", colClasses=c('character', 'numeric',
                                'numeric', rep('NULL', 2), 'character')))
  setnames(rddt, 1:4, c('chrom', 'start', 'end', 'strand'))
  tss_sigdt  <- countRegionSignal(tssdt,  rddt, fraglen, nthr, 'tss')
  body_sigdt <- countRegionSignal(bodydt, rddt, fraglen, nthr, 'body')
  tes_sigdt  <- countRegionSignal(tesdt,  rddt, fraglen, nthr, 'tes')

  trdt <- merge(trdt, tss_sigdt,  by='trid', all.x=T)
  trdt <- merge(trdt, body_sigdt, by='trid', all.x=T)
  trdt <- merge(trdt, tes_sigdt,  by='trid', all.x=T)

  trdt[, `:=`(tss_sig  = ifelse(is.na(tss_sig), 0.0, tss_sig),
              body_sig = ifelse(is.na(body_sig), 0.0, body_sig),
              tes_sig  = ifelse(is.na(tes_sig),  0.0, tes_sig ))]

  training_trdt <- fread(ftraining_tr_crd, header=T, sep="\t", select='trid')
  trdt[, `:=`( tss_pk  = ifelse(trid %in% has_tss_pk_trids,  1, 0),
               body_pk = ifelse(trid %in% has_body_pk_trids, 1, 0),
               tes_pk  = ifelse(trid %in% has_tes_pk_trids,  1, 0),
               is_training = ifelse(trid %in% training_trdt[, trid], 1, 0))]

  setkey(trdt, trid)
  trdt <- trdt[all_trdt[, trid]] ## keep the order of original trids
  write.table(trdt, fout, quote=F, sep="\t", col.names=T, row.names=F)
}

#
#  need to modify the way to calculate signal as # of nuc from fragment rather
#  than the number of read overlapping with selected region
#
#  tagAlign list the read
#  '+' strand, [start, start + read_length]
#  '-' strand, [end - read_length, end]
#
#  1. extend read to fragment
#  2. find fragmens overlapping target region
#  3. remove fragments that have middle position outside target region (as how
#     dpeak works)
#  4. count number of fragment nucleotide and average it by target region's
#     width to get signal
#
countRegionSignal <- function(regiondt, readdt, fraglen, nthr, prefix=''){
  regiondtl <- split(regiondt[, list(chrom, start, end, trid)],
                     regiondt[, chrom])
  readdtl   <- split(readdt, readdt[, chrom])

 #outdt <- rbindlist( lapply(names(regiondtl), countRegionSignalByChrom,
 #                           regiondtl, readdtl, fraglen, prefix))

  outdt <- rbindlist( mclapply(names(regiondtl), countRegionSignalByChrom,
                               regiondtl, readdtl, fraglen, prefix,
                               mc.cores = nthr))
  return(outdt)
}


countRegionSignalByChrom <- function(chrom, regiondtl, readdtl, fraglen,
                                     prefix) {
  regiondt <- copy(regiondtl[[chrom]])
  readdt   <- copy(readdtl[[chrom]])

  readdt[, frag_start := ifelse(strand == '+', start, end-fraglen)]
  readdt[, frag_end := frag_start + fraglen - 1]

  fragdt <- readdt[, list(chrom, frag_start, frag_end)]
  setnames(fragdt, 2:3, c('start', 'end'))
  fraggrs <- makeGRangesFromDataFrame(fragdt, ignore.strand=T)

  regiongrs <- makeGRangesFromDataFrame(regiondt[, list(chrom, start, end,
                                                        trid)],
                                        keep.extra.columns=T, ignore.strand=T)

  ol <- findOverlaps(regiongrs, fraggrs, type='any', ignore.strand=T)
  oldt <- data.table(query=queryHits(ol), subject=subjectHits(ol))

  oldt[, `:=`( region_start = regiondt[, start][query],
               region_end   = regiondt[, end][query],
               trid         = regiondt[, trid][query],
               frag_start   = fragdt[, start][subject],
               frag_end     = fragdt[, end][subject] )]

  oldt[, frag_mid := (frag_start + frag_end)/2]

  ## as dpeak, only select fragment which has mid position falling into region
  seloldt <- subset(oldt, (frag_mid >= region_start) & (frag_mid <= region_end))

  seloldt[, `:=`(start = ifelse(frag_start < region_start, region_start,
                                frag_start),
                 end   = ifelse(frag_end   > region_end,   region_end,
                                frag_end))]

  sigdt <- seloldt[, list(nuc = sum(end - start + 1)), by=trid]
  sigdt <- merge(sigdt, regiondt, by='trid', all.x=T)
  colname <- paste0(prefix, '_sig')
  sigdt[, eval(colname) := nuc/(end - start + 1)]
  sigdt[, `:=`(nuc=NULL, chrom=NULL, start=NULL, end=NULL)]
  return(sigdt)
}


genPriorByTSSPeak <- function(argv=NA){
  libloc           <- argv[1]
  fall_tr_features <- argv[2]
  fpval_LL         <- argv[3]
  fall_tr_prior    <- argv[4]

# libloc           <- '/ua/pliu/dev/RSEM/pRSEM/RLib/'
# fall_tr_features <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/example.stat/example_prsem.all_tr_features'
# fpval_LL         <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/example.stat/example_prsem.pval_LL'
# fall_tr_prior    <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/example.stat/example_prsem.all_tr_prior'

  .libPaths(c(libloc, .libPaths()))
  suppressMessages(library(data.table))

  alldt <- fread(fall_tr_features, header=T, sep="\t")
  alldt[, partition := tss_pk]

  trndt <- subset(alldt, is_training == 1)
  outdt <- getSampleAndPriorByTSSPeak(trndt, alldt)

  wpk_cnt  <- subset(trndt, tss_pk == 1)[, pme_count]
  nopk_cnt <- subset(trndt, tss_pk == 0)[, pme_count]
  wrs <- suppressWarnings(wilcox.test(wpk_cnt, nopk_cnt, alternative='greater',
                                      paired=F, exact=T))
  pval <- wrs$p.value
  loglikelihood <- unique(outdt[, loglikelihood])
  pval_LLdt <- data.table(pvalue=pval, loglikelihood=loglikelihood)

  write.table(alldt, fall_tr_features, quote=F, sep="\t", col.names=T,
              row.names=F)
  write.table(pval_LLdt, fpval_LL, quote=F, sep="\t", col.names=T, row.names=F)
  write.table(outdt[, list(prior, trid)], fall_tr_prior, quote=F, sep="  # ",
              col.names=F, row.names=F)
}


prepTSSPeakFeatures <- function(argv=NA) {
  libloc            <- argv[1]
  fall_tr_crd       <- argv[2]
  ftraining_tr_crd  <- argv[3]
  fout              <- argv[4]
  fisoforms_results <- argv[5]
  flanking_width    <- as.numeric(argv[6])
  fchipseq_peaks    <- argv[7]

# libloc            <- '/ua/pliu/dev/RSEM/pRSEM/RLib/'
# fall_tr_crd       <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/example.temp/example_prsem.all_tr_crd'
# ftraining_tr_crd  <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/example.temp/example_prsem.training_tr_crd'
# fout              <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/example.temp/example_prsem.all_tr_features'
# fisoforms_results <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/example.isoforms.results'
# flanking_width <- 500
# fchipseq_peaks <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/example.temp/idr_target_vs_control.regionPeak.gz'

  .libPaths(c(libloc, .libPaths()))
  suppressMessages(library(data.table))
  suppressMessages(library(GenomicRanges))

  rsemdt <- fread(fisoforms_results, header=T, sep="\t",
                  select=c('transcript_id', 'posterior_mean_count'))
  setnames(rsemdt, 1:2, c('trid', 'pme_count'))

  intrdt <- fread(fall_tr_crd, header=T, sep="\t")
  trdt <- merge(intrdt, rsemdt, by='trid', all.x=T)
  trdt[, tss := ifelse(strand=='+', start, end)]
  tssdt <- trdt[, list(chrom, tss, trid)]
  tssdt[, `:=`( start = tss - flanking_width,
                end   = tss + flanking_width)]

  pkdt <- tryCatch({
    data.table(read.table(gzfile(fchipseq_peaks), header=F, sep="\t",
                          colClasses=c('character', 'numeric',
                                       'numeric', rep('NULL', 7))))
  }, error = function(err) {
    message(paste0("\nFail to read file: ", fchipseq_peaks, "\n"))
    message(err)
    return(NA)
  })

  setnames(pkdt, 1:3, c('chrom', 'start', 'end'))

  has_pk_trids <- getRegionPeakOLTrID(tssdt, pkdt)
  training_trids <- fread(ftraining_tr_crd, header=T, sep="\t", select='trid'
                         )[, trid]

  trdt[, `:=`( tss_pk      = ifelse(trid %in% has_pk_trids,   1, 0),
               is_training = ifelse(trid %in% training_trids, 1, 0) )]

  setkey(trdt, trid)
  trdt <- trdt[intrdt[, trid]]  ## keep the order of original trid
  write.table(trdt, fout, quote=F, sep="\t", col.names=T, row.names=F)
}


getRegionPeakOLTrID <- function(regiondt, peakdt) {
  regiongrs <- makeGRangesFromDataFrame(regiondt[, list(chrom, start, end,
                                                        trid)],
                                        keep.extra.columns=T, ignore.strand=T)

  peakgrs <- makeGRangesFromDataFrame(peakdt[, list(chrom, start, end)],
                                    ignore.strand=T)
  olgrs <- subsetByOverlaps(regiongrs, peakgrs, type='any', ignore.strand=T)
  has_peak_trids <- unique(mcols(olgrs)$trid)
  return(has_peak_trids)
}


selTrainingTr <- function(argv=NA) {
  libloc   <- argv[1]
  fin_tr   <- argv[2]
  fin_exon <- argv[3]
  min_mpp  <- as.numeric(argv[4])
  flanking_width <- as.numeric(argv[5])
  fout     <- argv[6]

# libloc   <- '/ua/pliu/dev/RSEM/pRSEM/RLib/'
# fin_tr   <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/test.temp/test_prsem.all_tr_crd'
# fin_exon <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/test.temp/test_prsem.all_exon_crd'
# min_mpp  <- 0.8
# flanking_width <- 500
# fout     <- '/tier2/deweylab/scratch/pliu/dev/pRSEM/rsem_expr/test.temp/test_prsem.training_tr_crd'

  .libPaths(c(libloc, .libPaths()))
  suppressMessages(library(data.table))
  suppressMessages(library(GenomicRanges))

  alltrdt <- fread(fin_tr, header=T, sep="\t")
  alltrdt[, tss := ifelse(strand == '+', start, end)]
  highmppdt <- subset(alltrdt, (! is.na(tss_mpp )) & ( tss_mpp  > min_mpp ) &
                               (! is.na(body_mpp)) & ( body_mpp > min_mpp ) &
                               (! is.na(tes_mpp )) & ( tes_mpp  > min_mpp ) )

  ## select tr that are not nested with other tr regardless of strand
  nested_trids <- getTrTrOLTrID(highmppdt, alltrdt, oltype='within',
                                ignore_strand=T)
  not_nested_trdt <- subset(highmppdt, ! trid %in% nested_trids)

  ## select tr that not have exon all nested with the union of other tr's exons
  ## regardless of strand
  allexondt <- fread(fin_exon, header=T, sep="\t")
  exon_all_ol_trids <- getExonsAllOLTrID(not_nested_trdt[, trid], allexondt)
  seltrdt <- subset(not_nested_trdt, ! trid %in% exon_all_ol_trids)

  seltr_tss_region_dt <- copy(seltrdt)
  seltr_tss_region_dt[, `:=`( start = tss - flanking_width,
                              end   = tss + flanking_width )]

  alltr_tss_dt <- copy(alltrdt)
  alltr_tss_dt[, `:=`(start = tss, end=tss)]

  tss_region_ol_trids <- getTrTrOLTrID(seltr_tss_region_dt, alltr_tss_dt,
                                       'any', ignore_strand=T)

  outdt <- subset(seltrdt, ! trid %in% tss_region_ol_trids)
  write.table(outdt, fout, quote=F, sep="\t", col.names=T, row.names=F)
}


getExonsAllOLTrID <- function(query_trids, allexondt) {
  allexongrs <- makeGRangesFromDataFrame(allexondt, keep.extra.columns=T,
                                         ignore.strand=F)
  queryexongrs <- subset(allexongrs, mcols(allexongrs)$trid %in% query_trids)
  ol <- findOverlaps(queryexongrs, allexongrs, type='within', ignore.strand=T)

  oldt <- data.table(query = queryHits(ol), subject=subjectHits(ol))
  oldt[, `:=`( query_trid = mcols(queryexongrs)$trid[query],
               query_exon_index = mcols(queryexongrs)$exon_index[query],
               subject_trid = mcols(allexongrs)$trid[subject]
             )]
  oldt <- subset(oldt, query_trid != subject_trid)
  nolexondt <- oldt[, list(nolexon = length(unique(query_exon_index))),
                      by=query_trid]
  subexondt  <- subset(allexondt, trid %in% nolexondt[, query_trid])
  subnexondt <- subexondt[, list(nexon = length(unique(exon_index))), by=trid]
  setnames(nolexondt, 1, 'trid')
  nolexondt <- merge(nolexondt, subnexondt, by='trid', all.x=T)
  exon_all_ol_trids <- subset(nolexondt, nolexon == nexon)[, trid]

  return(exon_all_ol_trids)
}


getTrTrOLTrID <- function(querydt, subjectdt, oltype, ignore_strand) {
  querygrs <- makeGRangesFromDataFrame(
                  querydt[, list(chrom, strand, start, end, trid)],
                  keep.extra.columns=T, ignore.strand=F)
  subjectgrs <- makeGRangesFromDataFrame(
                  subjectdt[, list(chrom, strand, start, end, trid)],
                  keep.extra.columns=T, ignore.strand=F)

  ol <- findOverlaps(querygrs, subjectgrs, type=oltype,
                     ignore.strand=ignore_strand)

  oldt <- data.table(query=queryHits(ol), subject=subjectHits(ol))
  oldt[, `:=`(query_trid   = mcols(querygrs)$trid[query],
              subject_trid = mcols(subjectgrs)$trid[subject] )]
  ol_trids <- subset(oldt, query_trid != subject_trid)[, query_trid]
  return(unique(ol_trids))
}


rdirichlet_multinomial <- function(alpha, n) {
  theta <- rdirichlet(alpha)
  return(as.vector(rmultinom(1, n, theta)))
}


rdirichlet <- function(alpha) {
  x <- rgamma(length(alpha), alpha)
  return(x / sum(x))
}


getFitByMLDM <- function(counts, partition) {
  initial_alpha <- rep(1, nlevels(partition))
  fit <- optim(initial_alpha,
               partitioned_log_likelihood,
               partitioned_log_likelihood_gradient,
               counts=counts,
               partition=partition,
               method="L-BFGS-B",
               lower=0.0001,
               upper=1e+4,
               control=list(fnscale=-1))

  return(fit)
}


getSampleByDM <- function(par, counts, partition) {
  ml_alpha <- par
  names(ml_alpha) <- levels(partition)

  alpha <- ml_alpha[partition]
  sample <- rdirichlet_multinomial(alpha, sum(counts))
  return(sample)
}


partitioned_log_likelihood <- function(alpha, counts, partition) {

  component_counts <- table(partition)
  N <- sum(counts)

  return(lgamma(N + 1) - sum(lgamma(counts + 1)) +
         lgamma(component_counts %*% alpha) -
         lgamma(N + component_counts %*% alpha) +
         sum(lgamma(counts + alpha[partition])) -
         component_counts %*% lgamma(alpha))
}


partitioned_log_likelihood_gradient <- function(alpha, counts, partition) {

  component_counts <- table(partition)

  N <- sum(counts)
  alpha_sum <- sum(component_counts * alpha)

  return(component_counts * (digamma(alpha_sum) -
                             digamma(N + alpha_sum) -
                             digamma(alpha)) +
         tapply(digamma(counts + alpha[partition]), partition, sum))
}


#
# create a new partition with give parition and data
# the breaks from old partition will be kept
# lower and upper bounds will be from give data
#
createPartitionForNewData <- function(partition, data){
  labs <- levels(partition)
  lower <- as.numeric( sub("\\((.+),.*", "\\1", labs) )
  data_range <- range(data)
  eps <- 1.0e-4
  lower[1] <- data_range[1] - eps
  breaks <- c(lower, data_range[2] + eps)
  new_partition <- cut(data, breaks)

  return(new_partition)
}


#getSampleAndPriorByOnePartition <- function(trndt, tstdt) {
# trn_partition <- factor(rep(0, nrow(trndt)))
# fit <- getFitByMLDM(trndt[, pme_count], trn_partition)

##cat('priors:', format(fit$par, digits=2, nsmall=3), "\n")
#
# tst_partition <- factor(rep(0, nrow(tstdt)))
# prior <- fit$par[tst_partition]

# outdt <- tstdt[, list(trid, pme_count)]
# outdt[, `:=`(partition = tst_partition,
#              sample    = getSampleByDM(fit$par, pme_count, tst_partition),
#              prior     = prior)]

##cat("training set's partition:")
##print(table(trn_partition))
##cat("testing set's prior:")
##print(table(prior))

# return(outdt)
#}


getSampleAndPriorByTSSPeak <- function(trndt, tstdt) {
  trn_partition <- factor(trndt[, tss_pk])
  fit <- getFitByMLDM(trndt[, pme_count], trn_partition)

  tst_partition <- factor(tstdt[, tss_pk])
  prior <- fit$par[tst_partition]

  outdt <- tstdt[, list(trid, pme_count)]
  outdt[, `:=`(partition = tst_partition,
               sample    = getSampleByDM(fit$par, pme_count, tst_partition),
               prior     = prior,
               loglikelihood = fit$value )]

  cat("training set's partition:")
  print(table(trn_partition))
  cat("testing set's prior:")
  print(table(prior))

  return(outdt)
}


getSampleAndPriorByLM <- function(trndt, tstdt, nbin=NULL) {
	if (is.null(nbin)) nbin=3
  frm <- formula( paste0('log10_count~',
         'tss_pk  + tss_pk:log10_tss_sig   + no_tss_pk:log10_tss_sig   +',
         'body_pk + body_pk:log10_body_sig + no_body_pk:log10_body_sig +',
         'tes_pk  + tes_pk:log10_tes_sig   + no_tes_pk:log10_tes_sig   +',
         'log10_eff_len + log10_GC_ov_mean') )

  trn_lm <- lm(frm, trndt)
  trn_prd <- as.vector(predict(trn_lm, trndt))
  trn_partition <- cut(trn_prd, nbin)

	fit <- getFitByMLDM(trndt[, pme_count], trn_partition)

	tst_prd <- as.vector(predict(trn_lm, tstdt))
	tst_partition <- createPartitionForNewData(trn_partition, tst_prd)

	prior <- fit$par[tst_partition]

  outdt <- tstdt[, list(trid, pme_count)]
  outdt[, `:=`(partition = tst_partition,
               sample    = getSampleByDM(fit$par, pme_count, tst_partition),
               prior     = prior)]

  cat("training set's partition:")
  print(table(trn_partition))
  cat("testing set's prior:")
  print(table(prior))

  return(outdt)
}


getSampleAndPriorByPeakLM <- function(trndt, tstdt, nbin=NULL, lm_on_wpk=NULL) {
	if (is.null(nbin)) nbin=2
  if (is.null(lm_on_wpk)) lm_on_wpk=T
  lm_pk_type <- ifelse(lm_on_wpk, 1, 0)

	slim_trndt <- trndt[, list(trid, pme_count, tss_pk)]
	slim_tstdt <- tstdt[, list(trid, pme_count, tss_pk)]

  frm <- formula( paste0('log10_count~',
         'log10_tss_sig +',
         'body_pk + body_pk:log10_body_sig + no_body_pk:log10_body_sig +',
         'tes_pk  + tes_pk:log10_tes_sig   + no_tes_pk:log10_tes_sig   +',
         'log10_eff_len + log10_GC_ov_mean') )

	pk_trn_dt <- subset(trndt, tss_pk == lm_pk_type)
	pk_trn_lm <- lm(frm, pk_trn_dt)
	pk_trn_prd <- as.vector(predict(pk_trn_lm, pk_trn_dt))
	pk_trn_partition <- cut(pk_trn_prd, nbin)
	pk_trn_dt[, partition:=pk_trn_partition]

  slim_trndt <- merge(slim_trndt, pk_trn_dt[, list(trid, partition)], by='trid',
                      all=T)
  slim_trndt <- slim_trndt[trndt[,trid]]

	slim_trndt[, partition:=factor(ifelse(tss_pk==(1-lm_pk_type), 0, partition))]

	fit <- getFitByMLDM(slim_trndt[, pme_count], slim_trndt[, partition])

	pk_tst_dt <- subset(tstdt, tss_pk == lm_pk_type)
	pk_tst_prd <- as.vector(predict(pk_trn_lm, pk_tst_dt))
	pk_tst_partition <- createPartitionForNewData(pk_trn_partition,
	                                                   pk_tst_prd)
	pk_tst_dt[, partition:=pk_tst_partition]

  slim_tstdt <- merge(slim_tstdt, pk_tst_dt[, list(trid, partition)], by='trid',
                      all=T)
  slim_tstdt <- slim_tstdt[tstdt[,trid]]
	slim_tstdt[, partition:=factor(ifelse(tss_pk==(1-lm_pk_type), 0, partition))]
	prior <- fit$par[slim_tstdt[, partition]]

  outdt <- slim_tstdt[, list(trid, pme_count, partition)]
  outdt[, `:=`(sample = getSampleByDM(fit$par, pme_count, partition),
               prior  = prior)]

  cat("training set's partition:")
  print(table(slim_trndt[,partition]))
  cat("testing set:")
  print(table(prior))
  cat("\n")

	return(outdt)
}


getSampleAndPriorByPeakLogitNoPeak <- function(trndt, tstdt) {
	slim_trndt <- trndt[, list(trid, pme_count, tss_pk)]
	slim_tstdt <- tstdt[, list(trid, pme_count, tss_pk)]

  setkey(slim_trndt, trid)
  setkey(slim_tstdt, trid)

	nopk_trn_dt <- subset(trndt, tss_pk == 0)
	nopk_tst_dt <- subset(tstdt, tss_pk == 0)
	nopk_trn_dt[, has_count:=ifelse(pme_count > 0, 1, 0)]
	nopk_tst_dt[, has_count:=ifelse(pme_count > 0, 1, 0)]

  frm <- formula( paste0('has_count~',
         'log10_tss_sig +',
         'body_pk + body_pk:log10_body_sig + no_body_pk:log10_body_sig +',
         'tes_pk  + tes_pk:log10_tes_sig   + no_tes_pk:log10_tes_sig   +',
         'log10_eff_len + log10_GC_ov_mean') )
	prt_levels <- c('no pk, no cnt', 'no pk, has cnt', 'w/ pk')

	nopk_trn_glm <- glm(frm, data=nopk_trn_dt, family='binomial')
	trn_prob <- predict(nopk_trn_glm, nopk_trn_dt, type='response')
	nopk_trn_dt[, `:=`(logit_prob=trn_prob,
	                   partition=ifelse(trn_prob > 0.5, 'no pk, has cnt',
										                  'no pk, no cnt') )]

  slim_trndt <- merge(slim_trndt,
                      nopk_trn_dt[, list(trid, partition, logit_prob)],
                      by='trid', all=T)
  slim_trndt <- slim_trndt[trndt[, trid]]

	slim_trndt[, partition:=factor(ifelse(tss_pk==1, 'w/ pk', partition),
	                               levels=prt_levels)]


	fit <- getFitByMLDM(slim_trndt[, pme_count], slim_trndt[, partition])

	tst_prob <- predict(nopk_trn_glm, nopk_tst_dt, type='response')
	nopk_tst_dt[, `:=`(logit_prob=tst_prob,
	                   partition=ifelse(tst_prob > 0.5, 'no pk, has cnt',
										                  'no pk, no cnt'))]

  slim_tstdt <- merge(slim_tstdt,
                      nopk_tst_dt[, list(trid, partition, logit_prob)],
                      by='trid', all=T)
  slim_tstdt <- slim_tstdt[tstdt[, trid]]
	slim_tstdt[, partition:=factor(ifelse(tss_pk==1, 'w/ pk', partition),
	                               levels=prt_levels)]

	prior <- fit$par[slim_tstdt[, partition]]

  outdt <- slim_tstdt[, list(trid, pme_count, partition)]
  outdt[, `:=`(sample = getSampleByDM(fit$par, pme_count, partition),
               prior  = prior)]

  cat("training set's partition:")
  print(table(slim_trndt[,partition]))
  cat("testing set:")
  print(table(prior))
  cat("\n")

	return(outdt)
}


getSampleAndPriorByLM3 <- function(trndt, tstdt) {
	return(getSampleAndPriorByLM(trndt, tstdt, nbin=3))
}

getSampleAndPriorByLM4 <- function(trndt, tstdt) {
	return(getSampleAndPriorByLM(trndt, tstdt, nbin=4))
}

getSampleAndPriorByLM5 <- function(trndt, tstdt) {
	return(getSampleAndPriorByLM(trndt, tstdt, nbin=5))
}

getSampleAndPriorByLM6 <- function(trndt, tstdt) {
	return(getSampleAndPriorByLM(trndt, tstdt, nbin=6))
}


getSampleAndPriorByNoPeakLM2Peak <- function(trndt, tstdt) {
	return(getSampleAndPriorByPeakLM(trndt, tstdt, nbin=2, lm_on_wpk=T))
}

getSampleAndPriorByNoPeakLM3Peak <- function(trndt, tstdt) {
	return(getSampleAndPriorByPeakLM(trndt, tstdt, nbin=3, lm_on_wpk=T))
}

getSampleAndPriorByNoPeakLM4Peak <- function(trndt, tstdt) {
	return(getSampleAndPriorByPeakLM(trndt, tstdt, nbin=4, lm_on_wpk=T))
}

getSampleAndPriorByNoPeakLM5Peak <- function(trndt, tstdt) {
	return(getSampleAndPriorByPeakLM(trndt, tstdt, nbin=5, lm_on_wpk=T))
}


getSampleAndPriorByPeakLM2NoPeak <- function(trndt, tstdt) {
	return(getSampleAndPriorByPeakLM(trndt, tstdt, nbin=2, lm_on_wpk=F))
}

getSampleAndPriorByPeakLM3NoPeak <- function(trndt, tstdt) {
	return(getSampleAndPriorByPeakLM(trndt, tstdt, nbin=3, lm_on_wpk=F))
}

getSampleAndPriorByPeakLM4NoPeak <- function(trndt, tstdt) {
	return(getSampleAndPriorByPeakLM(trndt, tstdt, nbin=4, lm_on_wpk=F))
}

getSampleAndPriorByPeakLM5NoPeak <- function(trndt, tstdt) {
	return(getSampleAndPriorByPeakLM(trndt, tstdt, nbin=5, lm_on_wpk=F))
}


main()
#selTrainingTr()
#prepTSSPeakFeatures()
#genPriorByTSSPeak()
#prepPeakSignalGCLenFeatures()
#genPriorByPeakSignalGCLen()
#prepTSSSignalFeatures()
#genPriorByCombinedTSSSignals()
#prepMultiTargetsFeatures()

# modified by pliu
#
# revised on 2-20-10
# - fix error in pass.structure: reverse rank.combined, so that big sig.value
#  are ranked with small numbers (1, 2, ...)
# - fix error on get.ez.tt.all: get ez.cutoff from sorted e.z

#
# modified EM procedure to compute empirical CDF more precisely - 09/2009



# this file contains the functions for  
# 1. computing the correspondence profile (upper rank intersection and derivatives)
# 2. inference of copula mixture model
#
# It also has functions for
# 1. reading peak caller results
# 2. processing and matching called peaks
# 3. plotting results


################ read peak caller results

# process narrow peak format
# some peak callers may not report q-values, p-values or fold of enrichment
# need further process before comparison
#
# stop.exclusive: Is the basepair of peak.list$stop exclusive? In narrowpeak and broadpeak format they are exclusive.
# If it is exclusive, we need subtract peak.list$stop by 1 to avoid the same basepair being both a start and a stop of two 
# adjacent peaks, which creates trouble for finding correct intersect  
process.narrowpeak <- function(narrow.file, chr.size, half.width=NULL, summit="offset", stop.exclusive=T, broadpeak=F){

  ## pliu 20150607 
  ## to read gzipped files
  library(tools)
  narrow.file.ext <- file_ext(narrow.file)
  if ( narrow.file.ext %in% c('gz', 'gzip') ) {
    aa <- read.table(gzfile(narrow.file))
  } else {
    aa <- read.table(narrow.file)
  }
 #aa <- read.table(narrow.file)
  ######

  if(broadpeak){
    bb.ori <- data.frame(chr=aa$V1, start=aa$V2, stop=aa$V3, signal.value=aa$V7, p.value=aa$V8, q.value=aa$V9)
  }else{
    bb.ori <- data.frame(chr=aa$V1, start=aa$V2, stop=aa$V3, signal.value=aa$V7, p.value=aa$V8, q.value=aa$V9, summit=aa$V10)
  }
    
  if(summit=="summit"){
    bb.ori$summit <- bb.ori$summit-bb.ori$start # change summit to offset to avoid error when concatenating chromosomes
  }
 
  bb <- concatenate.chr(bb.ori, chr.size)

  #bb <- bb.ori

  # remove the peaks that has the same start and stop value
  bb <- bb[bb$start != bb$stop,]

  if(stop.exclusive==T){
    bb$stop <- bb$stop-1
  }

  if(!is.null(half.width)){
    bb$start.ori <- bb$start    #Anshul changed this
    bb$stop.ori <- bb$stop 	#Anshul changed this

    # if peak is narrower than the specified window, stay with its width
    # otherwise chop wider peaks to specified width
    width <- bb$stop-bb$start +1
    is.wider <- width > 2*half.width

    if(summit=="offset" | summit=="summit"){ # if summit is offset from start
      bb$start[is.wider] <- bb$start.ori[is.wider] + bb$summit[is.wider]-half.width
      bb$stop[is.wider] <- bb$start.ori[is.wider] + bb$summit[is.wider]+half.width
    } else { 
      if(summit=="unknown"){
        bb$start[is.wider] <- bb$start.ori[is.wider]+round(width[is.wider]/2) - half.width
        bb$stop[is.wider] <- bb$start.ori[is.wider]+round(width[is.wider]/2) + half.width
      }
    }

    bb$start.ori <- bb.ori$start    #Anshul changed this
    bb$stop.ori <- bb.ori$stop      #Anshul changed this
  }

  bb <- clean.data(bb)
  invisible(list(data.ori=bb.ori, data.cleaned=bb))
}

# clean data 
# and concatenate chromosomes if needed
clean.data <- function(adata){

  # remove the peaks that has the same start and stop value
  adata <- adata[adata$start != adata$stop,]

  # if some stops and starts are the same, need fix them
  stop.in.start <- is.element(adata$stop, adata$start)
  n.fix <- sum(stop.in.start)
  if(n.fix >0){
    print(paste("Fix", n.fix, "stops\n"))
    adata$stop[stop.in.start] <- adata$stop[stop.in.start]-1 
  }  
 
  return(adata) 
}

# concatenate peaks
# peaks: the dataframe to have all the peaks
# chr.file: the file to keep the length of each chromosome 
# chr files should come from the species that the data is from
#concatenate.chr <- function(peaks, chr.size){

 # chr.size <- read.table(chr.file)
#  chr.o <- order(chr.size[,1])
#  chr.size <- chr.size[chr.o,]
#
#  chr.shift <- cumsum(c(0, chr.size[-nrow(chr.size),2]))
#  chr.size.cum <- data.frame(chr=chr.size[,1], shift=chr.shift)  
#
#  for(i in 1:nrow(chr.size)){
#    is.in <- as.character(peaks$chr) == as.character(chr.size.cum$chr[i])
#    if(sum(is.in)>0){
#      peaks[is.in,]$start <- peaks[is.in,]$start + chr.size.cum$shift[i]
#      peaks[is.in,]$stop <- peaks[is.in,]$stop + chr.size.cum$shift[i]
#    }
#  }
#
#  invisible(peaks)
#}




# concatenate peaks
# peaks: the dataframe to have all the peaks
# chr.file: the file to keep the length of each chromosome 
# chr files should come from the species that the data is from
concatenate.chr <- function(peaks, chr.size){

 # chr.size <- read.table(chr.file)
  chr.o <- order(chr.size[,1])
  chr.size <- chr.size[chr.o,]

  chr.shift <- cumsum(c(0, chr.size[-nrow(chr.size),2]))
  chr.size.cum <- data.frame(chr=chr.size[,1], shift=chr.shift)  

  peaks$start.ori <- peaks$start
  peaks$stop.ori <- peaks$stop
  
  for(i in 1:nrow(chr.size)){
    is.in <- as.character(peaks$chr) == as.character(chr.size.cum$chr[i])
    if(sum(is.in)>0){
      peaks[is.in,]$start <- peaks[is.in,]$start + chr.size.cum$shift[i]
      peaks[is.in,]$stop <- peaks[is.in,]$stop + chr.size.cum$shift[i]
    }
  }

  invisible(peaks)
}


deconcatenate.chr <- function(peaks, chr.size){

  chr.o <- order(chr.size[,1])
  chr.size <- chr.size[chr.o,]

  chr.shift <- cumsum(c(0, chr.size[-nrow(chr.size),2]))
  chr.size.cum <- data.frame(chr=chr.size[,1], shift=chr.shift)  

  peaks$chr <- rep(NA, nrow(peaks))
  
  for(i in 1:(nrow(chr.size.cum)-1)){
    is.in <- peaks$start > chr.size.cum[i,2] & peaks$start <= chr.size.cum[i+1, 2]
    if(sum(is.in)>0){
      peaks[is.in,]$start <- peaks[is.in,]$start - chr.size.cum[i,2]
      peaks[is.in,]$stop <- peaks[is.in,]$stop - chr.size.cum[i,2]+1    
      peaks[is.in,]$chr <- chr.size[i,1]
    }
  }

  if(i == nrow(chr.size.cum)){
    is.in <- peaks$start > chr.size.cum[i, 2]
    if(sum(is.in)>0){
      peaks[is.in,]$start <- peaks[is.in,]$start - chr.size.cum[i,2]
      peaks[is.in,]$stop <- peaks[is.in,]$stop - chr.size.cum[i,2]+1    
      peaks[is.in,]$chr <- chr.size[i,1]
    }
  }
  
  invisible(peaks)
}

################ preprocessing peak calling output


# 
# read two calling results and sort by peak starting locations, 
# then find overlap between peaks
# INPUT:
#   rep1: the 1st replicate
#   rep2: the 2nd replicate
# OUTPUT:
#   id1, id2: the labels for the identified peaks on the replicates
find.overlap <- function(rep1, rep2){

  o1 <- order(rep1$start)
  rep1 <- rep1[o1,]
    
  o2 <- order(rep2$start)
  rep2 <- rep2[o2,]

  n1 <- length(o1)
  n2 <- length(o2)
  
  # assign common ID to peaks
  id1 <- rep(0, n1) # ID assigned on rep1
  id2 <- rep(0, n2) # ID assigned on rep2
  id <- 1 # keep track common id's
  
  # check if two replicates overlap with each other
  i <- 1
  j <- 1

  while(i <= n1|| j <= n2){

    # && (id1[n1] ==0 || id2[n2] ==0)
    
    # if one list runs out
    if(i > n1 && j < n2){
      
      j <- j+1
      id2[j] <- id
      id <- id +1
      next
    } else{
      if(j > n2 && i < n1){
        i <- i+1        
        id1[i] <- id
        id <- id +1
        next
      } else {
        if(i >= n1 && j >=n2)
          break
      }
    }

    # if not overlap

    if(!(rep1$start[i] <= rep2$stop[j] && rep2$start[j] <= rep1$stop[i])){

      # at the start of loop, when both are not assigned an ID
      # the one locates in front is assigned first
      if(id1[i] ==0 && id2[j]==0){
        if(rep1$stop[i] < rep2$stop[j]){
          id1[i] <- id
        } else {
          id2[j] <- id
        }
      } else { # in the middle of the loop, when one is already assigned
      # The one that has not assigned gets assigned
      #  if(id1[i] ==0){ # id1[i] is not assigned
      #    id1[i] <- id
      #  } else { # id2[i] is not assigned
      #    id2[j] <- id 
      #  }

        # order the id according to location
        if(rep1$stop[i] <= rep2$stop[j]){
          id1[i] <- max(id2[j], id1[i])
          id2[j] <- id  
        } else {
          if(rep1$stop[i] > rep2$stop[j]){
            id2[j] <- max(id1[i], id2[j])
            id1[i] <- id
          }
        }
          
      }
      
      id <- id +1
      
    } else { # if overlap
    
      if(id1[i] == 0 && id2[j] == 0){ # not assign label yet
        id1[i] <- id 
        id2[j] <- id
        id <- id +1
      } else { # one peak is already assigned label, the other is 0
        
        id1[i] <- max(id1[i], id2[j]) # this is a way to copy the label of the assigned peak without knowing which one is already assigned
        id2[j] <- id1[i] # syncronize the labels        
      }
      
    }
    
    if(rep1$stop[i] < rep2$stop[j]){
      i <- i+1
    } else {
      j <- j+1
    } 
    
  }

  invisible(list(id1=id1, id2=id2))
  
}

# Impute the missing significant value for the peaks called only on one replicate.
# value 
# INPUT:
#   rep1, rep2: the two peak calling output 
#   id1, id2: the IDs assigned by function find.overlap, vectors
#        If id1[i]==id2[j], peak i on rep1 overlaps with peak j on rep2
#   p.value.impute: the significant value to impute for the missing peaks 
# OUTPUT:   
#   rep1, rep2: peaks ordered by the start locations with imputed peaks
#   id1, id2: the IDs with imputed peaks
fill.missing.peaks <- function(rep1, rep2, id1, id2, p.value.impute){

#   rep1 <- data.frame(chr=rep1$chr, start=rep1$start, stop=rep1$stop, sig.value=rep1$sig.value)
#   rep2 <- data.frame(chr=rep2$chr, start=rep2$start, stop=rep2$stop, sig.value=rep2$sig.value)   
   
   o1 <- order(rep1$start)
   rep1 <- rep1[o1,]
    
   o2 <- order(rep2$start)
   rep2 <- rep2[o2,]  
     
   entry.in1.not2 <- !is.element(id1, id2)
   entry.in2.not1 <- !is.element(id2, id1)

   if(sum(entry.in1.not2) > 0){
   
     temp1 <- rep1[entry.in1.not2, ]

     # impute sig.value
     temp1$sig.value <- p.value.impute
     temp1$signal.value <- p.value.impute
     temp1$p.value <- p.value.impute
     temp1$q.value <- p.value.impute
     
     rep2.filled <- rbind(rep2, temp1)
     id2.filled <- c(id2, id1[entry.in1.not2])
   } else {
     id2.filled <- id2
     rep2.filled <- rep2
   }

   if(sum(entry.in2.not1) > 0){

     temp2 <- rep2[entry.in2.not1, ]

     # fill in p.values to 1
     temp2$sig.value <- p.value.impute
     temp2$signal.value <- p.value.impute
     temp2$p.value <- p.value.impute
     temp2$q.value <- p.value.impute
   

     # append to the end
     rep1.filled <- rbind(rep1, temp2)

     id1.filled <- c(id1, id2[entry.in2.not1])
   } else {
     id1.filled <- id1
     rep1.filled <- rep1
   }

   # sort rep1 and rep2 by the same id
   o1 <- order(id1.filled)
   rep1.ordered <- rep1.filled[o1, ]

   o2 <- order(id2.filled)
   rep2.ordered <- rep2.filled[o2, ]   
   
   invisible(list(rep1=rep1.ordered, rep2=rep2.ordered,
                  id1=id1.filled[o1], id2=id2.filled[o2]))
 }

# Merge peaks with same ID on the same replicates 
# (They are generated if two peaks on rep1 map to the same peak on rep2)
# need peak.list have 3 columns: start, stop and sig.value 
merge.peaks.best <- function(peak.list, id){

  i <- 1
  j <- 1
  dup.index <- c()
  sig.value <- c()
  start.new <- c()
  stop.new <- c()
  id.new <- c()

  # original data
  chr <- c()
  start.ori <- c()
  stop.ori <- c()
  
  signal.value <- c()
  p.value <- c()
  q.value <- c()

  while(i < length(id)){
    
    if(id[i] == id[i+1]){
      dup.index <- c(dup.index, i, i+1) # push on dup.index
    } else {
      if(length(dup.index)>0){ # pop from dup.index        
    #    sig.value[j] <- mean(peak.list$sig.value[unique(dup.index)]) # mean of -log(pvalue)
        sig.value[j] <- max(peak.list$sig.value[unique(dup.index)])
        start.new[j] <- peak.list$start[min(dup.index)]
        stop.new[j] <- peak.list$stop[max(dup.index)]
        id.new[j] <- id[max(dup.index)]
        
    #    signal.value[j] <- mean(peak.list$signal.value[unique(dup.index)])        #    p.value[j] <- mean(peak.list$p.value[unique(dup.index)]) # mean of -log(pvalue)
    #    q.value[j] <- mean(peak.list$q.value[unique(dup.index)]) # mean of -log(pvalue)     
        signal.value[j] <- max(peak.list$signal.value[unique(dup.index)]) 
        p.value[j] <- max(peak.list$p.value[unique(dup.index)]) 
        q.value[j] <- max(peak.list$q.value[unique(dup.index)]) 

        chr[j] <- as.character(peak.list$chr[min(dup.index)])
        start.ori[j] <- peak.list$start.ori[min(dup.index)]
        stop.ori[j] <- peak.list$stop.ori[max(dup.index)]
        
        dup.index <- c()
      } else { # nothing to pop
        sig.value[j] <- peak.list$sig.value[i]
        start.new[j] <- peak.list$start[i]
        stop.new[j] <- peak.list$stop[i]
        id.new[j] <- id[i]

        signal.value[j] <- peak.list$signal.value[i] 
        p.value[j] <- peak.list$p.value[i] 
        q.value[j] <- peak.list$q.value[i] 

        chr[j] <- as.character(peak.list$chr[i])
        start.ori[j] <- peak.list$start.ori[i]
        stop.ori[j] <- peak.list$stop.ori[i]
        
      }
      j <- j+1
    }
    i <- i+1
  }

  data.new <- data.frame(id=id.new, sig.value=sig.value, start=start.new, stop=stop.new, signal.value=signal.value, p.value=p.value, q.value=q.value, chr=chr, start.ori=start.ori, stop.ori=stop.ori)
  invisible(data.new)
}

# Merge peaks with same ID on the same replicates 
# (They are generated if two peaks on rep1 map to the same peak on rep2)
# need peak.list have 3 columns: start, stop and sig.value 
merge.peaks <- function(peak.list, id){

  i <- 1
  j <- 1
  dup.index <- c()
  sig.value <- c()
  start.new <- c()
  stop.new <- c()
  id.new <- c()

  # original data
  chr <- c()
  start.ori <- c()
  stop.ori <- c()
  
  signal.value <- c()
  p.value <- c()
  q.value <- c()

  while(i < length(id)){
    
    if(id[i] == id[i+1]){
      dup.index <- c(dup.index, i, i+1) # push on dup.index
    } else {
      if(length(dup.index)>0){ # pop from dup.index
        sig.value[j] <- mean(peak.list$sig.value[unique(dup.index)]) # mean of -log(pvalue)
        start.new[j] <- peak.list$start[min(dup.index)]
        stop.new[j] <- peak.list$stop[max(dup.index)]
        id.new[j] <- id[max(dup.index)]
        
        signal.value[j] <- mean(peak.list$signal.value[unique(dup.index)]) # mean of -log(pvalue)
        p.value[j] <- mean(peak.list$p.value[unique(dup.index)]) # mean of -log(pvalue)
        q.value[j] <- mean(peak.list$q.value[unique(dup.index)]) # mean of -log(pvalue)

        chr[j] <- as.character(peak.list$chr[min(dup.index)])
        start.ori[j] <- peak.list$start.ori[min(dup.index)]
        stop.ori[j] <- peak.list$stop.ori[max(dup.index)]
        
        dup.index <- c()
      } else { # nothing to pop
        sig.value[j] <- peak.list$sig.value[i]
        start.new[j] <- peak.list$start[i]
        stop.new[j] <- peak.list$stop[i]
        id.new[j] <- id[i]

        signal.value[j] <- peak.list$signal.value[i] 
        p.value[j] <- peak.list$p.value[i] 
        q.value[j] <- peak.list$q.value[i] 

        chr[j] <- as.character(peak.list$chr[i])
        start.ori[j] <- peak.list$start.ori[i]
        stop.ori[j] <- peak.list$stop.ori[i]
        
      }
      j <- j+1
    }
    i <- i+1
  }

  data.new <- data.frame(id=id.new, sig.value=sig.value, start=start.new, stop=stop.new, signal.value=signal.value, p.value=p.value, q.value=q.value, chr=chr, start.ori=start.ori, stop.ori=stop.ori)
  invisible(data.new)
}





# a wrap function to fill in missing peaks, merge peaks and impute significant values
# out1 and out2 are two peak calling outputs
pair.peaks <- function(out1, out2, p.value.impute=0){

  aa <- find.overlap(out1, out2)
  bb <- fill.missing.peaks(out1, out2, aa$id1, aa$id2, p.value.impute=0)

  cc1 <- merge.peaks(bb$rep1, bb$id1)
  cc2 <- merge.peaks(bb$rep2, bb$id2)

  invisible(list(merge1=cc1, merge2=cc2))
}



# overlap.ratio is a parameter to define the percentage of overlap
# if overlap.ratio =0, 1 basepair overlap is counted as overlap
# if overlap.ratio between 0 and 1, it is the minimum proportion of
# overlap required to be called as a match
# it is computed as the overlap part/min(peak1.length, peak2.length)
pair.peaks.filter <- function(out1, out2, p.value.impute=0, overlap.ratio=0){

  aa <- find.overlap(out1, out2)
  bb <- fill.missing.peaks(out1, out2, aa$id1, aa$id2, p.value.impute=0)

  cc1 <- merge.peaks(bb$rep1, bb$id1)
  cc2 <- merge.peaks(bb$rep2, bb$id2)

  frag12 <- cbind(cc1$start, cc1$stop, cc2$start, cc2$stop)
  
  frag.ratio <- apply(frag12, 1, overlap.middle)

  frag.ratio[cc1$sig.value==p.value.impute | cc2$sig.value==p.value.impute] <- 0

  cc1$frag.ratio <- frag.ratio
  cc2$frag.ratio <- frag.ratio

  merge1 <- cc1[cc1$frag.ratio >= overlap.ratio,]
  merge2 <- cc2[cc2$frag.ratio >= overlap.ratio,]
  
  invisible(list(merge1=merge1, merge2=merge2))
}

# x[1], x[2] are the start and end of the first fragment
# and x[3] and x[4] are the start and end of the 2nd fragment 
# If there are two fragments, we can find the overlap by ordering the
# start and stop of all the ends and find the difference between the middle two
overlap.middle  <- function(x){

  x.o <- x[order(x)]
  f1 <- x[2]-x[1]
  f2 <- x[4]-x[3]
  
  f.overlap <- abs(x.o[3]-x.o[2])
  f.overlap.ratio <- f.overlap/min(f1, f2)

  return(f.overlap.ratio)
}



#######
####### compute correspondence profile
#######

# compute upper rank intersection for one t
# tv: the upper percentile
# x is sorted by the order of paired variable
comp.uri <- function(tv, x){
  n <- length(x)
  qt <- quantile(x, prob=1-tv[1]) # tv[1] is t
#  sum(x[1:ceiling(n*tv[2])] >= qt)/n/tv[2]- tv[1]*tv[2] #tv[2] is v
  sum(x[1:ceiling(n*tv[2])] >= qt)/n

}

# compute the correspondence profile
# tt, vv: vector between (0, 1) for percentages
get.uri.2d <- function(x1, x2, tt, vv, spline.df=NULL){

  o <- order(x1, x2, decreasing=T)
  
  # sort x2 by the order of x1
  x2.ordered <- x2[o]
  
  tv <- cbind(tt, vv)
  ntotal <- length(x1) # number of peaks    

  uri <- apply(tv, 1, comp.uri, x=x2.ordered)

  # compute the derivative of URI vs t using small bins
  uri.binned <- uri[seq(1, length(uri), by=4)]
  tt.binned <- tt[seq(1, length(uri), by=4)]
  uri.slope <- (uri.binned[2:(length(uri.binned))] - uri.binned[1:(length(uri.binned)-1)])/(tt.binned[2:(length(uri.binned))] - tt.binned[1:(length(tt.binned)-1)])

  # smooth uri using spline
  # first find where the jump is and don't fit the jump
  # this is the index on the left
  # jump.left.old  <- which.max(uri[-1]-uri[-length(uri)])
  short.list.length <- min(sum(x1>0)/length(x1), sum(x2>0)/length(x2))

  if(short.list.length < max(tt)){
    jump.left <- which(tt>short.list.length)[1]-1
  } else {
    jump.left <- which.max(tt)
  }

#  reversed.index <- seq(length(tt), 1, by=-1)
#  nequal <- sum(uri[reversed.index]== tt[reversed.index])
#  temp  <- which(uri[reversed.index]== tt[reversed.index])[nequal]
#  jump.left <- length(tt)-temp
 
  if(jump.left < 6){
   jump.left <- length(tt)
  }
    
 
  if(is.null(spline.df))
    uri.spl <- smooth.spline(tt[1:jump.left], uri[1:jump.left], df=6.4)
  else{
    uri.spl <- smooth.spline(tt[1:jump.left], uri[1:jump.left], df=spline.df)
  }
  # predict the first derivative
  uri.der <- predict(uri.spl, tt[1:jump.left], deriv=1)

  invisible(list(tv=tv, uri=uri, 
                 uri.slope=uri.slope, t.binned=tt.binned[2:length(uri.binned)], 
                 uri.spl=uri.spl, uri.der=uri.der, jump.left=jump.left,
                 ntotal=ntotal))
 }


# change the scale of uri from based on t (percentage) to n (number of peaks or basepairs)
# this is for plotting multiple pairwise URI's on the same plot 
scale.t2n <- function(uri){

  ntotal <- uri$ntotal
  tv <- uri$tv*uri$ntotal
  uri.uri <- uri$uri*uri$ntotal
  jump.left <- uri$jump.left
  uri.spl <- uri$uri.spl
  uri.spl$x <- uri$uri.spl$x*uri$ntotal 
  uri.spl$y <- uri$uri.spl$y*uri$ntotal

  t.binned <- uri$t.binned*uri$ntotal
  uri.slope <- uri$uri.slope
  uri.der <- uri$uri.der
  uri.der$x <- uri$uri.der$x*uri$ntotal
  uri.der$y <- uri$uri.der$y

  uri.n <- list(tv=tv, uri=uri.uri, t.binned=t.binned, uri.slope=uri.slope, uri.spl=uri.spl, uri.der=uri.der, ntotal=ntotal, jump.left=jump.left)
  return(uri.n)
} 




# a wrapper for running URI for peaks from peak calling results
# both data1 and data2 are calling results in narrowpeak format
compute.pair.uri <- function(data.1, data.2, sig.value1="signal.value", sig.value2="signal.value", spline.df=NULL, overlap.ratio=0){

  tt <- seq(0.01, 1, by=0.01)
  vv <- tt

  if(sig.value1=="signal.value"){
    data.1.enrich <- data.frame(chr=data.1$chr, start.ori=data.1$start.ori, stop.ori=data.1$stop.ori, start=data.1$start, stop=data.1$stop, sig.value=data.1$signal.value, signal.value=data.1$signal.value, p.value=data.1$p.value, q.value=data.1$q.value)
  } else {
    if(sig.value1=="p.value"){ 
      data.1.enrich <- data.frame(chr=data.1$chr, start.ori=data.1$start.ori, stop.ori=data.1$stop.ori, start=data.1$start, stop=data.1$stop, sig.value=data.1$p.value, signal.value=data.1$signal.value, p.value=data.1$p.value, q.value=data.1$q.value)
    } else {
      if(sig.value1=="q.value"){
        data.1.enrich <- data.frame(chr=data.1$chr, start.ori=data.1$start.ori, stop.ori=data.1$stop.ori, start=data.1$start, stop=data.1$stop, sig.value=data.1$q.value, signal.value=data.1$signal.value, p.value=data.1$p.value, q.value=data.1$q.value)
      }
    }
  }

  if(sig.value2=="signal.value"){
    data.2.enrich <- data.frame(chr=data.2$chr, start.ori=data.2$start.ori, stop.ori=data.2$stop.ori, start=data.2$start, stop=data.2$stop, sig.value=data.2$signal.value, signal.value=data.2$signal.value, p.value=data.2$p.value, q.value=data.2$q.value)
  } else {
    if(sig.value2=="p.value"){ 
      data.2.enrich <- data.frame(chr=data.2$chr, start.ori=data.2$start.ori, stop.ori=data.2$stop.ori, start=data.2$start, stop=data.2$stop, sig.value=data.2$p.value, signal.value=data.2$signal.value, p.value=data.2$p.value, q.value=data.2$q.value)
    } else {
      if(sig.value2=="q.value"){
        data.2.enrich <- data.frame(chr=data.2$chr, start.ori=data.2$start.ori, stop.ori=data.2$stop.ori, start=data.2$start, stop=data.2$stop, sig.value=data.2$q.value, signal.value=data.2$signal.value, p.value=data.2$p.value, q.value=data.2$q.value)
      }
    }
  }

  ### by peaks
  # data12.enrich <- pair.peaks(data.1.enrich, data.2.enrich)
  data12.enrich <- pair.peaks.filter(data.1.enrich, data.2.enrich, p.value.impute=0, overlap.ratio)
  uri <- get.uri.2d(as.numeric(as.character(data12.enrich$merge1$sig.value)), as.numeric(as.character(data12.enrich$merge2$sig.value)), tt, vv, spline.df=spline.df)
  uri.n <- scale.t2n(uri)

  return(list(uri=uri, uri.n=uri.n, data12.enrich=data12.enrich, sig.value1=sig.value1, sig.value2=sig.value2))


}



# compute uri for matched sample
get.uri.matched <- function(data12, df=10){

  tt <- seq(0.01, 1, by=0.01)
  vv <- tt
  uri <- get.uri.2d(data12$sample1$sig.value, data12$sample2$sig.value, tt, vv, spline.df=df)

  # change scale from t to n
  uri.n <- scale.t2n(uri)

  return(list(uri=uri, uri.n=uri.n))
  
}

# map.uv is a pair of significant values corresponding to specified consistency FDR
# assuming values in map.uv and qvalue are linearly related
# data.set is the original data set
# sig.value is the name of the significant value in map.uv, say enrichment
# nominal.value is the one we want to map to, say q-value
# 
map.sig.value <- function(data.set, map.uv, nominal.value){

  index.nominal <- which(names(data.set$merge1)==nominal.value)
  nentry <- nrow(map.uv)  
  map.nominal <- rbind(map.uv[, c("sig.value1", "sig.value2")])

  for(i in 1:nentry){

    map.nominal[i, "sig.value1"] <- data.set$merge1[unique(which.min(abs(data.set$merge1$sig.value-map.uv[i, "sig.value1"]))), index.nominal]
    map.nominal[i, "sig.value2"] <- data.set$merge2[unique(which.min(abs(data.set$merge2$sig.value-map.uv[i, "sig.value2"]))), index.nominal]
  }

  invisible(map.nominal)
}


############### plot correspondence profile

# plot multiple comparison wrt one template
# uri.list contains the total number of peaks
# plot.missing=F: not plot the missing points on the right 
plot.uri.group <- function(uri.n.list, plot.dir, file.name=NULL, legend.txt, xlab.txt="num of significant peaks", ylab.txt="num of peaks in common", col.start=0, col.txt=NULL, plot.missing=F, title.txt=NULL){

  if(is.null(col.txt))
    col.txt <- c("black", "red", "purple", "green", "blue", "cyan", "magenta", "orange", "grey")

  n <- length(uri.n.list)  

  ntotal <- c()
  for(i in 1:n)
    ntotal[i] <- uri.n.list[[i]]$ntotal

  jump.left <- c()
  jump.left.der <- c()
  ncommon <- c()
  for(i in 1:n){
#    jump.left[i]  <- which.max(uri.n.list[[i]]$uri[-1]-uri.n.list[[i]]$uri[-length(uri.n.list[[i]]$uri)])
#    if(jump.left[i] < 6)
#      jump.left[i] <- length(uri.n.list[[i]]$uri)

##  reversed.index <- seq(length(uri.n.list[[i]]$tv[,1]), 1, by=-1)
##  nequal <- sum(uri.n.list[[i]]$uri[reversed.index]== uri.n.list[[i]]$tv[reversed.index,1])
##  temp  <- which(uri.n.list[[i]]$uri[reversed.index]== uri.n.list[[i]]$tv[reversed.index,1])[nequal]
##  jump.left[i] <- length(uri.n.list[[i]]$tv[,1])-temp
##print(uri.n.list[[i]]$uri)
##print(uri.n.list[[i]]$tv[,1])
##   jump.left[i] <- uri.n.list[[i]]$jump.left

#    jump.left.der[i] <- sum(uri.n.list[[i]]$t.binned < uri.n.list[[i]]$uri.der$x[length(uri.n.list[[i]]$uri.der$x)])

    jump.left[i] <- uri.n.list[[i]]$jump.left
    jump.left.der[i] <- jump.left[i]
    ncommon[i] <- uri.n.list[[i]]$tv[jump.left[i],1]
  }


  if(plot.missing){
    max.peak <- max(ntotal)
  } else {
    max.peak <- max(ncommon)*1.05
  }

  if(!is.null(file.name)){
    postscript(paste(plot.dir, "uri.", file.name, sep=""))
    par(mfrow=c(1,1), mar=c(5,5,4,2))
  }

  plot(uri.n.list[[1]]$tv[,1], uri.n.list[[1]]$uri, type="n", xlab=xlab.txt, ylab=ylab.txt, xlim=c(0, max.peak), ylim=c(0, max.peak), cex.lab=2)

  for(i in 1:n){

    if(plot.missing){ 
      points(uri.n.list[[i]]$tv[,1], uri.n.list[[i]]$uri, col=col.txt[i+col.start], cex=0.5 )
    } else {
      points(uri.n.list[[i]]$tv[1:jump.left[i],1], uri.n.list[[i]]$uri[1:jump.left[i]], col=col.txt[i+col.start], cex=0.5)
    }
    lines(uri.n.list[[i]]$uri.spl, col=col.txt[i+col.start], lwd=4)
  }
  abline(coef=c(0,1), lty=3)
  legend(0, max.peak, legend=legend.txt, col=col.txt[(col.start+1):length(col.txt)], lty=1, lwd=3, cex=2)
  if(!is.null(title))
    title(title.txt)

  if(!is.null(file.name)){
    dev.off()
  }

  if(!is.null(file.name)){
    postscript(paste(plot.dir, "duri.", file.name, sep=""))
    par(mfrow=c(1,1), mar=c(5,5,4,2))
  } 
  plot(uri.n.list[[1]]$t.binned, uri.n.list[[1]]$uri.slope, type="n", xlab=xlab.txt, ylab="slope", xlim=c(0, max.peak), ylim=c(0, 1.5), cex.lab=2)

  for(i in 1:n){
#    if(plot.missing){ 
#      points(uri.n.list[[i]]$t.binned, uri.n.list[[i]]$uri.slope, col=col.txt[i+col.start], cex=0.5)
#    } else {
#      points(uri.n.list[[i]]$t.binned[1:jump.left.der[i]], uri.n.list[[i]]$uri.slope[1:jump.left.der[i]], col=col.txt[i+col.start], cex=0.5)
#    }
    lines(uri.n.list[[i]]$uri.der, col=col.txt[i+col.start], lwd=4)
  }
  abline(h=1, lty=3)
  legend(0.5*max.peak, 1.5, legend=legend.txt, col=col.txt[(col.start+1):length(col.txt)], lty=1, lwd=3, cex=2)

  if(!is.null(title))
    title(title.txt)

  if(!is.null(file.name)){
    dev.off()
  }
  
}



#######################
####################### copula fitting for matched peaks
#######################

# estimation from mixed copula model 

# 4-5-09
# A nonparametric estimation of mixed copula model


# updated

# c1, c2, f1, f2, g1, g2 are vectors
# c1*f1*g1 and c2*f2*g2 are copula densities for the two components
# xd1 and yd1 are the values of marginals for the first component
# xd2 and yd2 are the values of marginals for the 2nd component
#
# ez is the prob for being in the consistent group
get.ez <- function(p, c1, c2, xd1, yd1, xd2, yd2){

  return(p*c1*xd1*yd1/(p*c1*xd1*yd1 + (1-p)*c2*xd2*yd2))
}

# checked

# this is C_12 not the copula density function c=C_12 * f1* f2
# since nonparametric estimation is used here for f1 and f2, which
# are constant throughout the iterations, we don't need them for optimization
# 
# bivariate gaussian copula function
# t and s are vectors of same length, both are percentiles 
# return a vector
gaussian.cop.den <- function(t, s, rho){

  A <- qnorm(t)^2 + qnorm(s)^2
  B <- qnorm(t)*qnorm(s)

  loglik <-  -log(1-rho^2)/2 - rho/(2*(1-rho^2))*(rho*A-2*B)

  return(exp(loglik))
}

clayton.cop.den <- function(t, s, rho){

  if(rho > 0)
    return(exp(log(rho+1)-(rho+1)*(log(t)+log(s))-(2+1/rho)*log(t^(-rho) + s^(-rho)-1)))

  if(rho==0)
    return(1)

  if(rho<0)
    stop("Incorrect Clayton copula coefficient")
  
}


# checked
# estimate rho from Gaussian copula
mle.gaussian.copula <- function(t, s, e.z){

  # reparameterize to bound from rho=+-1
  l.c <- function(rho, t, s, e.z){
#    cat("rho=", rho, "\n")
    sum(e.z*log(gaussian.cop.den(t, s, rho)))}

  rho.max <- optimize(f=l.c, c(-0.998, 0.998), maximum=T, tol=0.00001, t=t, s=s, e.z=e.z)

#print(rho.max$m)

#cat("cor=", cor(qnorm(t)*e.z, qnorm(s)*e.z), "\t", "rho.max=", rho.max$m, "\n")
#  return(sign(rho.max$m)/(1+rho.max$m))
  return(rho.max$m)
}


# estimate mle from Clayton copula, 
mle.clayton.copula <- function(t, s, e.z){

  l.c <- function(rho, t, s, e.z){
    lc <- sum(e.z*log(clayton.cop.den(t, s, rho)))
#    cat("rho=", rho, "\t", "l.c=", lc, "\n")
    return(lc)
  }

  rho.max <- optimize(f=l.c, c(0.1, 20), maximum=T, tol=0.00001, t=t, s=s, e.z=e.z)

  return(rho.max$m)
}



# updated
# mixture likelihood of two gaussian copula
# nonparametric and ranked transformed
loglik.2gaussian.copula <- function(x, y, p, rho1, rho2, x.mar, y.mar){
 
  px.1 <- get.pdf.cdf(x, x.mar$f1)
  px.2 <- get.pdf.cdf(x, x.mar$f2)
  py.1 <- get.pdf.cdf(y, y.mar$f1)
  py.2 <- get.pdf.cdf(y, y.mar$f2)

  c1 <- gaussian.cop.den(px.1$cdf, py.1$cdf, rho1)
  c2 <- gaussian.cop.den(px.2$cdf, py.2$cdf, rho2)

  sum(log(p*c1*px.1$pdf*py.1$pdf + (1-p)*c2*px.2$pdf*py.2$pdf))
}

loglik.2copula <- function(x, y, p, rho1, rho2, x.mar, y.mar, copula.txt){

  px.1 <- pdf.cdf$px.1
  px.2 <- pdf.cdf$px.2
  py.1 <- pdf.cdf$py.1
  py.2 <- pdf.cdf$py.2

  if(copula.txt=="gaussian"){
    c1 <- gaussian.cop.den(px.1$cdf, py.1$cdf, rho1)
    c2 <- gaussian.cop.den(px.2$cdf, py.2$cdf, rho2)
  } else {
    if(copula.txt=="clayton"){
      c1 <- clayton.cop.den(px.1$cdf, py.1$cdf, rho1)
      c2 <- clayton.cop.den(px.2$cdf, py.2$cdf, rho2)
    }
  }  
  sum(log(p*c1*px.1$pdf*py.1$pdf + (1-p)*c2*px.2$pdf*py.2$pdf))
}


# estimate the marginals of each component using histogram estimator in EM
# return the density, breaks, and cdf of the histogram estimator 
est.mar.hist <- function(x, e.z, breaks){

  binwidth <- c()
  nbin <- length(breaks)-1
  nx <- length(x) 

  # the histogram
  x1.pdf <- c()
  x2.pdf <- c()
  x1.cdf <- c()
  x2.cdf <- c()

  # the pdf for each point
  x1.pdf.value <- rep(NA, nx)
  x2.pdf.value <- rep(NA, nx)

  x1.cdf.value <- rep(NA, nx)
  x2.cdf.value <- rep(NA, nx) 

  for(i in 1:nbin){

    binwidth[i] <- breaks[i+1] - breaks[i]
    if(i < nbin)
      in.bin <- x>= breaks[i] & x < breaks[i+1]
    else    # last bin
      in.bin <- x>= breaks[i] & x <=breaks[i+1]

    # each bin add one observation to avoid empty bins
    # multiple (nx+nbin)/(nx+nbin+1) to avoid blowup when looking up for
    # quantiles 
    x1.pdf[i] <- (sum(e.z[in.bin])+1)/(sum(e.z)+nbin)/binwidth[i]*(nx+nbin)/(nx+nbin+1)        
    x2.pdf[i] <- (sum(1-e.z[in.bin])+1)/(sum(1-e.z)+nbin)/binwidth[i]*(nx+nbin)/(nx+nbin+1) 


#    x1.pdf[i] <- sum(e.z[in.bin])/sum(e.z)/binwidth[i]*nx/(nx+1)        
#    x2.pdf[i] <- sum(1-e.z[in.bin])/sum(1-e.z)/binwidth[i]*nx/(nx+1) 
    
# treat each bin as a value for a discrete variable    
#    x1.cdf[i] <- sum(x1.pdf[1:i]*binwidth[1:i])
#    x2.cdf[i] <- sum(x2.pdf[1:i]*binwidth[1:i])


    # cumulative density before reaching i
    if(i>1){
      x1.cdf[i] <- sum(x1.pdf[1:(i-1)]*binwidth[1:(i-1)])
      x2.cdf[i] <- sum(x2.pdf[1:(i-1)]*binwidth[1:(i-1)])    
    } else{
      x1.cdf[i] <- 0
      x2.cdf[i] <- 0
    }

    # make a vector of nx to store the values of pdf and cdf for each x
    # this will speed up the computation dramatically
    x1.pdf.value[in.bin] <- x1.pdf[i]
    x2.pdf.value[in.bin] <- x2.pdf[i]

    x1.cdf.value[in.bin] <- x1.cdf[i] + x1.pdf[i]*(x[in.bin]-breaks[i])
    x2.cdf.value[in.bin] <- x2.cdf[i] + x2.pdf[i]*(x[in.bin]-breaks[i])      
  }

#  x1.cdf <- cumsum(x1.pdf*binwidth)
#  x2.cdf <- cumsum(x2.pdf*binwidth)

  f1 <-list(breaks=breaks, density=x1.pdf, cdf=x1.cdf)
  f2 <-list(breaks=breaks, density=x2.pdf, cdf=x2.cdf)

  f1.value <- list(pdf=x1.pdf.value, cdf=x1.cdf.value)
  f2.value <- list(pdf=x2.pdf.value, cdf=x2.cdf.value)

  return(list(f1=f1, f2=f2, f1.value=f1.value, f2.value=f2.value))
}

# estimate the marginal cdf from rank
est.cdf.rank <- function(x, conf.z){

  # add 1 to prevent blow up
  x1.cdf <- rank(x[conf.z==1])/(length(x[conf.z==1])+1)

  x2.cdf <- rank(x[conf.z==0])/(length(x[conf.z==0])+1)

  return(list(cdf1=x1.cdf, cdf2=x2.cdf))
}

# df is a density function with fields: density, cdf and breaks, x is a scalar
get.pdf <- function(x, df){

  if(x < df$breaks[1])
    cat("x is out of the range of df\n")

  index <- which(df$breaks >= x)[1]

  if(index==1)
    index <- index +1
  return(df$density[index-1])  
}

# get cdf from histgram estimator for a single value
get.cdf <- function(x, df){

  index <- which(df$breaks >= x)[1]
  if(index==1)
    index <- index +1
  return(df$cdf[index-1])   
}

# df is a density function with fields: density, cdf and breaks
get.pdf.cdf <- function(x.vec, df){

  x.pdf <- sapply(x.vec, get.pdf, df=df)
  x.cdf <- sapply(x.vec, get.cdf, df=df) 
  return(list(cdf=x.cdf, pdf=x.pdf))
}

# E-step
# x and y are the original observations or ranks
# rho1 and rho2 are the parameters of each copula
# f1, f2, g1, g2 are functions, each is a histogram 
e.step.2gaussian <- function(x, y, p, rho1, rho2, x.mar, y.mar){

  # get pdf and cdf of each component from functions in the corresponding component 
  px.1 <- get.pdf.cdf(x, x.mar$f1)
  px.2 <- get.pdf.cdf(x, x.mar$f2)
  py.1 <- get.pdf.cdf(y, y.mar$f1)
  py.2 <- get.pdf.cdf(y, y.mar$f2)

  c1 <- gaussian.cop.den(px.1$cdf, py.1$cdf, rho1)
  c2 <- gaussian.cop.den(px.2$cdf, py.2$cdf, rho2)
  
  return(get.ez(p, c1, c2, px.1$pdf, py.1$pdf, px.2$pdf, py.2$pdf))
}

# E-step
# rho1 and rho2 are the parameters of each copula 
e.step.2copula <- function(x, y, p, rho1, rho2, x.mar, y.mar, copula.txt){

  # get pdf and cdf of each component from functions in the corresponding component 
  px.1 <- get.pdf.cdf(x, x.mar$f1)
  px.2 <- get.pdf.cdf(x, x.mar$f2)
  py.1 <- get.pdf.cdf(y, y.mar$f1)
  py.2 <- get.pdf.cdf(y, y.mar$f2)

  if(copula.txt=="gaussian"){
    c1 <- gaussian.cop.den(px.1$cdf, py.1$cdf, rho1)
    c2 <- gaussian.cop.den(px.2$cdf, py.2$cdf, rho2)
  } else {
    if(copula.txt=="clayton"){
      c1 <- clayton.cop.den(px.1$cdf, py.1$cdf, rho1)
      c2 <- clayton.cop.den(px.2$cdf, py.2$cdf, rho2)
    } 
  }
  return(get.ez(p, c1, c2, px.1$pdf, py.1$pdf, px.2$pdf, py.2$pdf))
}




# M-step
m.step.2gaussian <- function(x, y, e.z, breaks){

  # compute f1, f2, g1 and g2
  x.mar <- est.mar.hist(x, e.z, breaks)
  y.mar <- est.mar.hist(y, e.z, breaks)  

  px.1 <- get.pdf.cdf(x, x.mar$f1)
  px.2 <- get.pdf.cdf(x, x.mar$f2)
  py.1 <- get.pdf.cdf(y, y.mar$f1)
  py.2 <- get.pdf.cdf(y, y.mar$f2)

  rho1 <- mle.gaussian.copula(px.1$cdf, py.1$cdf, e.z)  
  rho2 <- mle.gaussian.copula(px.2$cdf, py.2$cdf, 1-e.z) 

  p <- sum(e.z)/length(e.z) 

  return(list(p=p, rho1=rho1, rho2=rho2, x.mar=x.mar, y.mar=y.mar))
}

m.step.2copula <- function(x, y, e.z, breaks, copula.txt){

  # compute f1, f2, g1 and g2
  x.mar <- est.mar.hist(x, e.z, breaks)
  y.mar <- est.mar.hist(y, e.z, breaks)  

  px.1 <- get.pdf.cdf(x, x.mar$f1)
  px.2 <- get.pdf.cdf(x, x.mar$f2)
  py.1 <- get.pdf.cdf(y, y.mar$f1)
  py.2 <- get.pdf.cdf(y, y.mar$f2)

  if(copula.txt=="gaussian"){
    rho1 <- mle.gaussian.copula(px.1$cdf, py.1$cdf, e.z)  
    rho2 <- mle.gaussian.copula(px.2$cdf, py.2$cdf, 1-e.z) 
  } else {
    if(copula.txt=="clayton"){
      rho1 <- mle.clayton.copula(px.1$cdf, py.1$cdf, e.z)  
      rho2 <- mle.clayton.copula(px.2$cdf, py.2$cdf, 1-e.z)      
    }
  }
  
  p <- sum(e.z)/length(e.z) 

  return(list(p=p, rho1=rho1, rho2=rho2, x.mar=x.mar, y.mar=y.mar))
}



# E-step: pass values
# x and y are the original observations or ranks
# rho1 and rho2 are the parameters of each copula
# f1, f2, g1, g2 are functions, each is a histogram 
e.step.2gaussian.value <- function(x, y, p, rho1, rho2, pdf.cdf){

  c1 <- gaussian.cop.den(pdf.cdf$px.1$cdf, pdf.cdf$py.1$cdf, rho1)
  c2 <- gaussian.cop.den(pdf.cdf$px.2$cdf, pdf.cdf$py.2$cdf, rho2)
  
  e.z <- get.ez(p, c1, c2, pdf.cdf$px.1$pdf, pdf.cdf$py.1$pdf, 
               pdf.cdf$px.2$pdf, pdf.cdf$py.2$pdf)
  return(e.z)
}


e.step.2copula.value <- function(x, y, p, rho1, rho2, pdf.cdf, copula.txt){

  if(copula.txt =="gaussian"){
    c1 <- gaussian.cop.den(pdf.cdf$px.1$cdf, pdf.cdf$py.1$cdf, rho1)
    c2 <- gaussian.cop.den(pdf.cdf$px.2$cdf, pdf.cdf$py.2$cdf, rho2)
  } else {
    if(copula.txt =="clayton"){
      c1 <- clayton.cop.den(pdf.cdf$px.1$cdf, pdf.cdf$py.1$cdf, rho1)
      c2 <- clayton.cop.den(pdf.cdf$px.2$cdf, pdf.cdf$py.2$cdf, rho2)      
    }
  }
  
  e.z <- get.ez(p, c1, c2, pdf.cdf$px.1$pdf, pdf.cdf$py.1$pdf, 
               pdf.cdf$px.2$pdf, pdf.cdf$py.2$pdf)
  return(e.z)
}


# M-step: pass values
m.step.2gaussian.value <- function(x, y, e.z, breaks, fix.rho2){

  # compute f1, f2, g1 and g2
  x.mar <- est.mar.hist(x, e.z, breaks)
  y.mar <- est.mar.hist(y, e.z, breaks)  

#  px.1 <- get.pdf.cdf(x, x.mar$f1)
#  px.2 <- get.pdf.cdf(x, x.mar$f2)
#  py.1 <- get.pdf.cdf(y, y.mar$f1)
#  py.2 <- get.pdf.cdf(y, y.mar$f2)

  px.1 <- x.mar$f1.value
  px.2 <- x.mar$f2.value
  py.1 <- y.mar$f1.value
  py.2 <- y.mar$f2.value

  rho1 <- mle.gaussian.copula(px.1$cdf, py.1$cdf, e.z)  

  if(!fix.rho2)
    rho2 <- mle.gaussian.copula(px.2$cdf, py.2$cdf, 1-e.z) 
  else
    rho2 <- 0

  p <- sum(e.z)/length(e.z) 

  pdf.cdf <- list(px.1=px.1, px.2=px.2, py.1=py.1, py.2=py.2)

  return(list(p=p, rho1=rho1, rho2=rho2, x.mar=x.mar, y.mar=y.mar,
              pdf.cdf=pdf.cdf))
}

m.step.2gaussian.value2 <- function(x, y, e.z, breaks, fix.rho2, x.mar, y.mar){

  # compute f1, f2, g1 and g2
#  x.mar <- est.mar.hist(x, e.z, breaks)
#  y.mar <- est.mar.hist(y, e.z, breaks)  

#  px.1 <- get.pdf.cdf(x, x.mar$f1)
#  px.2 <- get.pdf.cdf(x, x.mar$f2)
#  py.1 <- get.pdf.cdf(y, y.mar$f1)
#  py.2 <- get.pdf.cdf(y, y.mar$f2)

  px.1 <- x.mar$f1.value
  px.2 <- x.mar$f2.value
  py.1 <- y.mar$f1.value
  py.2 <- y.mar$f2.value

  rho1 <- mle.gaussian.copula(px.1$cdf, py.1$cdf, e.z)  

  if(!fix.rho2)
    rho2 <- mle.gaussian.copula(px.2$cdf, py.2$cdf, 1-e.z) 
  else
    rho2 <- 0

  p <- sum(e.z)/length(e.z) 

  pdf.cdf <- list(px.1=px.1, px.2=px.2, py.1=py.1, py.2=py.2)

  return(list(p=p, rho1=rho1, rho2=rho2, x.mar=x.mar, y.mar=y.mar,
              pdf.cdf=pdf.cdf))
}



m.step.2copula.value <- function(x, y, e.z, breaks, fix.rho2, copula.txt){

  # compute f1, f2, g1 and g2
  x.mar <- est.mar.hist(x, e.z, breaks)
  y.mar <- est.mar.hist(y, e.z, breaks)  

#  px.1 <- get.pdf.cdf(x, x.mar$f1)
#  px.2 <- get.pdf.cdf(x, x.mar$f2)
#  py.1 <- get.pdf.cdf(y, y.mar$f1)
#  py.2 <- get.pdf.cdf(y, y.mar$f2)

  px.1 <- x.mar$f1.value
  px.2 <- x.mar$f2.value
  py.1 <- y.mar$f1.value
  py.2 <- y.mar$f2.value

  if(copula.txt=="gaussian"){
    rho1 <- mle.gaussian.copula(px.1$cdf, py.1$cdf, e.z)  
    
    if(!fix.rho2)
      rho2 <- mle.gaussian.copula(px.2$cdf, py.2$cdf, 1-e.z) 
    else
      rho2 <- 0
  } else {

    if(copula.txt=="clayton"){
      rho1 <- mle.clayton.copula(px.1$cdf, py.1$cdf, e.z)  
    
      if(!fix.rho2)
        rho2 <- mle.clayton.copula(px.2$cdf, py.2$cdf, 1-e.z) 
      else
        rho2 <- 0
    }    
  }
    
  p <- sum(e.z)/length(e.z) 

  pdf.cdf <- list(px.1=px.1, px.2=px.2, py.1=py.1, py.2=py.2)

  return(list(p=p, rho1=rho1, rho2=rho2, x.mar=x.mar, y.mar=y.mar,
              pdf.cdf=pdf.cdf))
}




# updated
# mixture likelihood of two gaussian copula
# nonparametric and ranked transformed
loglik.2gaussian.copula.value <- function(x, y, p, rho1, rho2, pdf.cdf){

  px.1 <- pdf.cdf$px.1
  px.2 <- pdf.cdf$px.2
  py.1 <- pdf.cdf$py.1
  py.2 <- pdf.cdf$py.2

  c1 <- gaussian.cop.den(px.1$cdf, py.1$cdf, rho1)
  c2 <- gaussian.cop.den(px.2$cdf, py.2$cdf, rho2)

  sum(log(p*c1*px.1$pdf*py.1$pdf + (1-p)*c2*px.2$pdf*py.2$pdf))
}



# updated
# mixture likelihood of two gaussian copula
# nonparametric and ranked transformed
loglik.2copula.value <- function(x, y, p, rho1, rho2, pdf.cdf, copula.txt){

  px.1 <- pdf.cdf$px.1
  px.2 <- pdf.cdf$px.2
  py.1 <- pdf.cdf$py.1
  py.2 <- pdf.cdf$py.2

  if(copula.txt=="gaussian"){
    c1 <- gaussian.cop.den(px.1$cdf, py.1$cdf, rho1)
    c2 <- gaussian.cop.den(px.2$cdf, py.2$cdf, rho2)
  } else {
    if(copula.txt=="clayton"){
      c1 <- clayton.cop.den(px.1$cdf, py.1$cdf, rho1)
      c2 <- clayton.cop.den(px.2$cdf, py.2$cdf, rho2)
    }
  }

  sum(log(p*c1*px.1$pdf*py.1$pdf + (1-p)*c2*px.2$pdf*py.2$pdf))
}



# EM for 2 Gaussian, speed up computation, unfinished

em.2gaussian.quick <- function(x, y, p0, rho1.0, rho2.0, eps, fix.p=F, stoc=T, fix.rho2=T){

  x <- rank(x, tie="random")
  y <- rank(y, tie="random")

#  x <- rank(x, tie="average")
#  y <- rank(y, tie="average")

  # nbin=20
  xy.min <- min(x, y)
  xy.max <- max(x, y)
  binwidth <- (xy.max-xy.min)/50
  breaks <- seq(xy.min-binwidth/100, xy.max+binwidth/100, by=(xy.max-xy.min+binwidth/50)/50)
#  breaks <- seq(xy.min, xy.max, by=binwidth)
  

  # initiate marginals 
  # initialization: first p0 data has 
#  e.z <- e.step.2gaussian(x, y, p0, rho1.0, rho2.0, x0.mar, y0.mar) # this starting point assumes two components are overlapped

  e.z <- c(rep(0.9, round(length(x)*p0)), rep(0.1, length(x)-round(length(x)*p0)))

  if(!stoc)
    para <- m.step.2gaussian.value(x, y, e.z, breaks, fix.rho2)
  else 
    para <- m.step.2gaussian.stoc.value(x, y, e.z, breaks, fix.rho2)


  if(fix.p){
    p <- p0
  } else {
    p <- para$p  
  }

  if(fix.rho2){
    rho2 <- rho2.0
  } else {
    rho2 <- para$rho2
  }

#  rho1 <- 0.8
  rho1 <- para$rho1

  l0 <- loglik.2gaussian.copula.value(x, y, p, rho1, rho2, para$pdf.cdf)

  loglik.trace <- c()
  loglik.trace[1] <- l0
#  loglik.trace[2] <- l1
  to.run <- T

  i <- 2

  # this two lines to remove
#  x.mar <- est.mar.hist(x, e.z, breaks)
#  y.mar <- est.mar.hist(y, e.z, breaks)  
  
  while(to.run){

    e.z <- e.step.2gaussian.value(x, y, p, rho1, rho2, para$pdf.cdf) 
    if(!stoc)
      para <- m.step.2gaussian.value(x, y, e.z, breaks, fix.rho2)
    else
      para <- m.step.2gaussian.stoc.value(x, y, e.z, breaks, fix.rho2)

    # fix x.mar and y.mar : to remove
#    if(!stoc)
#      para <- m.step.2gaussian.value2(x, y, e.z, breaks, fix.rho2, x.mar, y.mar)
#    else
#      para <- m.step.2gaussian.stoc.value(x, y, e.z, breaks, fix.rho2)

    
    if(fix.p){
      p <- p0
    } else {
      p <- para$p  
    }

    if(fix.rho2){
      rho2 <- rho2.0
    } else {
      rho2 <- para$rho2
    }

#    rho1 <- 0.8
    rho1 <- para$rho1

  #  l0 <- l1
    l1 <- loglik.2gaussian.copula.value(x, y, p, rho1, rho2, para$pdf.cdf)
    loglik.trace[i] <- l1

#cat("l1=", l1, "\n") 

    # Aitken acceleration criterion
    if(i > 2){
      l.inf <- loglik.trace[i-2] + (loglik.trace[i-1] - loglik.trace[i-2])/(1-(loglik.trace[i]-loglik.trace[i-1])/(loglik.trace[i-1]-loglik.trace[i-2])) 
      to.run <- abs(l.inf - loglik.trace[i]) > eps 
#cat("para=", "p=", para$p, " rho1=", rho1, " rho2=", rho2, "\n")
#cat("l.inf=", l.inf, "\n")
#cat(l.inf-loglik.trace[i], "\n")     
    }

    i <- i+1
  }

  bic <- -2*l1 + (2*(length(breaks)-1+1)+1-fix.p-fix.rho2)*log(length(x)) # parameters
  return(list(para=list(p=para$p, rho1=rho1, rho2=rho2), 
              loglik=l1, bic=bic, e.z=e.z, conf.z = para$conf.z, 
              loglik.trace=loglik.trace, x.mar=para$x.mar, y.mar=para$y.mar,
              breaks=breaks))
}



em.2copula.quick <- function(x, y, p0, rho1.0, rho2.0, eps, fix.p=F, stoc=T, fix.rho2=T, copula.txt, nbin=50){

  x <- rank(x, tie="random")
  y <- rank(y, tie="random")

#  x <- rank(x, tie="first")
#  y <- rank(y, tie="first")

  # nbin=50
  xy.min <- min(x, y)
  xy.max <- max(x, y)
  binwidth <- (xy.max-xy.min)/50
  breaks <- seq(xy.min-binwidth/100, xy.max+binwidth/100, by=(xy.max-xy.min+binwidth/50)/nbin)  
#  breaks <- seq(xy.min, xy.max, by=binwidth)
  
  # initiate marginals 
  # initialization: first p0 data has 
#  e.z <- e.step.2gaussian(x, y, p0, rho1.0, rho2.0, x0.mar, y0.mar) # this starting point assumes two components are overlapped

  e.z <- c(rep(0.9, round(length(x)*p0)), rep(0.1, length(x)-round(length(x)*p0)))


  if(!stoc)
    para <- m.step.2copula.value(x, y, e.z, breaks, fix.rho2, copula.txt)
  else 
    para <- m.step.2copula.stoc.value(x, y, e.z, breaks, fix.rho2, copula.txt)

  if(fix.p){
    p <- p0
  } else {
    p <- para$p  
  }

  if(fix.rho2){
    rho2 <- rho2.0
  } else {
    rho2 <- para$rho2
  }

  l0 <- loglik.2copula.value(x, y, p, para$rho1, rho2, para$pdf.cdf, copula.txt)

  loglik.trace <- c()
  loglik.trace[1] <- l0
#  loglik.trace[2] <- l1
  to.run <- T

  i <- 2

  while(to.run){

    e.z <- e.step.2copula.value(x, y, p, para$rho1, rho2, para$pdf.cdf, copula.txt) 
    if(!stoc)
      para <- m.step.2copula.value(x, y, e.z, breaks, fix.rho2, copula.txt)
    else
      para <- m.step.2copula.stoc.value(x, y, e.z, breaks, fix.rho2, copula.txt)

    if(fix.p){
      p <- p0
    } else {
      p <- para$p  
    }

    if(fix.rho2){
      rho2 <- rho2.0
    } else {
      rho2 <- para$rho2
    }


  #  l0 <- l1
    l1 <- loglik.2copula.value(x, y, p, para$rho1, rho2, para$pdf.cdf, copula.txt)
    loglik.trace[i] <- l1

cat("l1=", l1, "\n") 

    # Aitken acceleration criterion
    if(i > 2){
      l.inf <- loglik.trace[i-2] + (loglik.trace[i-1] - loglik.trace[i-2])/(1-(loglik.trace[i]-loglik.trace[i-1])/(loglik.trace[i-1]-loglik.trace[i-2])) 
      to.run <- abs(l.inf - loglik.trace[i]) > eps 
cat("para=", "p=", para$p, " rho1=", para$rho1, " rho2=", rho2, "\n")
#cat("l.inf=", l.inf, "\n")
#cat(l.inf-loglik.trace[i], "\n")     
    }

    i <- i+1
  }

  bic <- -2*l1 + (2*(length(breaks)-1+1)+1-fix.p-fix.rho2)*log(length(x)) # parameters
  return(list(para=list(p=para$p, rho1=para$rho1, rho2=rho2), 
              loglik=l1, bic=bic, e.z=e.z, conf.z = para$conf.z, 
              loglik.trace=loglik.trace, x.mar=para$x.mar, y.mar=para$y.mar,
              breaks=breaks))
}


#######################
####################### fit EM procedure for the matched peaks
#######################

# remove the unmatched ones
#rm.unmatch <- function(sample1, sample2, p.value.impute=0){
#
#  sample1.prune <- sample1[sample1$sig.value > p.value.impute & sample2$sig.value > p.value.impute,]
#  sample2.prune <- sample2[sample1$sig.value > p.value.impute & sample2$sig.value > p.value.impute,]
# 
#  invisible(list(sample1=sample1.prune$sig.value, sample2=sample2.prune$sig.value))
#}


# fit 2-component model
#fit.em <- function(sample12, fix.rho2=T){
#
#  prune.sample <- rm.unmatch(sample12$merge1, sample12$merge2)
#
#  em.fit <- em.2gaussian.quick(-prune.sample$sample1, -prune.sample$sample2,
# p0=0.5, rho1.0=0.7, rho2.0=0, eps=0.01, fix.p=F, stoc=F, fix.rho2)
#
#  invisible(list(em.fit=em.fit, data.pruned=prune.sample))
#}


rm.unmatch <- function(sample1, sample2, p.value.impute=0){

  sample1.prune <- sample1[sample1$sig.value > p.value.impute & sample2$sig.value > p.value.impute,]
  sample2.prune <- sample2[sample1$sig.value > p.value.impute & sample2$sig.value > p.value.impute,]
 
  invisible(list(sample1=sample1.prune, sample2=sample2.prune))
}


# fit 2-component model
fit.em <- function(sample12, fix.rho2=T){

  prune.sample <- rm.unmatch(sample12$merge1, sample12$merge2)

  em.fit <- em.2gaussian.quick(-prune.sample$sample1$sig.value, -prune.sample$sample2$sig.value,
 p0=0.5, rho1.0=0.7, rho2.0=0, eps=0.01, fix.p=F, stoc=F, fix.rho2)

  invisible(list(em.fit=em.fit, data.pruned=prune.sample))
}



fit.2copula.em <- function(sample12, fix.rho2=T, copula.txt){

  prune.sample <- rm.unmatch(sample12$merge1, sample12$merge2)

#  o <- order(prune.sample$sample1)
#  n <- length(prune.sample$sample1)
    
#  para <- init(prune.sample$sample1$sig.value, prune.sample$sample2$sig.value, c(rep(0, round(n/3)), rep(c(0,1), round(n/6)), rep(1, n-round(n/3)-round(n/6))))

#  temp <- init.dist(f0, f1)
  para <- list()
  para$rho <- 0.6
  para$p <- 0.3
  para$mu <- 2.5
  para$sigma <- 1
##  para$mu <- -temp$mu
##  para$sigma <- temp$sigma
#cat("mu=", para$mu, "sigma=", para$sigma, "\n")
  
#  em.fit <- em.transform.1loop(-prune.sample$sample1, -prune.sample$sample2,
  cat("EM is running")
  em.fit <- em.transform(prune.sample$sample1$sig.value, prune.sample$sample2$sig.value, para$mu, para$sigma, para$rho, para$p, eps=0.01)

  invisible(list(em.fit=em.fit, data.pruned=prune.sample))
}




# fit 1-component model
fit.1.component <- function(data.pruned, breaks){

#  gaussian.1 <- fit.gaussian.1(-data.pruned$sample1$sig.value, -data.pruned$sample2$sig.value, breaks)
#  clayton.1 <- fit.clayton.1(-data.pruned$sample1$sig.value, -data.pruned$sample2$sig.value, breaks)

  gaussian.1 <- fit.gaussian.1(-data.pruned$sample1, -data.pruned$sample2, breaks)
  clayton.1 <- fit.clayton.1(-data.pruned$sample1, -data.pruned$sample2, breaks)

  return(list(gaussian.1=gaussian.1, clayton.1=clayton.1))
}



#################
# Fit a single component  
#################

# a single gaussian copula
# if breaks=NULL, use empirical pdf, otherwise use histogram estimate
fit.gaussian.1 <- function(x, y, breaks=NULL){

  # rank transformed and compute the empirical cdf
  t <- emp.mar.cdf.rank(x)
  s <- emp.mar.cdf.rank(y)

  mle.rho <- mle.gaussian.copula(t, s, rep(1, length(t)))

  c1 <- gaussian.cop.den(t, s, mle.rho)
cat("c1", sum(log(c1)), "\n")

  if(is.null(breaks)){
    f1 <- emp.mar.pdf.rank(t)
    f2 <- emp.mar.pdf.rank(s)
  } else {
    x.mar <- est.mar.hist(rank(x), rep(1, length(x)), breaks)
    y.mar <- est.mar.hist(rank(y), rep(1, length(y)), breaks)

    f1 <- x.mar$f1.value$pdf  # only one component
    f2 <- y.mar$f1.value$pdf
  }


cat("f1", sum(log(f1)), "\n")
cat("f2", sum(log(f2)), "\n")

  loglik <- sum(log(c1)+log(f1)+log(f2))

  bic <- -2*loglik + log(length(t))*(1+length(breaks)-1)

  return(list(rho=mle.rho, loglik=loglik, bic=bic))
}


# a single Clayton copula
fit.clayton.1 <- function(x, y, breaks=NULL){

  # rank transformed and compute the empirical cdf
  t <- emp.mar.cdf.rank(x)
  s <- emp.mar.cdf.rank(y)

  mle.rho <- mle.clayton.copula(t, s, rep(1, length(t)))

  c1 <- clayton.cop.den(t, s, mle.rho)

  if(is.null(breaks)){
    f1 <- emp.mar.pdf.rank(t)
    f2 <- emp.mar.pdf.rank(s)
  } else {
    x.mar <- est.mar.hist(rank(x), rep(1, length(x)), breaks)
    y.mar <- est.mar.hist(rank(y), rep(1, length(y)), breaks)

    f1 <- x.mar$f1.value$pdf  # only one component
    f2 <- y.mar$f1.value$pdf
  }

  loglik <- sum(log(c1)+log(f1)+log(f2))

  bic <- -2*loglik + log(length(t))*(1+length(breaks)-1)

  return(list(rho=mle.rho, tau=rho/(rho+2), loglik=loglik, bic=bic)) 
}

## obsolete function (01-06-2010)
## compute the average posterior probability to belong to the random component
## for peaks selected at different cutoffs 
comp.uri.ez <- function(tt, u, v, e.z){

   u.t <- quantile(u, prob=(1-tt))
   v.t <- quantile(v, prob=(1-tt))

 #  ez <- mean(e.z[u >= u.t & v >=u.t]) Is this wrong?
   ez <- mean(e.z[u >= u.t & v >=v.t])

   return(ez)
}

## obsolete function (01-06-2010)
# compute the largest posterior error probability corresponding to
# the square centered at the origin and spanned top tt% on both coordinates
# so the consistent low rank ones are excluded
# boundary.txt: either "max" or "min", if it is error prob, use "max"
comp.ez.cutoff <- function(tt, u, v, e.z, boundary.txt){

   u.t <- quantile(u, prob=(1-tt))
   v.t <- quantile(v, prob=(1-tt))

   if(boundary.txt == "max"){
 #    ez.bound <- max(e.z[u >= u.t & v >=u.t])
     ez.bound <- max(e.z[u >= u.t & v >=v.t])
   } else {
 #    ez.bound <- min(e.z[u >= u.t & v >=u.t])
     ez.bound <- min(e.z[u >= u.t & v >=v.t])     
   }

   return(ez.bound)

}

# obsolete functions: 01-06-2010
# compute the error rate
# u.t and v.t are the quantiles
# this one is used for the plots generated initially in the brief writeup  
# and it was used for processing merged data in July before the IDR definition
# is formalized
# It does not implement the current definition of IDR
get.ez.tt.old  <- function(em.fit, reverse=T, fdr.level=c(0.01, 0.05, 0.1)){

  u <- em.fit$data.pruned$sample1
  v <- em.fit$data.pruned$sample2

  tt <- seq(0.01, 0.99, by=0.01)
  if(reverse){ 
    e.z <-  1-em.fit$em.fit$e.z # this is the error prob
    uri.ez <- sapply(tt, comp.uri.ez, u=u, v=v, e.z=e.z)
    ez.bound <- sapply(tt, comp.ez.cutoff, u=u, v=v, e.z=e.z, boundary.txt="max") 
  } else {
    e.z <-  em.fit$em.fit$e.z
    uri.ez <- sapply(tt, comp.uri.ez, u=u, v=v, e.z=e.z)
    ez.bound <- sapply(tt, comp.ez.cutoff, u=u, v=v, e.z=e.z, boundary.txt="min") 
  }

  u.t <- quantile(u, prob=(1-tt))
  v.t <- quantile(v, prob=(1-tt))  

  # find the levels on the two replicates
  sig.value1 <- c()
  sig.value2 <- c()
  error.prob.cutoff <- c()
  n.selected.match <- c()

  for(i in 1:length(fdr.level)){

    # find which uri.ez is closet to fdr.level
    index <- which.min(abs(uri.ez - fdr.level[i]))
    sig.value1[i] <- u.t[index]
    sig.value2[i] <- v.t[index]
    error.prob.cutoff[i] <- ez.bound[index]  
    if(reverse){
      n.selected.match[i] <- sum(e.z<=ez.bound[index])    
    } else {
      n.selected.match[i] <- sum(e.z>=ez.bound[index])    
    }
  }   

  # output the cutoff of posterior probability, signal values on two replicates
  map.uv <- cbind(error.prob.cutoff, sig.value1, sig.value2, n.selected.match)

  return(list(n=tt*length(u), uri.ez=uri.ez, u.t=u.t, v.t=v.t, tt=tt, fdr.level=fdr.level,  map.uv=map.uv, e.z=e.z, error.prob.cutoff=error.prob.cutoff))
}

# created: 01-06-2010
# Output IDR at various number of selected peaks
# Find cutoff (idr cutoff, sig.value cutoff on each replicate) for specified IDR level
# IDR definition is similar to FDR
get.ez.tt <- function(em.fit, idr.level=c(0.01, 0.05, 0.1)){

#  u <- em.fit$data.pruned$sample1$sig.value
#  v <- em.fit$data.pruned$sample2$sig.value
  u <- em.fit$data.pruned$sample1
  v <- em.fit$data.pruned$sample2
  
  e.z <-  1-em.fit$em.fit$e.z # this is the error prob
  
  o <- order(e.z)
  e.z.ordered <- e.z[o]
  n.select <- c(1:length(e.z))
  IDR <- cumsum(e.z.ordered)/n.select

  u.o <- u[o]
  v.o <- v[o]

  n.level <- length(idr.level)
#  sig.value1 <- rep(NA, n.level)
#  sig.value2 <- rep(NA, n.level)
  ez.cutoff <- rep(NA, n.level)
  n.selected <- rep(NA, n.level)
  
  for(i in 1:length(idr.level)){

    # find which uri.ez is closet to fdr.level
    index <- which.min(abs(IDR - idr.level[i]))
#    sig.value1[i] <- min(u.o[1:index])
#    sig.value2[i] <- min(v.o[1:index])
    ez.cutoff[i] <- e.z[index]      
    n.selected[i] <- sum(e.z<=ez.cutoff[i])    
  }   

  # output the cutoff of posterior probability, number of selected overlapped peaks 
#  map.uv <- cbind(ez.cutoff, sig.value1, sig.value2, n.selected)

  map.uv <- cbind(ez.cutoff, n.selected)

  return(list(n=n.select, IDR=IDR, idr.level=idr.level, map.uv=map.uv))
}   
  
#  return(list(n=tt*length(u), uri.ez=uri.ez,  fdr.level=fdr.level,  map.uv=map.uv, e.z=e.z, error.prob.cutoff=error.prob.cutoff))  
  




### compute the mean of the marginals
get.mar.mean <- function(em.out){

  x.f1 <- em.out$x.mar$f1
  x.f2 <- em.out$x.mar$f2

  y.f1 <- em.out$y.mar$f1
  y.f2 <- em.out$y.mar$f2

  x.stat1 <- get.hist.mean(x.f1)
  x.stat2 <- get.hist.mean(x.f2)
  y.stat1 <- get.hist.mean(y.f1)
  y.stat2 <- get.hist.mean(y.f2)

  return(list(x.mean1=x.stat1$mean, x.mean2=x.stat2$mean, 
              y.mean1=y.stat1$mean, y.mean2=y.stat2$mean,
              x.sd1=x.stat1$sd, x.sd2=x.stat2$sd, 
              y.sd1=y.stat1$sd, y.sd2=y.stat2$sd
              ))

}


# compute the mean of marginals
get.hist.mean  <- function(x.f){

  nbreaks <- length(x.f$breaks)
  x.bin <- x.f$breaks[-1]-x.f$breaks[-nbreaks]

  x.mid <- (x.f$breaks[-nbreaks]+x.f$breaks[-1])/2
  x.mean <- sum(x.mid*x.f$density*x.bin)
  x.sd <- sqrt(sum(x.mid*x.mid*x.f$density*x.bin)-x.mean^2)
  
  return(list(mean=x.mean, sd=x.sd))
}

get.hist.var <- function(x.f){

  nbreaks <- length(x.f$breaks)
  x.bin <- x.f$breaks[-1]-x.f$breaks[-nbreaks]

  x.mid <- (x.f$breaks[-nbreaks]+x.f$breaks[-1])/2
  x.mean <- sum(x.mid*x.f$density*x.bin)

  return(mean=x.mean)  
}

# obsolete function (01-06-2010)
# plot 
plot.ez.group.old <- function(ez.list, plot.dir, file.name=NULL, legend.txt, y.lim=NULL, xlab.txt="num of significant peaks",  ylab.txt="avg posterior prob of being random", col.txt=NULL, title.txt=NULL){

  if(is.null(col.txt))
    col.txt <- c("black", "red", "purple", "green", "blue", "cyan", "magenta", "orange", "grey")

  x <- c()
  y <- c()

  for(i in 1:length(ez.list)){
    x <- c(x, ez.list[[i]]$n)
      
    y <- c(y, ez.list[[i]]$uri.ez)
  }

  if(is.null(y.lim))
    y.lim <- c(0, max(y))

  if(!is.null(file.name)){
    postscript(paste(plot.dir, "ez.", file.name, sep=""))
    par(mfrow=c(1,1), mar=c(5,5,4,2))
  }

  plot(x, y, ylim=y.lim, type="n", xlab=xlab.txt, ylab=ylab.txt, lwd=5, cex=5, cex.axis=2, cex.lab=2)

  for(i in 1:length(ez.list)){
    lines(ez.list[[i]]$n, ez.list[[i]]$uri.ez, col=col.txt[i], cex=2, lwd=5)    
  }

#   plot(ez.list[[1]]$u.t, y, ylim=y.lim, type="l", xlab="rep-sig", ylab=ylab.txt, lwd=5, cex=5, cex.axis=2, cex.lab=2)
#   plot(ez.list[[1]]$v.t, y, ylim=y.lim, type="l", xlab="rep-sig", ylab=ylab.txt, lwd=5, cex=5, cex.axis=2, cex.lab=2)
  

  legend(0, y.lim[2], legend=legend.txt, col=col.txt[1:length(col.txt)], lty=1, lwd=5, cex=2)

  if(!is.null(title))
    title(title.txt)

  if(!is.null(file.name)){
    dev.off()
  }
  
}


plot.ez.group <- function(ez.list, plot.dir, file.name=NULL, legend.txt, y.lim=NULL, xlab.txt="num of significant peaks",  ylab.txt="IDR", col.txt=NULL, title.txt=NULL){

  if(is.null(col.txt))
    col.txt <- c("black", "red", "purple", "green", "blue", "cyan", "magenta", "orange", "grey")

  n.entry <- length(ez.list)
  x <- rep(NA, n.entry)
  y.max <- rep(NA, n.entry)

  for(i in 1:n.entry){
    x[i] <- max(ez.list[[i]]$n)
      
    y.max[i] <- max(ez.list[[i]]$IDR)
  
  }

  if(is.null(y.lim))
    y.lim <- c(0, max(y.max))

  if(!is.null(file.name)){
    postscript(paste(plot.dir, "ez.", file.name, sep=""))
    par(mfrow=c(1,1), mar=c(5,5,4,2))
  }


  
  plot(c(0, max(x)), y.lim, ylim=y.lim, type="n", xlab=xlab.txt, ylab=ylab.txt, lwd=5, cex=5, cex.axis=2, cex.lab=2)

  q <- seq(0.01, 0.99, by=0.01)
  
  for(i in 1:length(ez.list)){

    n.plot <- round(quantile(ez.list[[i]]$n, prob=q))
    IDR.plot <- ez.list[[i]]$IDR[n.plot]
    lines(n.plot, IDR.plot, col=col.txt[i], cex=2, lwd=5)    
  }


  legend(0, y.lim[2], legend=legend.txt, col=col.txt[1:length(col.txt)], lty=1, lwd=5, cex=2)

  if(!is.null(title))
    title(title.txt)

  if(!is.null(file.name)){
    dev.off()
  }
  
}



#############################################################################
#############################################################################
# statistics about peaks selected on the individual replicates
#
# idr.level: the consistency cutoff, say 0.05
# uri.output: a list of uri.output from consistency analysis generated by batch-consistency-analysis.r
# ez.list : a list of IDRs computed from get.ez.tt using the same idr.level
#
##################


# obsolete?
# compute the error rate
# u.t and v.t are the quantiles
# 
# map back to all peaks and report the number of peaks selected
get.ez.tt.all.old  <- function(em.fit, all.data1, all.data2, idr.level){

  u <- em.fit$data.pruned$sample1
  v <- em.fit$data.pruned$sample2

  tt <- seq(0.01, 0.99, by=0.01)
#  if(reverse){ 
    e.z <-  1-em.fit$em.fit$e.z # this is the error prob
    uri.ez <- sapply(tt, comp.uri.ez, u=u, v=v, e.z=e.z)
    ez.bound <- sapply(tt, comp.ez.cutoff, u=u, v=v, e.z=e.z, boundary.txt="max") 
#  } else {
#    e.z <-  em.fit$em.fit$e.z
#    uri.ez <- sapply(tt, comp.uri.ez, u=u, v=v, e.z=e.z)
#    ez.bound <- sapply(tt, comp.ez.cutoff, u=u, v=v, e.z=e.z, boundary.txt="min") 
#  }

  u.t <- quantile(u, prob=(1-tt))
  v.t <- quantile(v, prob=(1-tt))  

  # find the levels on the two replicates
  sig.value1 <- c()
  sig.value2 <- c()
  error.prob.cutoff <- c()
  n.selected.match <- c()
  npeak.rep1 <- c()
  npeak.rep2 <- c()

  for(i in 1:length(idr.level)){

    # find which uri.ez is closet to idr.level
    index <- which.min(abs(uri.ez - as.numeric(idr.level[i])))

    sig.value1[i] <- u.t[index]
    sig.value2[i] <- v.t[index]
    error.prob.cutoff[i] <- ez.bound[index]  
    n.selected.match[i] <- sum(u>= u.t[index] & v>=v.t[index])

    npeak.rep1[i] <- sum(all.data1["sig.value"] >= sig.value1[i])
    npeak.rep2[i] <- sum(all.data2["sig.value"] >= sig.value2[i])    
  }   


  # output the cutoff of posterior probability, signal values on two replicates
  map.uv <- cbind(error.prob.cutoff, sig.value1, sig.value2, n.selected.match, npeak.rep1, npeak.rep2)

  return(list(n=tt*length(u), uri.ez=uri.ez, u.t=u.t, v.t=v.t, tt=tt, idr.level=idr.level,  map.uv=map.uv, e.z=e.z, error.prob.cutoff=error.prob.cutoff))
}


get.ez.tt.all <- function(em.fit, all.data1, all.data2, idr.level=c(0.01, 0.05, 0.1)){

  u <- em.fit$data.pruned$sample1$sig.value
  v <- em.fit$data.pruned$sample2$sig.value
#  u <- em.fit$data.pruned$sample1
#  v <- em.fit$data.pruned$sample2
  
  e.z <-  1-em.fit$em.fit$e.z # this is the error prob
  
  o <- order(e.z)
  e.z.ordered <- e.z[o]
  n.select <- c(1:length(e.z))
  IDR <- cumsum(e.z.ordered)/n.select

  u.o <- u[o]
  v.o <- v[o]

  n.level <- length(idr.level)
#  sig.value1 <- rep(NA, n.level)
#  sig.value2 <- rep(NA, n.level)
  ez.cutoff <- rep(NA, n.level)
  n.selected <- rep(NA, n.level)
  npeak.rep1 <- rep(NA, n.level)
  npeak.rep2 <- rep(NA, n.level)
  
  for(i in 1:length(idr.level)){

    # find which uri.ez is closet to fdr.level
    index <- which.min(abs(IDR - idr.level[i]))
#    sig.value1[i] <- min(u.o[1:index])
#    sig.value2[i] <- min(v.o[1:index])
    ez.cutoff[i] <- e.z.ordered[index]      # fixed on 02/20/10
    n.selected[i] <- sum(e.z<=ez.cutoff[i])
#    npeak.rep1[i] <- sum(all.data1["sig.value"] >= sig.value1[i])
#    npeak.rep2[i] <- sum(all.data2["sig.value"] >= sig.value2[i])     
  }   

  # output the cutoff of posterior probability, number of selected overlapped peaks 
  map.uv <- cbind(ez.cutoff, n.selected)

  return(list(n=n.select, IDR=IDR, idr.level=idr.level, map.uv=map.uv))
}   
  
#  return(list(n=tt*length(u), uri.ez=uri.ez,  fdr.level=fdr.level,  map.uv=map.uv, e.z=e.z, error.prob.cutoff=error.prob.cutoff))  
  





####### the following is for determining thresholds for merged dataset

############# select peaks above a given threshold
#
# pass.threshold: a simple method, passing the threshold on the threshold on the individual replicate to the pooled sample 
#                 
# sig.map.list: a list of matrix to include all the cutoff values, each row corresponds to a cutoff. The first column is idr.level
#          the 2nd column is the cutoff of ez, the rest of columns are consistency analysis for other replicates 
# sig.value.name: the name of the sig.value column
# combined: combined dataset
# nrep: number of pairs of comparisons
#
# Procedure:
# 1. Find the significant threshold corresponding to the idr cutoff on the matched peaks. 
# 2. Each time we will get two or more (if >2 replicates) cutoffs and will report the most stringent and the least stringent
#    cutoff and the number of peaks selected at those two cutoffs
#############

pass.threshold <- function(sig.map.list, sig.value.name, combined, idr.level, nrep, chr.size){

  sig.map <- c()

  # choose idr.level
  idr.index <- which(rbind(sig.map.list[[1]])[,1] == idr.level)
  if(length(i) ==0){
    print("no level matches specified idr.level")
    return(-1)
  }

  for(i in 1:length(sig.map.list))
    sig.map <- c(sig.map, rbind(sig.map.list[[i]])[idr.index, c("sig.value1", "sig.value2")])
  
  
  npeak.tight <- c()  
  npeak.loose <- c()


  max.sig <- max(sig.map)
  min.sig <- min(sig.map)
  selected.sig.tight <- combined[combined[,sig.value.name]>=max.sig, ]
  selected.sig.loose <- combined[combined[,sig.value.name]>=min.sig, ]

  selected.sig.tight <- deconcatenate.chr(selected.sig.tight, chr.size)[,c("chr", "start", "stop", "signal.value", "p.value", "q.value")]
  selected.sig.loose <- deconcatenate.chr(selected.sig.loose, chr.size)[,c("chr", "start", "stop", "signal.value", "p.value", "q.value")]
  
  npeak.tight <- nrow(selected.sig.tight)
  npeak.loose <- nrow(selected.sig.loose)
  
  
  npeak.stat <- list(idr.level=idr.level, max.sig=max.sig, min.sig=min.sig, npeak.tight=npeak.tight, npeak.loose=npeak.loose)

  invisible(list(npeak.stat=npeak.stat, combined.selected.tight=selected.sig.tight, combined.selected.loose=selected.sig.loose))  
}

#################
# pass the regions selected from consistency analysis to combined data
# Threshold is determined on the replicates, the regions above the threshold are selected
# then peaks on the combined data are selected from the selected regions
#
# To avoid being too stringent, regions satisfying the following conditions are selected
# 1. regions above the significant threshold determined by consistency analysis on either replicate
# 2. regions that have consistent low peaks, i.e. posterior prob > threshold but not passing the significant threshold
#
# This method doesn't make a difference when using different thresholds
#################

pass.region <- function(sig.map.list, uri.output, ez.list, em.output, combined, idr.level, sig.value.impute=0, chr.size){
 
  combined <- combined[, c("start", "stop", "sig.value", "signal.value", "p.value", "q.value")]
  npair <- length(uri.output) # number of pairs of consistency analysis
  combined.region <- c()

  # choose idr.level
  idr.index <- which(rbind(sig.map.list[[1]])[,1] == idr.level)
  if(length(idr.index) ==0){
    print("no level matches specified idr.level")
    return(-1)
  }

    for(j in 1:npair){
      # select peaks from individual replicates using individual cutoff
      above.1 <- uri.output[[j]]$data12.enrich$merge1["sig.value"] >= ez.list[[j]]$map.uv[idr.index,"sig.value1"]
      above.2 <- uri.output[[j]]$data12.enrich$merge1["sig.value"] >= ez.list[[j]]$map.uv[idr.index,"sig.value2"]
      selected.sig.rep1 <- uri.output[[j]]$data12.enrich$merge1[above.1, c("start", "stop", "sig.value", "signal.value", "p.value", "q.value")]
      selected.sig.rep2 <- uri.output[[j]]$data12.enrich$merge2[above.2, c("start", "stop", "sig.value", "signal.value", "p.value", "q.value")] 
      
      # find the peaks that are overlapped with reliable peaks in the individual replicates
      overlap.1 <- pair.peaks(selected.sig.rep1, combined)$merge2
      overlap.2 <- pair.peaks(selected.sig.rep2, combined)$merge2

      # choose the ones with significant value > 0, which are the overlapped ones

      combined.in1 <- overlap.1[overlap.1$sig.value > sig.value.impute, c("start", "stop", "sig.value", "signal.value", "p.value", "q.value")]
      combined.in2 <- overlap.2[overlap.2$sig.value > sig.value.impute, c("start", "stop", "sig.value", "signal.value", "p.value", "q.value")]

      ## consistent low significant ones
      ## first find consistenct ones, ie. high posterior prob
      # is.consistent <- ez.list[[j]]$e.z < ez.list[[j]]$ez.cutoff 

      # data.matched <- keep.match(uri.output[[j]]$data12.enrich$merge1[!above.1, ], uri.output[[j]]$data12.enrich$merge2[!above.2, ], sig.value.impute=0)
      # data.matched$sample1 <- data.matched$sample1[, c("start", "stop", "sig.value", "signal.value", "p.value", "q.value")]
      # data.matched$sample2 <- data.matched$sample2[, c("start", "stop", "sig.value", "signal.value", "p.value", "q.value")]

      # consistent.in1 <- data.matched$sample1[is.consistent, ]
      # consistent.in2 <- data.matched$sample2[is.consistent, ]

      # overlap.consistent.1 <- pair.peaks(consistent.in1, combined)$merge2
      # overlap.consistent.2 <- pair.peaks(consistent.in2, combined)$merge2

      ## choose the ones with significant value > 0, which are the overlapped ones

      # combined.consistent.in1 <- overlap.consistent.1[overlap.consistent.1$sig.value > sig.value.impute, ]
      # combined.consistent.in2 <- overlap.consistent.2[overlap.consistent.2$sig.value > sig.value.impute, ]

      # combined.region <- rbind(combined.region, combined.in1, combined.in2, combined.consistent.in1, combined.consistent.in2)

       combined.region <- rbind(combined.region, combined.in1, combined.in2)

      is.repeated <- duplicated(combined.region$start)
      combined.region <- combined.region[!is.repeated, c("start", "stop", "sig.value", "signal.value", "p.value", "q.value")]
      
    }
    npeak <- nrow(combined.region)
  
   sig.combined <- c(min(combined.region[,"sig.value"], na.rm=T), max(combined.region[,"sig.value"], na.rm=T))

  # idr.combined <- c(min(combined.region[,"q.value"], na.rm=T), max(combined.region[,"q.value"], na.rm=T))

   npeak.stat <- list(idr.level=idr.level, npeak=npeak)

   combined.region <- deconcatenate.chr(combined.region, chr.size)[,c("chr", "start", "stop", "signal.value", "p.value", "q.value")]

  invisible(list(npeak.stat=npeak.stat, combined.selected=combined.region, sig.combined=sig.combined))
}

################
# pass structure: this method does another round of inference on the combined data
#
# To make the mixture structure comparable on the replicates and the combined data, the 2nd inference is done on the peaks
# at the reliable regions on the combined data, using rank transformed significant values. The mixture structure is estimated using my consistency analysis, which 
# estimates marginal distributions of ranks using nonparametric ways. Then the significant values are found out.
# There are several advantages to do it this way:  
# 1. The premise of passing structure is that the means and variance (i.e. distribution) of two replicates should be the same
#    The significant values on the two replicates clearly have different distributions. The structure estimated from consistency
#    analysis will generate similar rank distribution on two replicates by its setup (i.e. same number of peaks are paired up).  
# 2. Because pooled sample is a black box, the structure is more likely to be followed in the matched regions than other locations,
#    after all, we don't know what other things are. If even the structure doesn't hold on the matched regions, 
#    which is possible, let alone the other regions. Focusing on the reliable regions helps to get rid of those unknown noises.
#  
# 
# modified on 2-20-10: reverse rank.combined, make big sig.value with small
# ranks, to be consistent with f1 and f2
################ 

pass.structure <- function(uri.output, em.output, combined, idr.level, sig.value.impute, chr.size, overlap.ratio=0){

  columns.keep <- c("sig.value", "start", "stop", "signal.value", "p.value", "q.value", "chr", "start.ori", "stop.ori")
  combined <- combined[, columns.keep]
  combined.selected.all <- c()

  for(j in 1:npair){

    sample1 <- uri.output[[j]]$data12.enrich$merge1[, columns.keep]
    sample2 <- uri.output[[j]]$data12.enrich$merge2[, columns.keep]
        
    # find peaks on the matched region on the combined one
    data.matched <- keep.match(sample1, sample2, sig.value.impute=sig.value.impute)

    data.matched$sample1 <- data.matched$sample1[, columns.keep]
    data.matched$sample2 <- data.matched$sample2[, columns.keep]

    overlap.1 <- pair.peaks.filter(data.matched$sample1, combined, p.value.impute=sig.value.impute, overlap.ratio)$merge2
    overlap.2 <- pair.peaks.filter(data.matched$sample2, combined, p.value.impute=sig.value.impute, overlap.ratio)$merge2

    # choose the ones with significant value > sig.value.impute, which are the overlapped ones

    combined.in1 <- overlap.1[overlap.1$sig.value > sig.value.impute, ]
    combined.in2 <- overlap.2[overlap.2$sig.value > sig.value.impute, ]

    combined.region <- rbind(combined.in1, combined.in2)
  
    is.repeated <- duplicated(combined.region$start)
    combined.region <- combined.region[!is.repeated,]

    # now rank the peaks in matched region
    rank.combined <- rank(-combined.region$sig.value)
    
    # now transform the parameters estimated into the new scale
    npeaks.overlap <- nrow(combined.region)
    npeaks.consistent <- nrow(cbind(em.output[[j]]$data.pruned$sample1))

    
    # the breaks are the same for x and y
    f1 <- list(breaks=em.output[[j]]$em.fit$x.mar$f1$breaks*npeaks.overlap/npeaks.consistent, density=(em.output[[j]]$em.fit$x.mar$f1$density+em.output[[j]]$em.fit$y.mar$f1$density)/2)
    # the first break boundary goes up when changing scale, need set it back to be a bit smaller than 1
    f1$breaks[1] <- min(f1$breaks[1], 0.95)
    
    f2 <- list(breaks=em.output[[j]]$em.fit$x.mar$f2$breaks*npeaks.overlap/npeaks.consistent, density=(em.output[[j]]$em.fit$x.mar$f2$density+em.output[[j]]$em.fit$y.mar$f2$density)/2)
    # the first break boundary goes up when changing scale, need set it back to be a bit smaller than 1
    f2$breaks[1] <- min(f2$breaks[1], 0.95)
    
    p <- em.output[[j]]$em.fit$para$p
 
    # find the posterior probability
    errorprob.combined <- get.comp2.prob(rank.combined, p, f1, f2)

    # compute the FDR and find cutoff of posterior prob and the sig value
    o <- order(errorprob.combined)
    idr <- cumsum(errorprob.combined[o])/c(1:length(o))
    idr.index <- which(idr > idr.level)[1]
    errorprob.cutoff <- errorprob.combined[o][idr.index]

    # find the minimum significant measure among selected peaks
    sig.value <- min(combined.region$sig.value[o][1:idr.index])
  #  sig.value <- quantile(combined.region$sig.value[o][1:idr.index], prob=0.05)
#sig.value <- quantile(combined.region$sig.value[errorprob.combined<=errorprob.cutoff], prob=0.05)
    
    # apply the significant value on the whole pooled list
    combined.selected <- combined[combined$sig.value >= sig.value,]

    combined.selected.all <- rbind(combined.selected.all, combined.selected)
  }

  is.repeated <- duplicated(combined.selected.all$start)
  combined.selected.all <- combined.selected.all[!is.repeated,]

  npeak <- nrow(combined.selected.all)  
  
  npeak.stat <- list(idr.level=idr.level, npeak=npeak)

  sig.combined <- c(min(combined.selected.all[,"sig.value"], na.rm=T), max(combined.selected.all[,"sig.value"], na.rm=T))

 #  idr.combined <- c(min(combined.selected.all[,"q.value"], na.rm=T), max(combined.selected.all[,"q.value"], na.rm=T))
 # combined.selected.all <- deconcatenate.chr(combined.selected.all, chr.size)[,c("chr", "start", "stop", "signal.value", "p.value", "q.value")]

  combined.selected.all <- combined.selected.all[,  c("chr", "start.ori", "stop.ori", "signal.value", "p.value", "q.value")]
  colnames(combined.selected.all) <- c("chr", "start", "stop", "signal.value", "p.value", "q.value")
  
  invisible(list(npeak.stat=npeak.stat, combined.selected=combined.selected.all, sig.combined=sig.combined))
}



# get the posterior probability of the 2nd component
get.comp2.prob <- function(x, p, f1, f2){

  # get pdf and cdf of each component from functions in the corresponding component 
  px.1 <- sapply(x, get.pdf, df=f1)
  px.2 <- sapply(x, get.pdf, df=f2)

  comp2prob <- 1 - p*px.1/(p*px.1+(1-p)*px.2)
  
  return(comp2prob)
}

keep.match <- function(sample1, sample2, sig.value.impute=0){

  sample1.prune <- sample1[sample1$sig.value > sig.value.impute & sample2$sig.value > sig.value.impute,]
  sample2.prune <- sample2[sample1$sig.value > sig.value.impute & sample2$sig.value > sig.value.impute,]
 
  invisible(list(sample1=sample1.prune, sample2=sample2.prune))
}


##############################################
#
# The following is for simulation
#
##############################################


# simulate gaussian copula
# u is the uniform random variable and rho is correlation coefficient 
simu.gaussian.copula <- function(u, rho){

  n <- length(u)

  # simulate y given x=qnorm(u)
  y <- qnorm(u)*rho + rnorm(n)*sqrt(1-rho^2)

  v <- pnorm(y)

  invisible(v)
}

## simulate Clayton copula from its generating function
## Genest and MacKay (1986)

phi.ori <- function(t, s){

 (t^(-s) -1)/s
}


phi.inv <- function(y, s){

  exp(-log(s*y+1)/s)
}

phi.der <- function(t, s){

  -t^(-s-1)
}

phi.der.inv <- function(y, s){

  exp(log(-y)/(-s-1))
}

get.w <- function(u, t, s){

  phi.der.inv(phi.der(u, s)/t, s)
} 

get.v <- function(w, u, s){

  phi.inv(phi.ori(w, s) - phi.ori(u, s), s) 
}

# u is a uniform random variable, s is the association parameter
simu.clayton.copula <- function(u, s){

  t <- runif(length(u))

  if(s>0){
    w <- get.w(u, t, s)
    v <- get.v(w, u, s)
    return(v)    
  }

  if(s==0){
    return(t)
  }

  if(s <0){
    print("Invalid association parameters for clayton copula")
  }
  
}



###### 09-09-09

# simulate a two-component copula mixture:
# - marginal distributions for the two variables in each component are both 
#   normal and with the same parameters 
# p is the mixing proportion of component 1
# n is the total sample size
simu.copula.2mix <- function(s1, s2, p, n, mu1, mu2, sd1, sd2, copula.txt){

  n1 <- round(n*p)
  n2 <- n-n1

  u1 <- runif(n1)
  
  if(copula.txt =="clayton")
    v1 <- simu.clayton.copula(u1, s1)
  else{
    if(copula.txt =="gaussian")
      v1 <- simu.gaussian.copula(u1, s1)
  }

  u2 <- runif(n2)

  if(copula.txt =="clayton")
    v2 <- simu.clayton.copula(u2, s2)
  else{
    if(copula.txt =="gaussian")
      v2 <- simu.gaussian.copula(u2, s2)
  }

  # generate test statistics
  sample1.1 <- qnorm(u1, mu1, sd1)
  sample1.2 <- qnorm(v1, mu1, sd1)

  sample2.1 <- qnorm(u2, mu2, sd2)
  sample2.2 <- qnorm(v2, mu2, sd2)

  return(list(u=c(u1, u2), v=c(v1, v2), 
              u.inv=c(sample1.1, sample2.1), v.inv=c(sample1.2, sample2.2),
              label=c(rep(1, n1), rep(2, n2))))
}

# using inverse of the cdf to generate original observations 

simu.copula.2mix.inv <- function(s1, s2, p, n, cdf1.x, cdf1.y, cdf2.x, cdf2.y, copula.txt){

  n1 <- round(n*p)
  n2 <- n-n1

  u1 <- runif(n1)
  
  if(copula.txt =="clayton")
    v1 <- simu.clayton.copula(u1, s1)
  else{
    if(copula.txt =="gaussian")
      v1 <- simu.gaussian.copula(u1, s1)
  }

  u2 <- runif(n2)

  if(copula.txt =="clayton")
    v2 <- simu.clayton.copula(u2, s2)
  else{
    if(copula.txt =="gaussian")
      v2 <- simu.gaussian.copula(u2, s2)
  }

  # generate test statistics
#  sample1.1 <- qnorm(u1, mu1, sd1)
#  sample1.2 <- qnorm(v1, mu1, sd1)

#  sample2.1 <- qnorm(u2, mu2, sd2)
#  sample2.2 <- qnorm(v2, mu2, sd2)
  
  sample1.x <- inv.cdf.vec(u1, cdf1.x)
  sample1.y <- inv.cdf.vec(v1, cdf1.y)

  sample2.x <- inv.cdf.vec(u2, cdf2.x)
  sample2.y <- inv.cdf.vec(v2, cdf2.y)
  
  
  return(list(u=c(u1, u2), v=c(v1, v2), 
              u.inv=c(sample1.x, sample2.x), v.inv=c(sample1.y, sample2.y),
              label=c(rep(1, n1), rep(2, n2))))
}

# obtain original observation by converting cdf into quantiles
# u is one cdf
# u.cdf is a cdf (assuming it is a histogram) and has the break points (cdf$cdf and cdf$breaks)
# the smallest value of cdf=0 and the largest =1 
inv.cdf <- function(u, u.cdf){

  # which bin it falls into
  i <- which(u.cdf$cdf> u)[1]
  q.u  <- (u - u.cdf$cdf[i-1])/(u.cdf$cdf[i] - u.cdf$cdf[i-1])* (u.cdf$breaks[i]-u.cdf$breaks[i-1]) + u.cdf$breaks[i-1]

  return(q.u)
}

inv.cdf.vec <- function(u, u.cdf){

  # check if cdf has the right range (0, 1)  
  ncdf <- length(u.cdf$cdf)
  nbreaks <- length(u.cdf$breaks)
  
  if(ncdf == nbreaks-1 & u.cdf$cdf[ncdf]< 1)
    u.cdf[ncdf] <- 1
    
  q.u <- sapply(u, inv.cdf, u.cdf)

  return(q.u) 
}

# here we simulate a likely real situation
# the test statistics from two normal distributions
# according to their labels, then convert them into p-values w.r.t H0 using
# one-sided test.
# The test statistics are correlated for the signal component and independent
# for the noise component
# For the signal component, Y = X + eps, where eps ~ N(0, sigma^2)
simu.test.stat <- function(p, n, mu1, sd1, mu0, sd0, sd.e){

  # first component - signal
  n.signal <- round(n*p)
  n.noise <- n - n.signal

  # labels
  labels <- c(rep(1, n.signal), rep(0, n.noise))
  
  # test statistics for signal and noise
  mu.signal <- rnorm(n.signal, mu1, sd1)
  x.signal <- mu.signal + rnorm(n.signal, 0, sd.e)
  x.noise <- rnorm(n.noise, mu0, sd0) + rnorm(n.noise, 0, sd.e)

  y.signal <- mu.signal + rnorm(n.signal, 0, sd.e)
                                        # sd.e can be dependent on signal
  y.noise <- rnorm(n.noise, mu0, sd0) + rnorm(n.noise, 0, sd.e)

  # concatenate
  x <- c(x.signal, x.noise)
  y <- c(y.signal, y.noise)
  
  # convert to p-values based on H0
  p.x <- 1-pnorm(x, mu0, sqrt(sd0^2+sd.e^2))
  p.y <- 1-pnorm(y, mu0, sqrt(sd0^2+sd.e^2))

  return(list(p.x=p.x, p.y=p.y, x=x, y=y, labels=labels))
  
}

# compute the tradeoff and calibration
forward.decoy.tradeoff.ndecoy <- function(xx, labels, ndecoy){

  xx <- round(xx, 5) 
  o <- order(xx, decreasing=T)

  rand <- 1-labels # if rand==0, consistent
  # order the random indicator in the same order
  rand.o <- rand[o]

  if(sum(rand.o) > ndecoy){
    index.decoy <- which(cumsum(rand.o)==ndecoy)
  } else {
    index.decoy <- which(cumsum(rand.o)==sum(rand.o))
  }
  
  cutoff.decoy <- xx[o][index.decoy]
    
  # only consider the unique ones
  cutoff.unique <- unique(xx[o])

  cutoff <- cutoff.unique[cutoff.unique >= cutoff.decoy[length(cutoff.decoy)]]

   get.decoy.count <- function(cut.off){
     above <- rep(0, length(xx))
     above[xx >= cut.off] <- 1
     decoy.count <- sum(above==1 & rand==1)     
     return(decoy.count)
   }

   get.forward.count <- function(cut.off){
     above <- rep(0, length(xx))
     above[xx >= cut.off] <- 1
     forward.count <- sum(above==1 & rand==0)
     return(forward.count)
   }

   get.est.fdr <- function(cut.off){
     above <- rep(0, length(xx))
     above[xx >= cut.off] <- 1
     est.fdr <- 1-mean(xx[above==1])
     return(est.fdr)
   }

  # assuming rand=0 is right
   get.false.neg.count <- function(cut.off){
     below <- rep(0, length(xx))
     below[xx < cut.off] <- 1
     false.neg.count <- sum(below==1 & rand==0)
     return(false.neg.count)
   }

  get.false.pos.count <- function(cut.off){
     above <- rep(0, length(xx))
     above[xx >= cut.off] <- 1
     false.pos.count <- sum(above==1 & rand==1)
     return(false.pos.count)
   } 

   decoy <- sapply(cutoff, get.decoy.count)
   forward <- sapply(cutoff, get.forward.count)

   est.fdr <- sapply(cutoff, get.est.fdr)
   emp.fdr <- decoy/(decoy+forward)
  
   # compute specificity and sensitivity
   # assuming rand=1 is wrong and rand=0 is right
   false.neg <- sapply(cutoff, get.false.neg.count)
   false.pos <- sapply(cutoff, get.false.pos.count)
  
   true.pos <- sum(rand==0)-false.neg
   true.neg <- sum(rand==1)-false.pos
  
   sensitivity <- true.pos/(true.pos+false.neg)
   specificity <- true.neg/(true.neg+false.pos)
  
   return(list(decoy=decoy, forward=forward, cutoff=cutoff, est.fdr=est.fdr, emp.fdr=emp.fdr, sensitivity=sensitivity, specificity=specificity))  
}


# compute the em for jackknife and all data, and find FDR
get.emp.jack <- function(a, p0){

  nobs <- length(a$labels)
  est <- list()
  est.all <- list()

  temp.all <- em.transform(-a$p.x, -a$p.y, mu=1.5, sigma=1.4, rho=0.4, p=0.7, eps=0.01)
#  temp.all <- em.2copula.quick(a$p.x, a$p.y, p0=p0, rho1.0=0.7,
#      rho2.0=0, eps=0.01, fix.p=T, stoc=F, fix.rho2=T, "gaussian")

  est.all$p <- temp.all$para$p
  est.all$rho1 <- temp.all$para$rho1
  est.all$FDR <- get.FDR(temp.all$e.z)

  FDR <- list()
  p <- c()
  rho1 <- c()


  for(i in 1:nobs){

    temp <- em.transform(-a$p.x[-i], -a$p.y[-i], mu=1.5, sigma=1.4, rho=0.4, p=0.7, eps=0.01)    
#    temp <- em.2copula.quick(a$p.x[-i], a$p.y[-i], p0=p0, rho1.0=0.7,
#      rho2.0=0, eps=0.01, fix.p=T, stoc=F, fix.rho2=T, "gaussian")

    est[[i]] <- list(p=temp$para$p, rho1=temp$para$rho1, FDR=get.FDR(temp$e.z))

    FDR[[i]] <- est[[i]]$FDR # this is the FDR for top n peaks
    p[i] <- est[[i]]$p
    rho1[i] <- est[[i]]$rho1 
  }

  est.jack <- list(FDR=FDR, p=p, rho1=rho1) 
  return(list(est.jack=est.jack, est.all=est.all))
}


# get the npeaks corresponding to the nominal FDR estimated from the sample
# and find the corresponding FDR from the entire data
get.FDR.jack <- function(est, FDR.nominal){
  
  nobs <- length(est$est.jack$FDR)
  FDR.all <- c()  
  top.n <- c()
  
  for(i in 1:nobs){
    top.n[i] <- max(which(est$est.jack$FDR[[i]] <= FDR.nominal))
    FDR.all[i] <- est$est.all$FDR[top.n[i]]
  }
  
  invisible(list(FDR.all=FDR.all, top.n=top.n))
}

# compute Jackknife peudonumber
# a is the dataset
get.emp.IF <- function(a, p0){

  nobs <- length(a$labels)
  est <- list()
  est.all <- list()

  temp.all <- em.2copula.quick(a$p.x, a$p.y, p0=p0, rho1.0=0.7,
      rho2.0=0, eps=0.01, fix.p=T, stoc=F, fix.rho2=T, "gaussian")

  est.all$p <- temp.all$para$p
  est.all$rho1 <- temp.all$para$rho1
  est.all$FDR <- get.FDR(temp.all$e.z)

  IF.FDR <- list()
  IF.p <- c()
  IF.rho1 <- c()
  
  for(i in 1:nobs){
    
    temp <- em.2copula.quick(a$p.x[-i], a$p.y[-i], p0=p0, rho1.0=0.7,
      rho2.0=0, eps=0.01, fix.p=T, stoc=F, fix.rho2=T, "gaussian")

    est[[i]] <- list(p=temp$para$p, rho1=temp$para$rho1, FDR=get.FDR(temp$e.z))

    IF.FDR[[i]] <- (nobs-1)*(est.all$FDR[-nobs] - est[[i]]$FDR) # this is the FDR for top n peaks
    IF.p[i] <- (nobs-1)*(est.all$p - est[[i]]$p)
    IF.rho1[i] <- (nobs-1)*(est.all$rho1 - est[[i]]$rho1) 
  }

  emp.IF <- list(FDR=IF.FDR, p=IF.p, rho1=IF.rho1) 

  invisible(list(emp.IF=emp.IF, est.all=est.all, est=est))
}

# e.z is the posterior probability of being in signal component
get.FDR <- function(e.z){

  e.z.o <- order(1-e.z)
  FDR <- cumsum(1-e.z[e.z.o])/c(1:length(e.z.o))

  invisible(FDR)
}

# get the FDR of selecting the top n peaks
# IF.est is the sample influence function
# top.n
get.IF.FDR <- function(IF.est, top.n){

  nobs <- length(IF.est$emp.IF$FDR)
  FDR <- c()  
  
  # influence function of p
  for(i in 1:nobs)
    FDR[i] <- IF.est$emp.IF$FDR[[i]][top.n]
  
  invisible(FDR)
}

# get the sample influence function for FDR at a given FDR size
# 1. find the number of peaks selected at a given FDR computed from all obs
# 2. use the number to find the sample influence function for FDR
# IF.est$est.all is the FDR with all peaks
get.IF.FDR.all <- function(IF.est, FDR.size){

  top.n <- which.min(abs(IF.est$est.all$FDR -FDR.size))
  nobs <- length(IF.est$est.all$FDR)
  FDR <- c()  
  
  # influence function of p
  for(i in 1:nobs)
    FDR[i] <- IF.est$emp.IF$FDR[[i]][top.n]
  
  invisible(list(FDR=FDR, top.n=top.n))
}

plot.simu.uri <- function(x, y){

  tt <- seq(0.01, 0.99, by=0.01)
  uri <- sapply(tt, comp.uri.prob, u=x, v=y)
  uri.thin <- uri[seq(1, length(tt), by=3)]
  tt.thin <- tt[seq(1, length(tt), by=3)]
  duri <- (uri.thin[-1]-uri.thin[-length(uri.thin)])/(tt.thin[-1]-tt.thin[-length(tt.thin)])
  uri.spl <- smooth.spline(tt, uri, df=6.4)
  uri.der <- predict(uri.spl, tt, deriv=1)

  par(mfrow=c(2,2))
  plot(x[1:n0], y[1:n0])
  points(x[(n0+1):n], y[(n0+1):n], col=2)
  plot(rank(-x)[1:n0], rank(-y)[1:n0])
  points(rank(-x)[(1+n0):n], rank(-y)[(1+n0):n])
  plot(tt, uri)
  lines(c(0,1), c(0,1), lty=2)
  title(paste("rho1=", rho1, " rho2=", rho2, "p=", p, sep=""))
  plot(tt.thin[-1], duri)
  lines(uri.der)
  abline(h=1)
  invisible(list(x=x, y=y, uri=uri, tt=tt, duri=duri, tt.thin=tt.thin, uri.der=uri.der))

}


###### new fitting procedure




# 1. rank pairs

# 2. initialization
# 3. convert to pseudo-number

# 4. EM

# need plugin and test
# find the middle point between the bins
get.pseudo.mix <- function(x, mu, sigma, rho, p){

  
  # first compute cdf for points on the grid
  # generate 200 points between [-3, mu+3*sigma]
  nw <- 1000
  w <- seq(min(-3, mu-3*sigma), max(mu+3*sigma, 3), length=nw) 
  w.cdf <- p*pnorm(w, mean=mu, sd=sigma) + (1-p)*pnorm(w, mean=0, sd=1)

  i <- 1

  quan.x <- rep(NA, length(x))

  for(i in c(1:nw)){
    index <- which(x >= w.cdf[i] & x < w.cdf[i+1])
    quan.x[index] <- (x[index]-w.cdf[i])*(w[i+1]-w[i])/(w.cdf[i+1]-w.cdf[i]) +w[i]
  }

  index <- which(x < w.cdf[1])
  if(length(index)>0)
    quan.x[index] <- w[1]

  index <- which(x > w.cdf[nw])
  if(length(index)>0)
    quan.x[index] <- w[nw]  
  
#  linear.ext <- function(x, w, w.cdf){
  # linear interpolation
#    index.up <- which(w.cdf>= x)[1]
#    left.index <- which(w.cdf <=x)
#    index.down <- left.index[length(left.index)]
#    quan.x <- (w[index.up] + w[index.down])/2  
#  }
  
#  x.pseudo <- sapply(x, linear.ext, w=w, w.cdf=w.cdf)

#  invisible(x.pseudo)
  invisible(quan.x)
}


# EM to compute the latent structure
# steps:
# 1. raw values are first transformed into pseudovalues
# 2. EM is used to compute the underlining structure, which is a mixture
#    of two normals
em.transform <- function(x, y, mu, sigma, rho, p, eps){
  
  x.cdf.func <- ecdf(x)
  y.cdf.func <- ecdf(y)
  afactor <- length(x)/(length(x)+1)
  x.cdf <- x.cdf.func(x)*afactor
  y.cdf <- y.cdf.func(y)*afactor
  
  # initialization
  para <- list()
  para$mu <- mu
  para$sigma <- sigma
  para$rho <- rho
  para$p <- p  

  j <- 1
  to.run <- T
  loglik.trace <- c()
  loglik.inner.trace <- c()
  
  #to.run.inner <- T
  z.1 <- get.pseudo.mix(x.cdf, para$mu, para$sigma, para$rho, para$p)
  z.2 <- get.pseudo.mix(y.cdf, para$mu, para$sigma, para$rho, para$p)

#  cat("length(z1)", length(z.1), "\n")
  while(to.run){
    
    # get pseudo value in each cycle
#    z.1 <- get.pseudo.mix(x.cdf, para$mu, para$sigma, para$rho, para$p)
#    z.2 <- get.pseudo.mix(y.cdf, para$mu, para$sigma, para$rho, para$p)

    i <- 1
    while(to.run){
      
      # EM for latent structure
      e.z <- e.step.2normal(z.1, z.2, para$mu, para$sigma, para$rho, para$p)
      para <- m.step.2normal(z.1, z.2, e.z)
#para$rho <- rho
#para$p <- p    
#para$mu <- mu
#para$sigma <- sigma    
      if(i > 1)
        l.old <- l.new
    
      # this is just the mixture likelihood of two-component Gaussian
      l.new <- loglik.2binormal(z.1, z.2, para$mu, para$sigma, para$rho, para$p)

      loglik.inner.trace[i] <- l.new 

      if(i > 1){
        to.run <- loglik.inner.trace[i]-loglik.inner.trace[i-1]>eps         
      }
        
    
#      if(i > 2){
#        l.inf <- loglik.inner.trace[i-2] + (loglik.inner.trace[i-1] - loglik.inner.trace[i-2])/(1-(loglik.inner.trace[i]-loglik.inner.trace[i-1])/(loglik.inner.trace[i-1]-loglik.inner.trace[i-2]))

#        if(loglik.inner.trace[i-1]!=loglik.inner.trace[i-2])
#          to.run <- abs(l.inf - loglik.inner.trace[i]) > eps
#        else
#          to.run <- F
          
#      }

      cat("loglik.inner.trace[", i, "]=", loglik.inner.trace[i], "\n")
    cat("mu=", para$mu, "sigma=", para$sigma, "p=", para$p, "rho=", para$rho, "\n\n")
      
      i <- i+1
    }
    

    # get pseudo value in each cycle
    z.1 <- get.pseudo.mix(x.cdf, para$mu, para$sigma, para$rho, para$p)
    z.2 <- get.pseudo.mix(y.cdf, para$mu, para$sigma, para$rho, para$p)

    if(j > 1)
      l.old.outer <- l.new.outer

    l.new.outer <- loglik.2binormal(z.1, z.2, para$mu, para$sigma, para$rho, para$p)

    loglik.trace[j] <- l.new.outer
    
    if(j == 1)
      to.run <- T
    else{ # stop when iteration>100
      if(j > 100)
        to.run <- F
      else
        to.run <- l.new.outer - l.old.outer > eps
    }

#    if(j %% 10==0)
      cat("loglik.trace[", j, "]=", loglik.trace[j], "\n")
    cat("mu=", para$mu, "sigma=", para$sigma, "p=", para$p, "rho=", para$rho, "\n")
    
    j <- j+1
  }

  bic <- -2*l.new + 4*log(length(z.1))
  
  return(list(para=list(p=para$p, rho=para$rho, mu=para$mu, sigma=para$sigma),
              loglik=l.new, bic=bic, e.z=e.z, loglik.trace=loglik.trace))
}  




# compute log-likelihood for mixture of two bivariate normals
loglik.2binormal <- function(z.1, z.2, mu, sigma, rho, p){

  l.m <- sum(d.binormal(z.1, z.2, 0, 1, 0)+log(p*exp(d.binormal(z.1, z.2, mu, sigma, rho)-d.binormal(z.1, z.2, 0, 1, 0))+(1-p)))
  
#  l.m <- sum((p*d.binormal(z.1, z.2, mu, sigma, rho) + (1-p)*d.binormal(z.1, z.2, 0, 1, 0)))
  return(l.m) 
}

# check this when rho=1

# density of binomial distribution with equal mean and sigma on both dimensions
d.binormal <- function(z.1, z.2, mu, sigma, rho){

  loglik <- (-log(2)-log(pi)-2*log(sigma) - log(1-rho^2)/2 - (0.5/(1-rho^2)/sigma^2)*((z.1-mu)^2 -2*rho*(z.1-mu)*(z.2-mu) + (z.2-mu)^2))

  return(loglik)
}

# E-step for computing the latent strucutre
# e.z is the prob to be in the consistent group
# e.step for estimating posterior prob
# z.1 and z.2 can be vectors or scalars
e.step.2normal <- function(z.1, z.2, mu, sigma, rho, p){

  e.z <- p/((1-p)*exp(d.binormal(z.1, z.2, 0, 1, 0)-d.binormal(z.1, z.2, mu, sigma, rho))+ p)
  
  invisible(e.z)
}

# M-step for computing the latent structure
# m.step for estimating proportion, mean, sd and correlation coefficient
m.step.2normal <- function(z.1, z.2, e.z){

  p <- mean(e.z)
  mu <- sum((z.1+z.2)*e.z)/2/sum(e.z) 
  sigma <- sqrt(sum(e.z*((z.1-mu)^2+(z.2-mu)^2))/2/sum(e.z))
  rho <- 2*sum(e.z*(z.1-mu)*(z.2-mu))/(sum(e.z*((z.1-mu)^2+(z.2-mu)^2)))

  return(list(p=p, mu=mu, sigma=sigma, rho=rho))
}


# assume top p percent of observations are true
# x and y are ranks, estimate
init <- function(x, y, x.label){
  
  x.o <- order(x)

  x.ordered <- x[x.o]
  y.ordered <- y[x.o]
  x.label.ordered <- x.label[x.o]
  
  n <- length(x)
  p <- sum(x.label)/n
  
  rho <- cor(x.ordered[1:ceiling(p*n)], y.ordered[1:ceiling(p*n)])

  temp <- find.mu.sigma(x.ordered, x.label.ordered)
  mu <- temp$mu
  sigma <- temp$sigma
  
  invisible(list(mu=mu, sigma=sigma, rho=rho, p=p))

}

# find mu and sigma if the distributions of marginal ranks are known
# take the medians of the two dist and map back to the original
init.dist <- function(f0, f1){

  # take the median in f0
  index.median.0 <- which(f0$cdf>0.5)[1]
  q.0.small <- f0$cdf[index.median.0] # because f0 and f1 have the same bins
  q.1.small <- f1$cdf[index.median.0]

  # take the median in f1
  index.median.1 <- which(f1$cdf>0.5)[1]
  q.0.big <- f0$cdf[index.median.1] # because f0 and f1 have the same bins
  q.1.big <- f1$cdf[index.median.1]

  # find pseudo value for x.middle[1] on normal(0,1) 
  pseudo.small.0 <- qnorm(q.0.small, mean=0, sd=1)
  pseudo.small.1 <- qnorm(q.1.small, mean=0, sd=1)

  # find pseudo value for x.middle[2] on normal(0,1) 
  pseudo.big.0 <- qnorm(q.0.big, mean=0, sd=1)
  pseudo.big.1 <- qnorm(q.1.big, mean=0, sd=1)

  mu <- (pseudo.small.0*pseudo.big.1 - pseudo.small.1*pseudo.big.0)/(pseudo.big.1-pseudo.small.1) 

  sigma <- (pseudo.small.0-mu)/pseudo.small.1

  return(list(mu=mu, sigma=sigma))  
}

# generate labels

# find the part of data with overlap

# find the percentile on noise and signal

# Suppose there are signal and noise components, with mean=0 and sd=1 for noise
# x and x.label are the rank of the observations and their labels,
# find the mean and sd of the other component
# x.label takes values of 0 and 1
find.mu.sigma <- function(x, x.label){

  x.0 <- x[x.label==0]
  x.1 <- x[x.label==1]

  n.x0 <- length(x.0)
  n.x1 <- length(x.1)

  x.end <- c(min(x.0), min(x.1), max(x.0), max(x.1))
  o <- order(x.end)
  x.middle <- x.end[o][c(2,3)]

  # the smaller end of the overlap
  q.1.small <- mean(x.1 <= x.middle[1])*n.x1/(n.x1+1)
  q.0.small <- mean(x.0 <= x.middle[1])*n.x0/(n.x0+1)

  # the bigger end of the overlap
  q.1.big <- mean(x.1 <= x.middle[2])*n.x1/(n.x1+1)
  q.0.big <- mean(x.0 <= x.middle[2])*n.x0/(n.x0+1)

  # find pseudo value for x.middle[1] on normal(0,1) 
  pseudo.small.0 <- qnorm(q.0.small, mean=0, sd=1)
  pseudo.small.1 <- qnorm(q.1.small, mean=0, sd=1)

  # find pseudo value for x.middle[2] on normal(0,1) 
  pseudo.big.0 <- qnorm(q.0.big, mean=0, sd=1)
  pseudo.big.1 <- qnorm(q.1.big, mean=0, sd=1)

  mu <- (pseudo.small.0*pseudo.big.1 - pseudo.small.1*pseudo.big.0)/(pseudo.big.1-pseudo.small.1) 

  sigma <- (pseudo.small.0-mu)/pseudo.small.1

  return(list(mu=mu, sigma=sigma))
}

#
#  pliu 20160911
#
#  install Bioconductor and pRSEM-required libraries to this directory
#
#  require R-3.3.1
#
#  CRAN: data.table, caTools
#  Local: spp
#  BioC v3.3: ShortRead, GenomicRanges
#
#  install devtools first and use its' install_version to install packages in
#  particular version.
#
#  packages repos are obtained from
#  source("http://bioconductor.org/biocLite.R")
#  biocinstallRepos()
#

main <- function() {
  param <- list(
    lib_loc = './',
    repos = list(
      BioCsoft  = "http://bioconductor.org/packages/3.3/bioc/",
      BioCann   = "http://bioconductor.org/packages/3.3/data/annotation/",
      BioCexp   = "http://bioconductor.org/packages/3.3/data/experiment/",
      BioCextra = "http://bioconductor.org/packages/3.3/extra/",
      CRAN      = "http://cran.us.r-project.org"
    ),

    pkg_spp  = '../phantompeakqualtools/spp_1.10.1_on_R3.3/',

    pkg2ver = list(
      ## name          version
      caTools       = '1.17.1',  ## for spp
      data.table    = '1.9.6',
      GenomicRanges = '1.24.3',
      ShortRead     = '1.30.0'
    )
  )

  options(repos=structure(c(CRAN=param$repos$CRAN)))
  installRLib(param)
}


installRLib <- function(param) {
  prsem_installed_pkgs <- rownames(installed.packages(lib.loc=param$lib_loc))

  if ( ! 'devtools' %in% prsem_installed_pkgs ) {
    install.packages('devtools', lib=param$lib_loc, type='source')
  }

  .libPaths(c(param$lib_loc, .libPaths()))
  library(devtools)

  for ( pkg_name in names(param$pkg2ver) ) {
    pkg_version <- param$pkg2ver[[pkg_name]]
    if ( ! pkg_name %in% prsem_installed_pkgs ) {
      install_version(pkg_name, version=pkg_version, repos=param$repos,
                      lib=param$lib_loc, type='source')
    }
  }

  if ( ! 'spp' %in% prsem_installed_pkgs ) {
    install.packages(param$pkg_spp, lib=param$lib_loc, repos=NULL,
                     type='source')
  }
}

main()

#
#  pliu 20150509
# 
#  module for processing ChIP-seq data
#

main <- function() {
  name2func <- list(
    'guessFqEncoding' = guessFqEncoding
  )

  argv <- commandArgs(trailingOnly=T)
  name2func[[argv[1]]](argv[2:length(argv)])
}


guessFqEncoding <- function(argv){
  .libPaths(c(argv[4], .libPaths()))
  suppressMessages(library(data.table))
  suppressMessages(library(ShortRead))

  nthr      <- strtoi(argv[1])
  s_infiles <- argv[2]
  fout      <- argv[3]

  files <- strsplit(s_infiles, ',', fixed=T)[[1]]

 #lapply(files, guessFqEncodingByFile)

  ## cannot use mclapply here, ShortRead::qa function bound with BiocParallel
  ## have to use bplapply and define single core when call qa
  ## this new feature only appear in the new version of ShortRead
  register(MulticoreParam(workers=nthr))
  outdt <- rbindlist(bplapply(files, guessFqEncodingByFile))

  write.table(outdt, fout, sep="\t", quote=F, col.names=T, row.names=F)
 #cat('File written:', fout, "\n")
}


## exam and guess Fastq's quality score's format
guessFqEncodingByFile <- function(fq) {
  qual <- qa(fq, BPPARAM=registered()$SerialParam)
  bq <- qual[['baseQuality']]
  score <- subset(bq, bq$count > 0, select=c('score'))$score

  encod <- 'unknown'
  if ( any( strsplit(intToUtf8(33:58), '')[[1]] %in% score ) ) {
    encod <- '--phred33-quals'
  } else if ( any( strsplit(intToUtf8(59:64), '')[[1]] %in% score ) ) {
   #encod <- 'solexa ver. <1.3'
    encod <- '--solexa-quals'
  } else if ( any( strsplit(intToUtf8(75:104), '')[[1]] %in% score ) ) {
    encod <- '--phred64-quals'
  }

  return(list(file=fq, encoding=encod))
}


main()

# 1-20-10 Qunhua Li
#
# This program first plots correspondence curve and IDR threshold plot
# (i.e. number of selected peaks vs IDR) for each pair of sample
#
# It then performs consistency analysis on merged data
# It takes the parameters estimated from pairwise consistency analysis, and
# use the same parameters to determine threshold on the merged data
#
# usage: 
# Rscript batch-consistency-plot-merged.r [npairs] [output.dir] [input.file.prefix 1, 2, 3 ...] [half.width] [idr.level] [significant measure] [pooled.filename] [write out option] [overlap.ratio] [is.broadpeak]
# [npairs]: integer, number of consistency analyses
#          (e.g. if 2 replicates, npairs=1, if 3 replicates, npairs=3
# [output.dir]: output directory for plot
# [input.file.prefix 1, 2, 3]: prefix for the output from batch-consistency-analysis2. They are the input files for merged analysis see below for examples (i.e. saved.file.prefix). It can be multiple files
#
# The parameters below are for processing merged data
# [half.width]: -1 if using reported interval
# [idr.level]: threshold for idr
# [significant measure]: choose from "p.value", "q.value" or "signal.value"
# [pooled.filename]: peak caller output in narrowpeak or broadpeak format
# [write out option]: logical, T: write out selected peaks in merged data, F: not write out 
# [overlap.ratio]: minimum overlap for two peaks to be called as calling the
#  same region. A numerical value between 0 and 1. If 0, minimum overlap
#  is >=1bp.
# [is.broadpeak]:  a logical value. If broadpeak is used, set as T;
# if narrowpeak is used, set as F

args <- commandArgs(trailingOnly=T)

npair <- args[1] # number of curves to plot on the same figure
output.file.prefix <- args[2] # file name for plot, generated from script at the outer level

df.txt <- 10

## examples for debugging
#npair <- 3
#output.file.prefix <- "~/ENCODE/anshul/results/gm12878-cfos-YALE-combined-threshold/consistency-plot" 
#combofile <- "~/ENCODE/anshul/data/SPP.YaleGm12878Cfos.VS.Gm12878Input.PointPeak.narrowPeak"
#saved.file.prefix <- list()
#saved.file.prefix[[1]] <- "~/ENCODE/anshul/results/gm12878-cfos-YALE-combined-threshold/SPP.YaleRep1Gm12878Cfos.VS.SPP.YaleRep2Gm12878Cfos"
#saved.file.prefix[[2]] <- "~/ENCODE/anshul/results/gm12878-cfos-YALE-combined-threshold/SPP.YaleRep1Gm12878Cfos.VS.SPP.YaleRep3Gm12878Cfos"
#saved.file.prefix[[3]] <- "~/ENCODE/anshul/results/gm12878-cfos-YALE-combined-threshold/SPP.YaleRep2Gm12878Cfos.VS.SPP.YaleRep3Gm12878Cfos"

#npair <- 1
#output.file.prefix <- "~/ENCODE/anshul/results/gm12878-pol2-YALE-combined-threshold/consistency-plot" 
#combofile <- "~/ENCODE/anshul/data/SPP.YaleGm12878Pol2.VS.Gm12878Input.PointPeak.narrowPeak"
#saved.file.prefix <- "~/ENCODE/anshul/results/gm12878-pol2-YALE-combined-threshold/SPP.YaleRep1Gm12878Pol2.VS.SPP.YaleRep2Gm12878Pol2"


#ori.sig.value <- "signal.value"
# nominal.sig.value <- "q.value"
# idr.level <- 0.05
# half.width <- NULL
###################

# the df for plotting the smooth spline on the consistency curve
#if(length(args)-3> npair){ # if df is specified
#  df.txt <- as.numeric(args[length(args)]) # df for plotting, default is 10
#}else{ 
#  df.txt <- 10
#}

ntemp <- as.numeric(npair)

###### this is needed for pooled data

cat(as.numeric(args[3+ntemp]))
if(as.numeric(args[3+ntemp])==-1){ # enter -1 when using the reported length 
  half.width <- NULL
}else{
  half.width <- as.numeric(args[3+ntemp])
}


idr.level <- as.numeric(args[4+ntemp])  # this is the consistency FDR, e.g. 0.05
# a string: "signal.value", "p.value" or "q.value", for specifying which
# significant value to use for thresholding the merged data
ori.sig.value <- args[5+ntemp] 


# pooled data file
combofile <- args[6+ntemp]
is.write.out <- as.logical(args[7+ntemp])
overlap.ratio <- as.numeric(args[8+ntemp]) # the minimum amount of overlap to be called as an overlap

is.broadpeak <- args[9+ntemp]

saved.file.prefix <- list() # identifier of filenames that contain the em and URI results


source("functions-all-clayton-12-13.r")

uri.list <- list()
uri.list.match <- list()
ez.list <- list()
legend.txt <- c()
#fdr.map <- c()
sig.map <- list() 
em.output.list <- list()
uri.output.list <- list()

for(i in 1:npair){
  saved.file.prefix[i] <- args[2+i]
 
  load(paste(saved.file.prefix[i], "-uri.sav", sep=""))
  load(paste(saved.file.prefix[i], "-em.sav", sep=""))

  uri.output.list[[i]] <- uri.output
  em.output.list[[i]] <- em.output

  ez.list[[i]] <- get.ez.tt.all(em.output, uri.output.list[[i]]$data12.enrich$merge1,
                                uri.output.list[[i]]$data12.enrich$merge2, idr.level=idr.level) # reverse =T for error rate

  # URI for all peaks
  uri.list[[i]] <- uri.output$uri.n
  # URI for matched peaks
  uri.match <- get.uri.matched(em.output$data.pruned, df=df.txt)
  uri.list.match[[i]] <- uri.match$uri.n

  file.name <- unlist(strsplit(as.character(saved.file.prefix[i]), "/"))
  
  legend.txt[i] <- paste(i, "=", file.name[length(file.name)])
  sig.map[[i]] <- cbind(idr.level, ez.list[[i]]$map.uv)


  # map idr computed from consistency back to the original significant measure
  # 
  # if(is.null(nominal.sig.value)){
  #  sig.map <- cbind(idr.level, ez.list[[i]]$map.uv)
  #} else {

    # for SPP, need find the significant value based on FDR
  #  temp.map <- map.sig.value(uri.output$data12.enrich, ez.list[[i]]$map.uv, nominal.value=nominal.sig.value)
  #  sig.map <- cbind(idr.level, ez.list[[i]]$map.uv)
    # this is the corresponding FDR mapped from the significant value
    # you don't need this in general
  #  fdr.map <- cbind(idr.level, temp.map)
  #}

}

plot.uri.file <- paste(output.file.prefix, "-plot.ps", sep="")

cat("plot consistency plots\n")
############# plot and report output
# plot correspondence curve for each pair,
# plot number of selected peaks vs IDR 

# plot all into 1 file
postscript(paste(output.file.prefix, "-plot.ps", sep=""))
par(mfcol=c(2,3), mar=c(5,6,4,2)+0.1)
plot.uri.group(uri.list, NULL, file.name=NULL, c(1:npair), title.txt="all peaks")
plot.uri.group(uri.list.match, NULL, file.name=NULL, c(1:npair), title.txt="matched peaks")
plot.ez.group(ez.list, plot.dir=NULL, file.name=NULL, legend.txt=c(1:npair), y.lim=c(0, 0.6))
plot(0, 1, type="n", xlim=c(0,1), ylim=c(0,1), xlab="", ylab="", xaxt="n", yaxt="n") # legends
legend(0, 1, legend.txt, cex=0.6)

dev.off()

############### consistency cutoff on the replicates #############

cat("read pooled sample \n")
##################################################
########## now this part is for combined dataset
##################################################

chr.file <- "genome_table.txt"

chr.size <- read.table(chr.file)

# read combined data
combined.ori <- process.narrowpeak(paste(combofile, sep=""), chr.size, half.width=half.width, summit="offset", broadpeak=is.broadpeak)$data.cleaned

#combined <- combined.ori[, c("chr", "start", "stop", ori.sig.value, "signal.value", "p.value", "q.value", "start.chr", "stop.chr")]
#colnames(combined) <- c("chr", "start", "stop", "sig.value", "signal.value", "p.value", "q.value",  "start.chr", "stop.chr")

combined <- combined.ori[, c( ori.sig.value, "start", "stop","signal.value", "p.value", "q.value", "chr", "start.ori", "stop.ori")]
colnames(combined) <- c("sig.value", "start", "stop",  "signal.value", "p.value", "q.value", "chr", "start.ori", "stop.ori")
combined$frac.ratio <- NA

########
#  map by the matched structure
########
cat("Selecting peaks using parameters from consistency analysis\n")
sig.select.method2 <- pass.structure(uri.output.list, em.output.list, combined, idr.level=idr.level, sig.value.impute=0, chr.size)

if(is.write.out){
  write.table(sig.select.method2$combined.selected, file=paste(output.file.prefix, "-combined.selection.txt", sep=""), quote=F, row.names=F)
}

save(sig.select.method2, file=paste(output.file.prefix, "-select.sav", sep=""))


# output for ez
sink(paste(output.file.prefix, "-Rout.txt", sep=""))
cat("IDR Map for specified sig.value", "\n")
print(sig.map)

# cat("IDR Map for", nominal.sig.value, "\n")
# print(fdr.map)


# output for merged dataset
cat("Merged dataset has ", nrow(combined), "p\n")

cat("Apply parameters estimated from consistency analysis to merged data: select by ", ori.sig.value, "\n")
print(sig.select.method2$npeak.stat)
cat("Range of significant values on the selected pooled data", "\n")
print(sig.select.method2$sig.combined)

sink()

# modified 06/07/2015 pliu
#
# modified 3-29-10: Qunhua Li
# add 2 columns in the output of "-overlapped-peaks.txt": local.idr and IDR

# 01-20-2010 Qunhua Li
#
# This program performs consistency analysis for a pair of peak calling outputs
# It takes narrowPeak or broadPeak formats.
# 
# usage: Rscript batch-consistency-analysis2.r peakfile1 peakfile2 half.width outfile.prefix overlap.ratio  is.broadpeak sig.value
#
# peakfile1 and peakfile2 : the output from peak callers in narrowPeak or broadPeak format
# half.width: -1 if using the reported peak width, 
#             a numerical value to truncate the peaks to
# outfile.prefix: prefix of output file
# overlap.ratio: a value between 0 and 1. It controls how much overlaps two peaks need to have to be called as calling the same region. It is the ratio of overlap / short peak of the two. When setting at 0, it means as long as overlapped width >=1bp, two peaks are deemed as calling the same region.
# is.broadpeak: a logical value. If broadpeak is used, set as T; if narrowpeak is used, set as F
# sig.value: type of significant values, "q.value", "p.value" or "signal.value" (default, i.e. fold of enrichment)

args <- commandArgs(trailingOnly=T)

# consistency between peakfile1 and peakfile2
#input1.dir <- args[1]
#input2.dir <- args[2] # directories of the two input files
peakfile1 <- args[1]
peakfile2 <- args[2]

if(as.numeric(args[3])==-1){ # enter -1 when using the reported length 
  half.width <- NULL
}else{
  half.width <- as.numeric(args[3])
}


output.prefix <- args[4]
overlap.ratio <- args[5]

if(args[6] == "T"){
  is.broadpeak <- T
}else{
  is.broadpeak <- F
}

sig.value <- args[7]


#dir1 <- "~/ENCODE/anshul/data/"
#dir2 <- dir1
#peakfile1 <- "../data/SPP.YaleRep1Gm12878Cfos.VS.Gm12878Input.PointPeak.narrowPeak"
#peakfile2 <- "../data/SPP.YaleRep3Gm12878Cfos.VS.Gm12878Input.PointPeak.narrowPeak"
#half.width <- NULL
#overlap.ratio <- 0.1
#sig.value <- "signal.value"

## pliu
idr_code_path <- args[8]
source(paste0(idr_code_path, "/functions-all-clayton-12-13.r"))
#source("functions-all-clayton-12-13.r")
##

# read the length of the chromosomes, which will be used to concatenate chr's
## pliu 20150607
#chr.file <- "genome_table.txt"
chr.file <- args[9]
##

chr.size <- read.table(chr.file)


sink(paste(output.prefix, "-Rout.txt", sep=""))

############# process the data
cat("is.broadpeak", is.broadpeak, "\n")
# process data, summit: the representation of the location of summit
rep1 <- process.narrowpeak(paste(peakfile1, sep=""), chr.size, half.width=half.width, summit="offset", broadpeak=is.broadpeak)
rep2 <- process.narrowpeak(paste(peakfile2, sep=""), chr.size, half.width=half.width, summit="offset", broadpeak=is.broadpeak)

cat(paste("read", peakfile1, ": ", nrow(rep1$data.ori), "peaks\n", nrow(rep1$data.cleaned), "peaks are left after cleaning\n", peakfile2, ": ", nrow(rep2$data.ori), "peaks\n", nrow(rep2$data.cleaned), " peaks are left after cleaning"))

if(args[3]==-1){
  cat(paste("half.width=", "reported", "\n"))
}else{
  cat(paste("half.width=", half.width, "\n"))
}  
cat(paste("significant measure=", sig.value, "\n"))

# compute correspondence profile (URI)
uri.output <- compute.pair.uri(rep1$data.cleaned, rep2$data.cleaned, sig.value1=sig.value, sig.value2=sig.value, overlap.ratio=overlap.ratio)

#uri.output <- compute.pair.uri(rep1$data.cleaned, rep2$data.cleaned)

cat(paste("URI is done\n"))

# save output
save(uri.output, file=paste(output.prefix, "-uri.sav", sep=""))
cat(paste("URI is saved at: ", output.prefix, "-uri.sav \n", sep=""))


# EM procedure for inference
em.output <- fit.em(uri.output$data12.enrich, fix.rho2=T)

#em.output <- fit.2copula.em(uri.output$data12.enrich, fix.rho2=T, "gaussian")

cat(paste("EM is done\n\n"))


save(em.output, file=paste(output.prefix, "-em.sav", sep=""))
cat(paste("EM is saved at: ", output.prefix, "-em.sav \n", sep=""))


# write em output into a file

cat(paste("EM estimation for the following files\n", peakfile1, "\n", peakfile2, "\n", sep=""))

print(em.output$em.fit$para)

# add on 3-29-10
# output both local idr and IDR
idr.local <- 1-em.output$em.fit$e.z
IDR <- c()
o <- order(idr.local)
IDR[o] <- cumsum(idr.local[o])/c(1:length(o))


write.out.data <- data.frame(chr1=em.output$data.pruned$sample1[, "chr"],
                    start1=em.output$data.pruned$sample1[, "start.ori"],
                    stop1=em.output$data.pruned$sample1[, "stop.ori"],
                    sig.value1=em.output$data.pruned$sample1[, "sig.value"],   
                    chr2=em.output$data.pruned$sample2[, "chr"],
                    start2=em.output$data.pruned$sample2[, "start.ori"],
                    stop2=em.output$data.pruned$sample2[, "stop.ori"],
                    sig.value2=em.output$data.pruned$sample2[, "sig.value"],
                    idr.local=1-em.output$em.fit$e.z, IDR=IDR)

write.table(write.out.data, file=paste(output.prefix, "-overlapped-peaks.txt", sep=""))
cat(paste("Write overlapped peaks and local idr to: ", output.prefix, "-overlapped-peaks.txt\n", sep=""))

# number of peaks passing IDR range (0.01-0.25)
IDR.cutoff <- seq(0.01, 0.25, by=0.01)
idr.o <- order(write.out.data$idr.local)
idr.ordered <- write.out.data$idr.local[idr.o]
IDR.sum <- cumsum(idr.ordered)/c(1:length(idr.ordered))

IDR.count <- c()
n.cutoff <- length(IDR.cutoff)
for(i in 1:n.cutoff){
  IDR.count[i] <- sum(IDR.sum <= IDR.cutoff[i])
}


# write the number of peaks passing various IDR range into a file
idr.cut <- data.frame(peakfile1, peakfile2, IDR.cutoff=IDR.cutoff, IDR.count=IDR.count)
write.table(idr.cut, file=paste(output.prefix,"-npeaks-aboveIDR.txt", sep=""), append=T, quote=F, row.names=F, col.names=F)
cat(paste("Write number of peaks above IDR cutoff [0.01, 0.25]: ","npeaks-aboveIDR.txt\n", sep=""))

mar.mean <- get.mar.mean(em.output$em.fit)

cat(paste("Marginal mean of two components:\n"))
print(mar.mean)

sink()

#!/bin/bash
# $1: file containing arguments for batch-consistency-plot-merged3.r
# File has 4 tab-delimited fields
# [nPairs]\t[combOutFilePrefix]\t[pairOutFilePrefix,...]\t[combPeakFile]
# $2: idrThreshold (OPTIONAL: default is 0.1)
# $3: fdrThreshold (OPTIONAL: default is 0.7)
# Rscript batch-consistency-plot-merged2.r [npairs] [output.prefix] [input.file.prefix 1, 2, 3 ...] -1 [idr.level] signal.value [pooled.filename] T 0 F

if [[ "$#" -lt 1 ]]
then
	echo 'submit.idrmerge.lsf.sh:'  1>&2
	echo 'Submits jobs to run IDR code on pooled peak calls'  1>&2
	echo 'USAGE:'  1>&2
	echo 'submit.idrmerge.lsf.sh <idrMergeArgFile> <OPTIONAL:idrThresh> <OPTIONAL:fdrThresh>'  1>&2
	echo '<idrMergeArgFile>: File has 4 tab-delimited fields' 1>&2
	echo '					[nPairs]\t[combOutFilePrefix]\t[pairOutFilePrefix,...]\t[combPeakFile]' 1>&2
	echo '<idrThresh>: OPTIONAL: Default of 0.1' 1>&2
	echo '<fdrThresh>: OPTIONAL: Default of 0.7' 1>&2
	exit 1
fi

idrlevel='0.1'
if [[ "$#" -ge 2 ]]; then idrlevel=$2 ; fi     
fdrthresh='0.7'
if [[ "$#" -ge 3 ]]; then fdrthresh=$3 ; fi     
fdrthresh=$(echo ${fdrthresh} | awk '{print -log($1)/log(10)}') # convert fdrthreshold or logscale

rpath=`which Rscript`
# TEMPORARY DIRECTORY
#TMP='/scratch/users/akundaje/temp'

while read inputline
do

  npairs="$(echo $inputline | awk '{print $1}')" # extract npairs
  ofPrefix="$(echo $inputline | awk '{print $2}')" # extract output.prefix
  ifPrefix="$(echo $inputline | awk '{print $3}' | sed -r 's/,/ /g')" # extract input.prefixes
  combFname="$(echo $inputline | awk '{print $4}')" # extract merged peak file name
  echo "${ofPrefix}"
  logfile="${ofPrefix}.log"
  randseed="$RANDOM"

  # Create submitScript
  submitScript="tempMerge_${randseed}.sh"
  echo '#!/bin/bash' > "${submitScript}"  

  if [[ `echo ${combFname} | grep -E '\.gz$'` ]]
  then
    isgz='1'
    combStub="$(echo ${combFname} | sed -r -e 's:\.gz$::g' -e 's:^.*/::g')" # remove .gz and remove the directory name
    combPeakFile="${TMP}/${combStub}_${randseed}"
    # echo "gunzip -c ${combFname} > ${combPeakFile}" >> "${submitScript}"
  else
    isgz='0'
    combPeakFile="${combFname}"
  fi
 
  combPeakFile='random.txt'
  echo "${rpath} batch-consistency-plot-merged2.r ${npairs} ${ofPrefix} ${ifPrefix} -1 ${idrlevel} signal.value ${combPeakFile} T 0 F" >> "${submitScript}"

  if [[ "${isgz}" == '1' ]]
  then
    echo "rm -f ${combPeakFile}" >> "${submitScript}"
  fi
  
  chmod 755 "${submitScript}"
  bsub -W 24:00 -M 4096 -R "rusage[mem=4096]" -o ${logfile} -e ${logfile} < "${submitScript}"    
  rm "${submitScript}"

done < $1

exit 0

#!/bin/bash
# Converts pairwise IDR peak overlap output to narrowPeak

if [[ "$#" -lt 1 ]]
    then
    echo 'Converts pairwise IDR peak overlap output to narrowPeak' 1>&2
    echo "USAGE: $(basename $0) [idrOverlapFile] [oDir]" 1>&2
    echo '[idrOverlapFile]: overlap output file from pairwise IDR analysis' 1>&2
    echo '[oDir]: output directory' 1>&2
    exit 1
fi

# overlap file
ovFile=$1
if [[ ! -e ${ovFile} ]]
    then
    echo "ERROR:${ovFile} does not exist" 1>&2
    exit 1
fi

# Output directory
oDir=$(dirname ${ovFile})
[[ $# -gt 1 ]] && oDir=$2
if [[ ! -d ${oDir} ]]
    then
    mkdir ${oDir}
fi
oDir=$(echo ${oDir} | sed -r 's:/$::g')

# Create output file
oFile="${oDir}/$(basename ${ovFile} .gz).npk.gz"
if grep -q -E '\.gz$' ${ovFile}
    then
    zcat ${ovFile} | sed 1d | sed -r 's/"//g' | sort -k11g,11g | awk '{if ($3 <=$7) st=$3 ; else st=$7 ; if ($4 >= $8) sto=$4 ; else sto=$8 ; printf "%s\t%d\t%d\t%d\t%s\t.\t%s\t%f\t%f\n",$2,st,sto,NR,$5,$9,-log($10)/log(10),-log($11)/log(10)}' | gzip -c > ${oFile}
else
    sed 1d ${ovFile} | sed -r 's/"//g' | sort -k11g,11g | awk '{if ($3 <=$7) st=$3 ; else st=$7 ; if ($4 >= $8) sto=$4 ; else sto=$8 ; printf "%s\t%d\t%d\t%d\t%s\t.\t%s\t%f\t%f\n",$2,st,sto,NR,$5,$9,-log($10)/log(10),-log($11)/log(10)}' | gzip -c > ${oFile}
fi

#!/bin/bash
# $1: file containing arguments for batch-consistency-analysis.r
# File has 3 tab-delimited fields
# [peakFile1]\t[peakFile2]\t[pairOutFilePrefix]
# Rscript batch-consistency-analysis.r [peakfile1] [peakfile2] -1 [outfile.prefix] 0 F signal.value

if [[ "$#" -lt 1 ]]
then
	echo 'submit.idrpair.lsf.sh:'  1>&2
	echo 'Submits jobs to run pairwise IDR code'  1>&2
	echo 'USAGE:'  1>&2
	echo 'submit.idrpair.lsf.sh <idrPairArgFile>'  1>&2
	echo '<idrPairArgFile>: File has 3 tab-delimited fields' 1>&2
	echo '					[peakFile1]\t[peakFile2]\t[pairOutFilePrefix]' 1>&2
	exit 1
fi

rpath=`which Rscript`

JOBGROUPID="/idrPair${RANDOM}"

counter=1

while read inputline
do

  [[ $(( counter % 50 )) -eq 0 ]] && sleep 10s

  pf1="$(echo $inputline | awk '{print $1}')" # extract peak file 1
  pf2="$(echo $inputline | awk '{print $2}')" # extract peak file 2
  ofPrefix="$(echo $inputline | awk '{print $3}')" # extract outfile.prefix

  if [[ ! -e ${pf1} || ! -e ${pf2} || ! -d $( dirname ${ofPrefix} ) ]]
      then
      echo "Some file is not found for $( dirname ${ofPrefix} ): $(basename ${pf1}) $(basename ${pf2})"
      continue
  fi

  logfile="${ofPrefix}.log"
  randseed="${RANDOM}${RANDOM}"
  
  # If file exists then skip
  if [[ -e "${ofPrefix}-npeaks-aboveIDR.txt" ]]
      then
      continue
  fi

  # Create submit script
  submitScript="temp_${randseed}.sh"
  echo '#!/bin/bash' > ${submitScript}

  if echo ${pf1} | grep -q -E '\.gz$'
  then
    pf1gz=1
    pf1stub="$( basename ${pf1} | sed -r -e 's:\.gz$::g' )" # remove .gz and remove the directory name
    peakfile1="${TMP}/idr_${randseed}/${pf1stub}_${randseed}"
    echo "[[ ! -d ${TMP}/idr_${randseed} ]] && mkdir ${TMP}/idr_${randseed}" >> ${submitScript}
    echo "zcat ${pf1} > ${peakfile1}" >> ${submitScript}
  else
    pf1gz=0
    peakfile1="${pf1}"
  fi

  if echo ${pf2} | grep -q -E '\.gz$'
  then
    pf2gz=1
    pf2stub="$( basename ${pf2} | sed -r -e 's:\.gz$::g' )" # remove .gz and remove the directory name
    peakfile2="${TMP}/idr_${randseed}/${pf2stub}_${randseed}"
    echo "[[ ! -d ${TMP}/idr_${randseed} ]] && mkdir ${TMP}/idr_${randseed}" >> ${submitScript}
    echo "zcat ${pf2} > ${peakfile2}" >> ${submitScript}
  else
    pf2gz=0
    peakfile2="${pf2}"
  fi
  
  echo "${rpath} batch-consistency-analysis.r ${peakfile1} ${peakfile2} 500 ${ofPrefix} 0 F p.value" >> "${submitScript}"

  if [[ ${pf1gz} -eq 1 || ${pf2gz} -eq 1 ]]
      then
      echo "[[ -d ${TMP}/idr_${randseed} ]] && rm -rf ${TMP}/idr_${randseed}" >> ${submitScript}
  fi

  bsub -q research-rh6 -g ${JOBGROUPID} -W 48:00 -o ${logfile} -e ${logfile} < ${submitScript}
  (( counter = counter + 1 ))
  # bsub -g {JOBGROUPID} -W 48:00 -M 4096 -R "rusage[mem=4096]" -o ${logfile} -e ${logfile} < "${submitScript}"
  rm "${submitScript}"

done < $1

exit 0

\name{write.narrowpeak.binding}
\alias{write.narrowpeak.binding}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Write out determined binding peaks using narrowPeak format }
\description{
  Writes out determined binding positions into a narrowPeak file.
  The region will correspond to associated broad enrichment region, if
  such were added using add.broad.peak.regions method. Otherwise the
  region size will be determined using margin (which defaults to the
  window half size that was used to determine binding positions)
}
\usage{
write.narrowpeak.binding(results, filename,margin=results$whs)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{results}{ output of the \code{\link{find.binding.positions}} }
  \item{filename}{ file name }
  \item{margin}{ explicit value of the margin to be used if the borad
    region information is absent (defaults to peak detection window half-size}
}

\name{get.smoothed.enrichment.mle}
\alias{get.smoothed.enrichment.mle}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Calculate chromosome-wide profiles of smoothed enrichment estimate }
\description{
  Given signal and control tag positions, the method calculates log2
  signal to control enrichment esimates (maximum likelihood) for each
  chromosome, based on the smoothed tag density profile (see \link{get.smoothed.tag.density}).
}
\usage{
get.smoothed.enrichment.mle(signal.tags, control.tags, bandwidth = 150,tag.shift = 146/2, step = 50)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{signal.tags}{ signal chromosome tag coordinate vectors (e.g. output
    of \code{\link{select.informative.tags}} }
  \item{control.tags}{ control (input) tags }
  \item{pseudocount}{ pseudocount value to be added to tag density -
    defaults to 1 }
  other parameters (such as bandwidth, step.size and tag.shift) are
  passed to \link{get.smoothed.tag.density} - see appropriate reference
  for details.
}
\value{
  A list of elements corresponding to chromosomes, with each element
  being an $x/$y data.frame giving the position and associated
  log2 signal/control enrichment estimate. 
}
\seealso{ \code{\link{writewig}} }
\examples{
  # get smoothed enrichment estimate profile using 500bp bandwidth at
  # 50bp steps
  smoothed.M <- get.smoothed.enrichment.mle(chip.data,bandwidth=500,step=50);
  writewig(smoothed.M,"example.smoothedM.wig","Example smoothed log2 intensity ratio estimate");
}

\name{get.broad.enrichment.clusters}
\alias{get.broad.enrichment.clusters}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Determine broad clusters of enrichment }
\description{
  Scan chromosomes with a pre-defined window size, comparing scaled ChIP
  and input tag coutns to see if their ratio exceeds that expected from
  a Poisson process (normalized for dataset size).
}
\usage{
get.broad.enrichment.clusters(chip.tags, input.tags, window.size=1e3,z.thr=3,tag.shift=146/2)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{chip.tags}{ foreground tag vector list }
  \item{input.tags}{ background tag vector list }
  \item{window.size}{ window size to be used for tag counting }
  \item{z.thr}{ Z-score to be used as a significance threshold }
  \item{tag.shift}{ number of base pairs by which positive and negative
    tag coordinates should be shifted towards eachother (half of binding
  peak separation distance)}
}
\value{
  A list of elements corresponding to chromosomes, with each element
  being an $s/$e/$rv data.frame giving the starting, ending positions and the log2
  enrichment estimate for that region.
}
